unit bot_form;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, mshtml,
  Dialogs, StrUtils, StdCtrls, ExtCtrls, IdHashMessageDigest, idHash, ALEdit, JPEG, ClipBrd,
  ALQuickSortList, ALbutton;

type
  TBotForm = class(TForm)
    SS: TImage;
    b_current_hash_n: TButton;
    e_current_hash: TEdit;
    b_current_hash_s: TButton;
    b_recognize_hash: TButton;
    l_recognized_hash: TLabel;
    b_bet_everything: TButton;
    Label1: TLabel;
    Label2: TLabel;
    b_dummy_bet: TButton;
    Button1: TButton;
    Button2: TButton;
    procedure b_current_hash_nClick(Sender: TObject);
    procedure b_current_hash_sClick(Sender: TObject);
    procedure b_recognize_hashClick(Sender: TObject);
    procedure b_bet_everythingClick(Sender: TObject);
    procedure b_dummy_betClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    function PlaceBets:boolean;
    procedure PlaceDummyBet;
    procedure ClickAt(const x,y,lag,count:integer; const Button:TMouseButton=mbLeft);

    function RecognizeHash(const hash:string):string;
    function GetCurrentHash(const mode:string):string;
    function BmpToStr(Bitmap: TBitmap):widestring;
    procedure GetScreenShot(const x1,y1,x2,y2:integer);
    procedure Delay(const ms:integer);

    function BVLogout:boolean;
    function BVLogin:boolean;
    function BVLobby:boolean;
  public
    function CheckLimits(const mode:byte=1):boolean;
    function GlobalCheckLimits:boolean;
    function ReadNumber:string;
    function ReadStatus:string;
    function ReadMessage:string;
    procedure Bet(const name:string; const lag,units:integer);
    procedure StartCasino;
    procedure StartBot;
    procedure ResetBotSession;
    procedure ResetSystems;
    procedure Core;
    function MD5(const str:widestring):string;
  end;

  TRGBArray = ARRAY[0..32767] OF TRGBTriple; // pf24bit
  pRGBArray = ^TRGBArray;

const
  READYSTATE_UNINITIALIZED = 0; // Default initialisation state.
  READYSTATE_LOADING = 1; // Object is currently loading data.
  READYSTATE_LOADED = 2; // Object has been initialised.
  READYSTATE_INTERACTIVE = 3; // User can interact with the object but loading has not yet finished.
  READYSTATE_COMPLETE = 4; // All of the object's data has been loaded.

var
  BotForm: TBotForm;

  RealMoney:boolean=False;

  BOT_stage:integer=0;
  BOT_status:string='off';
  TABLE_status:string='off';
  CASINO_stage:integer=0;
  CASINO_status:string='off';

  CasinoHANDLE:hWND;

  SoftwareTYPE:string='';
  SoftwareDELAY:integer=0;
  SoftwareCODE:string='';

  a_coins:array of array of integer;

  a_ss_number:array of integer;
  a_ss_status:array of integer;
  a_ss_message:array of integer;

  a_hash:array of array of string;
  a_coords:array of array of string;

  a_names:array[0..15] of string = ('roulette','casino','player','ruleta','jugador','roulett',
                                    'speler','spiller','joueur','giocatore','imreoir','kasino',
                                    'kumarhane','spelare','oyuncu','kasyno'
                                    );



  implementation

uses main_form, config_form, sql_form, casino_form, table_form, chart_form, sys_config,
  sys_s9;

{$R *.dfm}


function GetFormByName(document: IHTMLDocument2; const formName: string): IHTMLFormElement;
begin
  try
  Result:=(document.Forms as IHTMLElementCollection).Item(formName,'') as IHTMLFormElement;
  except
    MainForm.RepError('Error code: B-101');
  end;
end;


procedure SetFieldValue(theForm: IHTMLFormElement; const fieldName: string; const newValue: string; const instance: integer=0);
var
  field: IHTMLElement;
  inputField: IHTMLInputElement;
  selectField: IHTMLSelectElement;
  textField: IHTMLTextAreaElement;
begin
  try
    if Assigned(theForm) then field := theForm.Item(fieldName,instance) as IHTMLElement;
    if Assigned(field) then begin
      if field.tagName = 'INPUT' then begin
        inputField := field as IHTMLInputElement;
        if (inputField.type_ <> 'radio') and (inputField.type_ <> 'checkbox') then
          inputField.value := newValue
        else
          inputField.checked := (newValue = 'checked');

      end else
      if field.tagName = 'SELECT' then begin
        selectField := field as IHTMLSelectElement;
        selectField.value := newValue;
      end else
      if field.tagName = 'TEXTAREA' then begin
        textField := field as IHTMLTextAreaElement;
        textField.value := newValue;
      end;
    end;
  except
    MainForm.RepError('Error code: B-001');
  end;
end;


function ClickLink(const s:string; Click:boolean=True):boolean;
var HTMLlinks:IHTMLElementCollection;
    HTMLanchor:IHTMLAnchorElement;
    i:integer;

    function IsThere(const s1,s2:string):boolean;
    var i:integer;
    begin
      Result:=True;
      try
        for i:=1 to Length(s2)-1 do begin
          if s2[Length(s2)-i]<>s1[Length(s1)-i] then begin
            Result:=False;
            Break;
          end;
        end;
      except
        MainForm.RepError('Error code: B-102');
      end;
    end;

begin
  Result:=False;
  try
    with CasinoForm do begin
      if Assigned(wb.Document) then begin
        HTMLlinks:=(wb.Document as IHTMLDocument2).links;
        for i:=0 to HTMLlinks.length-1 do begin
          HTMLanchor:=HTMLlinks.Item(i,0) as IHTMLAnchorElement;
          if IsThere(LowerCase(HTMLanchor.href),LowerCase(s)) then begin
            if Click then (HTMLlinks.Item(i,0) as IHTMLElement).click;
            Result:=True;
            Break;
          end else if i=HTMLlinks.length-1 then Result:=False;
        end;
      end;
    end;
  except
    MainForm.RepError('Error code: B-002');
  end;
end;


function ClickButton(const s:string; Click:Boolean=True):boolean;
var doc:IHTMLDocument3;
    el:OleVariant;
begin
  Result:=False;
  try
    with CasinoForm do begin
      if wb.Document.QueryInterface(IHTMLDocument3,doc) = S_OK then begin
        el:=doc.getElementByID(s);
        Result:=True;
        if Click then el.FireEvent('onclick', 0);
      end;
    end;
  except
    MainForm.RepError('Error code: B-003');
  end;
end;


function TBotForm.BVLobby:boolean;
var doc:IHTMLDocument3;
    el:OleVariant;
    lobby_loaded:boolean;
    game:string;
    i_timedout:integer;
    tStart,tPassed,tMAX:Cardinal;
begin
  tMAX:=120000;
  Result:=False;
  CASINO_status:='lobby_loading';
  i_timedout:=1;

  try
    repeat
      with CasinoForm do begin

        tStart:=GetTickCount;
        //loading loby
        if (CASINO_status<>'lobby_timedout') then begin
          SQLForm.UpdateStatus('0s # loading lobby...');
          if SoftwareCODE='bvnz' then game:='no-zero';
          if SoftwareCODE='bvsz' then game:='european';
          if ClickLink(game) then begin
            repeat
              sleep(50);
              tPassed:=GetTickCount-tStart;
              if tPassed>=tMAX then CASINO_Status:='lobby_timedout';
              SQLForm.UpdateStatus(''+IntToStr(Round(tPassed div 1000))+'s # loading lobby...');
            until (not wb.busy) or (CASINO_Status<>'lobby_loading');
          end else raise Exception.Create('[WEBSITE Error] Could NOT find game button.');
          if (CASINO_status='stop') then BREAK;
        end;
        //waiting for loby to load
        if (CASINO_status<>'lobby_timedout') then begin
          lobby_loaded:=False;
          repeat
            if wb.Document.QueryInterface(IHTMLDocument3,doc) = S_OK then begin
              el:=doc.getElementsByTagName('INPUT');
              if el.Length>0 then lobby_loaded:=True;
            end;
            sleep(50);
            tPassed:=GetTickCount-tStart;
            if tPassed>=tMAX then CASINO_Status:='lobby_timedout';
            SQLForm.UpdateStatus(''+IntToStr(Round(tPassed div 1000))+'s # loading lobby...');
          until (lobby_loaded) or (CASINO_Status<>'lobby_loading');
          if (CASINO_status='stop') then BREAK;
        end;


        if (CASINO_status<>'lobby_timedout') then begin
          if wb.Document.QueryInterface(IHTMLDocument3,doc) = S_OK then begin

            el:=doc.getElementsByTagName('INPUT');
            if el.Item(1,0).Value='Start' then begin
              tStart:=GetTickCount;
              //applying bankroll
              if ConfigForm.e_bankroll.Text<>'' then begin
                SQLForm.UpdateStatus('applying bankroll....');
                if StrToFloat(el.Item(0,0).Value)>=StrToFloat(ConfigForm.e_bankroll.Text) then
                  el.Item(0,0).Value:=ConfigForm.e_bankroll.Text;
              end;
              //starting casino
              SQLForm.UpdateStatus('0s # starting casino....');
              ClickButton(el.Item(1,0).id);
              repeat
                sleep(100);
                tPassed:=GetTickCount-tStart;
                if tPassed>=tMAX then CASINO_Status:='lobby_timedout';
                SQLForm.UpdateStatus(''+IntToStr(Round(tPassed div 1000))+'s # starting casino...');
              until (ReadNumber<>'') or (CASINO_Status<>'lobby_loading');
              if (CASINO_status='stop') then BREAK;
              Result:=True;

            end else if el.Item(1,0).Value='Continue' then begin
              tStart:=GetTickCount;
              tMAX:=240000;
              //reseting session
              SQLForm.UpdateStatus('0s # closing session...');
              ClickButton(el.Item(1,0).id);
              repeat
                sleep(100);
                tPassed:=GetTickCount-tStart;
                if tPassed>=tMAX then CASINO_Status:='lobby_timedout';
                SQLForm.UpdateStatus(''+IntToStr(Round(tPassed div 1000))+'s # closing session...');
              until (ReadNumber<>'') or (CASINO_Status<>'lobby_loading');
              if (CASINO_status='stop') then BREAK;

              if Assigned(TF) then TF.CloseCasino;
              repeat
                sleep(100);
                tPassed:=GetTickCount-tStart;
                if tPassed>=tMAX then CASINO_Status:='lobby_timedout';
                SQLForm.UpdateStatus(''+IntToStr(Round(tPassed div 1000))+'s # closing session...');
              until (not Assigned(TF)) or (CASINO_Status<>'lobby_loading') or (TABLE_status='off');
              if (CASINO_status='stop') then BREAK;
              Result:=False;
            end;
          end;
        end;

        if (CASINO_Status='lobby_timedout') then
          inc(i_timedout)
        else
          if Result then CASINO_Status:='lobby_done';

      end;
    until (i_timedout<4) or (CASINO_Status='lobby_done');
  except
    CASINO_Status:='error';
    MainForm.RepError('BOOM! Loading lobby failed! [B-004]');
  end;
end;


function TBotForm.BVLogout:boolean;
var tStart,tPassed,tMAX:Cardinal;
begin
  tMAX:=120000;
  Result:=False;
  try
    if ClickLink('/signout/') then begin
      tStart:=GetTickCount;
      CASINO_status:='logging_out';
      SqlForm.UpdateStatus('0s # logging out...');
      repeat
        sleep(50);
        tPassed:=GetTickCount-tStart;
        if tPassed>=tMAX then CASINO_Status:='timedout';
        SQLForm.UpdateStatus(''+IntToStr(Round(tPassed div 1000))+'s # logging out...');
      until (not CasinoForm.wb.Busy) or (CASINO_Status<>'logging_out');
    end;
  except
    CASINO_status:='error';
    MainForm.RepError('BOOM! Logging out failed! [B-005]');
  end;
end;


function TBotForm.BVLogin:boolean;
var failed:integer;
    tStart,tPassed,tMAX:Cardinal;
begin
  tMAX:=120000;
  Result:=False;
  try
    with CasinoForm do begin
      BVLogout;
      if CASINO_status<>'stop' then begin
        CASINO_status:='logging_in';
        failed:=0;
        repeat
          SetFieldValue(GetFormByName((wb.Document as IHTMLDocument2),'login'),'f_login',ConfigForm.e_un.Text);
          SetFieldValue(GetFormByName((wb.Document as IHTMLDocument2),'login'),'f_passwd',ConfigForm.e_up.Text);

          tStart:=GetTickCount;
          if ClickLink('/signin/') then begin
            SQLForm.UpdateStatus('0s # logging in...');
            repeat
              sleep(50);
              tPassed:=GetTickCount-tStart;
              if tPassed>=tMAX then CASINO_Status:='timedout';
              SQLForm.UpdateStatus(''+IntToStr(Round(tPassed div 1000))+'s # logging in...');
            until (not wb.Busy) or (CASINO_Status<>'logging_in');
          end;
          if (CASINO_status='stop') then BREAK;

          if not ClickLink('/signout/',False) then begin
            inc(failed);
            if failed=3 then CASINO_status:='logged_in_failed';
          end else begin
            Result:=True;
            CASINO_status:='logged_in_done';
          end;

        until (CASINO_status='logged_in_done') or (CASINO_status='logged_in_failed');
      end;
    end;
  except
    CASINO_status:='error';
    MainForm.RepError('BOOM! Logging in failed! [B-006]');
  end;
end;


procedure TBotForm.StartCasino;
var game:string;
    tStart,tPassed,tMAX:Cardinal;
begin
  tMAX:=120000;
  Screen.Cursor:=crHourGlass;
  ConfigForm.ControlsState(False);
  ConfigForm.GameModeState(False);
  try
    repeat
      if (SoftwareCODE='bvnz') or (SoftwareCODE='bvsz') then begin
        with CasinoForm do begin
          tStart:=GetTickCount;
          CASINO_Status:='starting_casino';
          SQLForm.UpdateStatus('0s # loading betvoyager.com....');
          if ConfigForm.cb_clear_cache.Checked then
            wb.ClearCache;
          wb.Navigate('http://betvoyager.com');
          repeat
            sleep(50);
            tPassed:=GetTickCount-tStart;
            if tPassed>=tMAX then CASINO_Status:='timedout';
            SQLForm.UpdateStatus(''+IntToStr(Round(tPassed div 1000))+'s # loading betvoyager.com....');
          until (not wb.Busy) or (CASINO_Status<>'starting_casino');
          if (CASINO_status='stop') then BREAK;

          if RealMoney then begin
            //REAL
            if BVLogin then begin
              tStart:=GetTickCount;
              CASINO_Status:='loading_games';
              SQLForm.UpdateStatus('0s # loading games...');
              if ClickLink('/games/') then begin
                repeat
                  sleep(50);
                  tPassed:=GetTickCount-tStart;
                  if tPassed>=tMAX then CASINO_Status:='timedout';
                  SQLForm.UpdateStatus(''+IntToStr(Round(tPassed div 1000))+'s # loading games...');
                until (not wb.Busy) or (CASINO_Status<>'loading_games');
                if CASINO_Status='loading_games' then CASINO_Status:='loading_games_done';
                if (CASINO_status='stop') then BREAK;
              end;

              if CASINO_Status='loading_games_done' then
                BVLobby;
            end;

          end else begin
            //DEMO
            BVLogout;

            if ClickLink('/demo/') then begin
              tStart:=GetTickCount;
              CASINO_Status:='loading_games';
              SQLForm.UpdateStatus('0s # loading games...');
              repeat
                sleep(50);
                tPassed:=GetTickCount-tStart;
                if tPassed>=tMAX then CASINO_Status:='timedout';
                SQLForm.UpdateStatus(''+IntToStr(Round(tPassed div 1000))+'s # loading games...');
              until (not wb.Busy) or (CASINO_Status<>'loading_games');
              if CASINO_Status='loading_games' then CASINO_Status:='loading_games_done';
              if (CASINO_status='stop') then BREAK;
            end;

            if CASINO_Status='loading_games_done' then begin
              if SoftwareCODE='bvnz' then game:='no-zero/';
              if SoftwareCODE='bvsz' then game:='european/';
              if ClickLink(game) then begin
                tStart:=GetTickCount;
                CASINO_Status:='loading_casino_table';
                SQLForm.UpdateStatus('0s # loading casino table...');
                repeat
                  sleep(50);
                  tPassed:=GetTickCount-tStart;
                  if tPassed>=tMAX then CASINO_Status:='timedout';
                  SQLForm.UpdateStatus(''+IntToStr(Round(tPassed div 1000))+'s # loading casino table...');
                until (not wb.Busy) or (CASINO_Status<>'loading_casino_table');
                if (CASINO_status='stop') then BREAK;

                if CASINO_Status='loading_casino_table' then begin
                  repeat
                    sleep(100);
                    tPassed:=GetTickCount-tStart;
                    if tPassed>=tMAX then CASINO_Status:='timedout';
                    SQLForm.UpdateStatus(''+IntToStr(Round(tPassed div 1000))+'s # loading casino table...');
                  until (ReadNumber<>'') or (CASINO_Status<>'loading_casino_table');
                  if (CASINO_status='stop') or (CASINO_status='timedout') then begin
                    if Assigned(TF) then TF.CloseCasino;
                    if (CASINO_status='stop') then BREAK;
                  end;
                  if (CASINO_Status='loading_casino_table') then CASINO_Status:='loading_casino_table_done';
                end;
              end;

            end;
          end;

        end;
      end;


      if (CASINO_status='lobby_done') or (CASINO_Status='loading_casino_table_done') then begin
        CASINO_status:='off';
        SQLForm.UpdateStatus('Casino table loaded.');
      end;

    until (CASINO_status='off');

    if (CASINO_status='stop') then begin
      ConfigForm.GameModeState(True);
      CASINO_status:='off';
      SQLForm.UpdateStatus('Casino loading stoped.');
    end;
  except
    CASINO_status:='error';
    MainForm.RepError('BOOM! Opening casino failed! [B-007]');
  end;

  with ConfigForm do begin
    ControlsState(True);
    ValidateManual;
    RealMoneyState(ConfigForm.cb_real.Checked);
  end;
  with MainForm do begin
    b_play.Enabled:=True;
    b_play.Font.Color:=clLime;
  end;
  Screen.Cursor:=crDefault;
end;


procedure TBotForm.ResetSystems;
var jpgImg: TJPEGImage;
    fn:string;
begin
  try
    BOT_status:='reseting';
    SQLForm.UpdateStatus('reseting session..');

    if ConfigForm.cb_save_stats.Checked then begin
      try
        DateTimeToString(fn, 'yyyy-mm-dd  hh-nn', NOW);
        fn:=ConfigForm.e_stats_path.text+'\'+fn;
        MainForm.ExportNumbers(fn+'.txt');
        with ChartForm do begin
          session_chart.CopyToClipboardBitmap;
          image_box.Picture.Bitmap.LoadFromClipboardFormat(cf_BitMap,ClipBoard.GetAsHandle(cf_Bitmap), 0);
          jpgImg := TJPEGImage.Create;
          jpgImg.Assign(image_box.Picture.Bitmap);
          jpgImg.SaveToFile(fn+'.jpg');
          jpgImg.Free;
        end;
      except
      end;
    end;

    SqlForm.SendStats;
    MainForm.SystemReset;
    bot_stage:=1;
  except
  end;
end;


procedure TBotForm.ResetBotSession;
var jpgImg: TJPEGImage;
    fn:string;
    tStart,tPassed,tMAX:Cardinal;
begin
  try
    tMAX:=120000;
    tStart:=GetTickCount;
    BOT_status:='reseting';
    SQLForm.UpdateStatus('0s # reseting session..');

    if ConfigForm.cb_save_stats.Checked then begin
      try
        DateTimeToString(fn, 'yyyy-mm-dd  hh-nn', NOW);
        fn:=ConfigForm.e_stats_path.text+'\'+fn;
        MainForm.ExportNumbers(fn+'.txt');
        with ChartForm do begin
          session_chart.CopyToClipboardBitmap;
          image_box.Picture.Bitmap.LoadFromClipboardFormat(cf_BitMap,ClipBoard.GetAsHandle(cf_Bitmap), 0);
          jpgImg := TJPEGImage.Create;
          jpgImg.Assign(image_box.Picture.Bitmap);
          jpgImg.SaveToFile(fn+'.jpg');
          jpgImg.Free;
        end;
      except
      end;
    end;

    if (TABLE_status='on') then begin
      TF.CloseCasino;
      repeat
        sleep(50);
        tPassed:=GetTickCount-tStart;
        if tPassed>=tMAX then BOT_Status:='timedout';
        SQLForm.UpdateStatus(''+IntToStr(Round(tPassed div 1000))+'s # reseting session...');
      until (TABLE_status='off') or (BOT_status<>'reseting');
    end;

  except
    MainForm.RepError('OMFG! Session reset is fcked again! [B-008]');
  end;
end;


procedure TBotForm.StartBot;
begin
  try
    ConfigForm.KeyboardState(False);
    ConfigForm.GameModeState(False);
    BOT_status:='on';
    repeat
      BotForm.Core;

      if (CheckLimits(0)) then begin
        if (configform.cb_session_relog.Checked) then begin
          ResetBotSession;
          StartCasino;
          if (TABLE_status='on') and (CASINO_status='off') then BOT_status:='on';
        end;
        if (configform.cb_session_reset.Checked) then begin
          ResetSystems;
          if (TABLE_status='on') and (CASINO_status='off') then BOT_status:='on';
        end;
      end;

      if (GlobalCheckLimits) then begin
        if (configform.cb_global_relog.Checked) then begin
          ResetBotSession;
          MainForm.GlobalReset;
          StartCasino;
          if (TABLE_status='on') and (CASINO_status='off') then BOT_status:='on';
        end;
        if (configform.cb_global_stop.Checked) then begin
          ResetBotSession;
          MainForm.GlobalReset;
        end;
      end;

      Application.ProcessMessages;
    until (BOT_status='off') or (BOT_status='stop');
    SQLForm.UpdateStatus('BOT stoped.');
  finally
    ConfigForm.KeyboardState(True);
  end;
end;


procedure TBotForm.Core;
var RN_TMP:String;
    RS_TMP:String;
begin
  try
    if (CASINO_status='off') and (TABLE_status='on') then begin

      if (BOT_stage=0) then begin
        if (ReadNumber='empty_number') then begin
          SqlForm.UpdateStatus('placing dummy bet...');
          PlaceDummyBet;
          SqlForm.UpdateStatus('spinning...');
          Bet('spin',softwareDELAY,1);
          BOT_stage:=1;
        end;
      end;

      while (BOT_status<>'stop') and (TABLE_status='on') and (CASINO_status='off') do begin

        if (BOT_stage=1) and (BOT_status<>'stop') then begin
          //BOT_status:='waiting_for_number';
          SqlForm.UpdateStatus('waiting for number...');
          repeat
            Delay(50);
            {if GetKeyState(VK_Escape) and 128=128 then BOT_status:='stop'
            else }RN_TMP:=ReadNumber;
          until ((RN_TMP<>'empty_number') and (RN_TMP<>'')) or (BOT_status='stop');
          if BOT_status<>'stop' then BOT_stage:=2;
        end;

        if (BOT_stage=2) and (BOT_status<>'stop') then begin
          //BOT_status:='calculating_bets';
          RN_TMP:=ReadNumber;
          if ((RN_TMP<>'empty_number') and (RN_TMP<>'')) then begin
            SqlForm.UpdateStatus('calculating bets...');
            MainForm.Bridge(StrToInt(RN_TMP));
            if (CheckLimits) or (GlobalCheckLimits) then BOT_status:='stop';
            BOT_stage:=3;
            if GetKeyState(VK_Escape) AND 128 = 128 then BOT_status:='stop';
          end else BOT_status:='error';
        end;

        if (BOT_stage=3) and (BOT_status<>'stop') then begin
          //BOT_status:='waiting_for_spin_button';
          SqlForm.UpdateStatus('waiting for spin button...');
          repeat
            if GetKeyState(VK_Escape) AND 128 = 128 then BOT_status:='stop'
            else Delay(50);
            if GetKeyState(VK_Escape) AND 128 = 128 then BOT_status:='stop'
            else RS_TMP:=ReadStatus;
          until (RS_TMP='spin') or (BOT_status='stop');
          if BOT_status<>'stop' then BOT_stage:=4;
        end;

        if (BOT_stage=4) and (BOT_status<>'stop') then begin
          //BOT_status:='placing_bets';
          RS_TMP:=ReadStatus;
          if (RS_TMP='spin') then begin
            SqlForm.UpdateStatus('placing bets...');
            if PlaceBets then BOT_stage:=5;
          end else BOT_status:='error';
        end;

        if (BOT_stage=5) and (BOT_status<>'stop') then begin
          //BOT_status:='spinning';
          SqlForm.UpdateStatus('spinning...');
          if SoftwareTYPE='RNG' then Bet('spin',SoftwareDELAY,1);
          repeat
            Delay(50);
            {if GetKeyState(VK_Escape) AND 128 = 128 then BOT_status:='stop'
            else }RS_TMP:=ReadStatus;
          until (RS_TMP='wait') or (BOT_status='stop');
          if BOT_status<>'stop' then BOT_stage:=6;
        end;

        if (BOT_stage=6) and (BOT_status<>'stop') then begin
          //BOT_status:='waiting_for_empty_number';
          SqlForm.UpdateStatus('spinning...');
          repeat
            Delay(50);
            {if GetKeyState(VK_Escape) AND 128 = 128 then BOT_status:='stop'
            else }RN_TMP:=ReadNumber;
          until (RN_TMP='empty_number') or (BOT_status='stop');
          if BOT_status<>'stop' then BOT_stage:=1;
        end;

      end;

      if BOT_status='stop' then begin
        BOT_status:='off';
        SqlForm.UpdateStatus('BOT stoped.');
      end;
      if BOT_status='error' then begin
        BOT_status:='off';
        SqlForm.UpdateStatus('BOT ERROR.');
      end;

    end;
  except
    MainForm.RepError('Error code: B-010');
  end;
end;


function TBotForm.CheckLimits(const mode:byte=1):boolean;
var E_TMP:Integer;
begin
  Result:=False;
  try
    with ConfigForm do begin

      if cb_profit_limit.Checked then begin
        E_TMP:=Trunc(StrToInt(e_profit_limit.Text));
        if E_TMP<=SYSTEM_Balance then begin
          Result:=True;
          if mode=1 then dummer_lw.Add('W');
        end;
      end;

      if cb_loss_limit.Checked then begin
        E_TMP:=Trunc(StrToInt(e_loss_limit.Text));
        if E_TMP>=SYSTEM_Balance-max_balance then begin
          Result:=True;
          if mode=1 then dummer_lw.Add('L');
        end;
      end;

      if mode=1 then MainForm.Dummer;
    end;
  except
    MainForm.RepError('Error code: B-011');
  end;
end;

function TBotForm.GlobalCheckLimits:boolean;
var E_TMP:Integer;
begin
  Result:=False;
  try
    with ConfigForm do begin

      if cb_global_profit_limit.Checked then begin
        E_TMP:=Trunc(StrToInt(e_global_profit_limit.Text));
        if E_TMP<=GLOBAL_Balance then Result:=True;
      end;

      if cb_global_loss_limit.Checked then begin
        E_TMP:=Trunc(StrToInt(e_global_loss_limit.Text));
        if E_TMP>=GLOBAL_Balance-GLOBAL_max_balance then Result:=True;
      end;

    end;
  except
    MainForm.RepError('Error code: B-111');
  end;
end;

function TBotForm.PlaceBets:boolean;
var i,j,k,t_count:integer;
    to_bet,tmp_sl_bets,tmp_sl_units:TStringList;
    to_bet_units:TALIntegerList;
    add:boolean;
begin
Result:=False;

try

if not MainForm.cb_dummy.Checked then begin
  REAL_Enabled:=True;

      //REAL STATS
    with ConfigForm do begin
      if (ConfigForm.e_manual.Text='') or (ConfigForm.e_manual.Text='0') then begin
        j:=1;
        for i:=1 to 9 do
          if (FindComponent('cb_coin'+IntToStr(i) ) as TALRadioButton).Checked=True then j:=i;
        REAL_units:=StrToFloat((FindComponent('e_coin'+IntToStr(j) ) as TALEdit).Text);
      end else begin
        REAL_units:=StrToFloat(e_manual.Text);
      end;
    end;
    //^^

  to_bet:=TStringList.Create;
  to_bet_units:=TALIntegerList.Create;
  tmp_sl_bets:=TStringList.Create;
  tmp_sl_units:=TStringList.Create;

  //s9
  if SysConfig.cb_s9.Checked then
    if s9_to_bet.Count>0 then begin
      for i:=0 to s9_to_bet.Count-1 do begin
        Add:=True;
        if to_bet.Count>0 then
          for k:=0 to to_bet.Count-1 do
            if to_bet[k]=s9_to_bet[i] then begin
              to_bet_units[k]:=to_bet_units[k]+s9_units[s9_units.Count-1];
              Add:=False;
              Break;
            end;

        if Add then begin
          to_bet.Add(s9_to_bet[i]);
          to_bet_units.Add(s9_units[s9_units.Count-1]);
        end;
      end;
    end;


  tmp_sl_bets.Free;
  tmp_sl_units.Free;

  if to_bet.Count>0 then begin

    dummy_to_bet:='0';
    for i:=0 to to_bet.Count-1 do begin

      if GetKeyState(VK_Escape) and 128=128 then BOT_status:='stop';
      if BOT_Status='stop' then Break;

      t_count:=to_bet_units[i];

      with ConfigForm do begin
        if e_manual.Color=clGreen then begin
          for j:=1 to 9 do
            if (FindComponent('e_coin'+IntToStr(j)) as TALEdit).Color=clGreen then begin
              t_count:=Trunc(t_count*(StrToFloat(e_manual.Text)/StrToFloat((FindComponent('e_coin'+IntToStr(j)) as TALEdit).Text)));
              Break;
            end;
        end;
      end;

      for j:=high(a_coins) downto low(a_coins) do begin
        if (a_coins[j,0]<>0) and (t_count<>0) then
          if t_count/a_coins[j,0]>=1 then
            Bet('coin'+IntToStr(a_coins[j,1]),SoftwareDELAY,1);

        while (a_coins[j,0]<>0) and (t_count<>0) do begin
          if t_count/a_coins[j,0]>=1 then begin
            Bet(to_bet[i],SoftwareDELAY,1);
            t_count:=t_count-a_coins[j,0];
          end else Break;
        end;

      end;

    end;

  end else begin
    PlaceDummyBet;
  end;

  if BOT_status='stop' then Result:=False else Result:=True;
  to_bet.Free;
  to_bet_units.Free;

end else begin
  Result:=True;
  REAL_Enabled:=False;
  PlaceDummyBet;
end;
  except
    MainForm.RepError('Error code: B-012');
  end;
end;


procedure TBotForm.PlaceDummyBet;
var i,j,ver,t_count:byte;
    to_bet:TStringList;
    to_bet_units:TALIntegerList;
begin
  try
    to_bet:=TStringList.Create;
    to_bet_units:=TALIntegerList.Create;
      //REAL STATS
    with ConfigForm do begin
      if (ConfigForm.e_manual.Text='') or (ConfigForm.e_manual.Text='0') then begin
        j:=1;
        for i:=1 to 9 do
          if (FindComponent('cb_coin'+IntToStr(i) ) as TALRadioButton).Checked=True then j:=i;
        REAL_units:=StrToFloat((FindComponent('e_coin'+IntToStr(j) ) as TALEdit).Text);
      end else begin
        REAL_units:=StrToFloat(e_manual.Text);
      end;
    end;
    //^^
    
    if SoftwareCODE='bvnz' then begin
      ver:=1+Random(2);

      case ver of
      1:begin
          to_bet.Add('DS1/2');
          to_bet_units.Add(1);
          to_bet.Add('DS3/4');
          to_bet_units.Add(1);
          to_bet.Add('D2');
          to_bet_units.Add(2);
          to_bet.Add('D3');
          to_bet_units.Add(2);
        end;
      2:begin
          to_bet.Add('D1');
          to_bet_units.Add(2);
          to_bet.Add('DS5/6');
          to_bet_units.Add(1);
          to_bet.Add('DS7/8');
          to_bet_units.Add(1);
          to_bet.Add('D3');
          to_bet_units.Add(2);
        end;
      3:begin
          to_bet.Add('D1');
          to_bet_units.Add(2);
          to_bet.Add('D2');
          to_bet_units.Add(2);
          to_bet.Add('DS9/10');
          to_bet_units.Add(1);
          to_bet.Add('DS11/12');
          to_bet_units.Add(1);
        end;
      end;
    end;

    if SoftwareCODE='bvsz' then begin
      if numbers_list.Count-1>1 then begin
        if DUMMY_l=2 then begin
          if DUMMY_mode=0 then DUMMY_mode:=1 else DUMMY_mode:=0;
          DUMMY_l:=0;
        end;

        if ODD(numbers_list[numbers_list.Count-2]) then begin
          if DUMMY_mode=0 then dummy_to_bet:='O' else dummy_to_bet:='E';
        end else begin
          if DUMMY_mode=0 then dummy_to_bet:='E' else dummy_to_bet:='O';
        end;
      end else begin
        dummy_to_bet:='O'
      end;

      to_bet.Add(dummy_to_bet);
      to_bet_units.Add(1);
    end;

  //BetMechanism
  if to_bet.Count>0 then begin
    for i:=0 to to_bet.Count-1 do begin

      if GetKeyState(VK_Escape) and 128=128 then BOT_status:='stop';
      //if BOT_Status='stop' then Break;

      t_count:=to_bet_units[i];

      with ConfigForm do begin
        if e_manual.Color=clGreen then begin
          for j:=1 to 9 do
            if (FindComponent('e_coin'+IntToStr(j)) as TALEdit).Color=clGreen then begin
              t_count:=Trunc(t_count*(StrToFloat(e_manual.Text)/StrToFloat((FindComponent('e_coin'+IntToStr(j)) as TALEdit).Text)));
              Break;
            end;
        end;
      end;

      for j:=high(a_coins) downto low(a_coins) do begin
        if (a_coins[j,0]<>0) and (t_count<>0) then
          if t_count/a_coins[j,0]>=1 then
            Bet('coin'+IntToStr(a_coins[j,1]),SoftwareDELAY,1);

        while (a_coins[j,0]<>0) and (t_count<>0) do begin
          if t_count/a_coins[j,0]>=1 then begin
            Bet(to_bet[i],SoftwareDELAY,1);
            t_count:=t_count-a_coins[j,0];
          end else Break;
        end;

      end;
    end;
  end;

  to_bet.Free;
  to_bet_units.Free;
  except
    MainForm.RepError('Error code: B-013');
  end;
end;


function ForceForegroundWindow(hwnd: THandle): Boolean;
const
   SPI_GETFOREGROUNDLOCKTIMEOUT = $2000;
   SPI_SETFOREGROUNDLOCKTIMEOUT = $2001;
var
   ForegroundThreadID: DWORD;
   ThisThreadID: DWORD;
   timeout: DWORD;
begin
   if IsIconic(hwnd) then ShowWindow(hwnd, SW_RESTORE);

   if GetForegroundWindow = hwnd then Result := True
   else
   begin
     // Windows 98/2000 doesn't want to foreground a window when some other
     // window has keyboard focus

     if ((Win32Platform = VER_PLATFORM_WIN32_NT) and (Win32MajorVersion > 4)) or
       ((Win32Platform = VER_PLATFORM_WIN32_WINDOWS) and
       ((Win32MajorVersion > 4) or ((Win32MajorVersion = 4) and
       (Win32MinorVersion > 0)))) then
     begin
       // Code from Karl E. Peterson, www.mvps.org/vb/sample.htm
       // Converted to Delphi by Ray Lischner
       // Published in The Delphi Magazine 55, page 16

       Result := False;
       ForegroundThreadID := GetWindowThreadProcessID(GetForegroundWindow, nil);
       ThisThreadID := GetWindowThreadPRocessId(hwnd, nil);
       if AttachThreadInput(ThisThreadID, ForegroundThreadID, True) then
       begin
         BringWindowToTop(hwnd); // IE 5.5 related hack
         SetForegroundWindow(hwnd);
         AttachThreadInput(ThisThreadID, ForegroundThreadID, False);
         Result := (GetForegroundWindow = hwnd);
       end;
       if not Result then
       begin
         // Code by Daniel P. Stasinski
         SystemParametersInfo(SPI_GETFOREGROUNDLOCKTIMEOUT, 0, @timeout, 0);
         SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, 0, TObject(0),
           SPIF_SENDCHANGE);
         BringWindowToTop(hwnd); // IE 5.5 related hack
         SetForegroundWindow(hWnd);
         SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, 0, TObject(timeout), SPIF_SENDCHANGE);
       end;
     end
     else
     begin
       BringWindowToTop(hwnd); // IE 5.5 related hack
       SetForegroundWindow(hwnd);
     end;

     Result := (GetForegroundWindow = hwnd);
   end;
end; { ForceForegroundWindow }


procedure TBotForm.Bet(const name:string; const lag,units:integer);
var i,x,y:integer;
begin
  try
    ForceForegroundWindow(TF.Handle);
    x:=0; y:=0;
    for i:=0 to High(a_coords) do
      if name=a_coords[i,0] then begin
        x:=strtoint(a_coords[i,1]);
        y:=strtoint(a_coords[i,2]);
        Break;
      end;

    if (x<>0) and (y<>0) then ClickAt(x,y,lag,units);
  except
    MainForm.RepError('Error code: B-014');
  end;
end;


procedure TBotForm.ClickAt(const x,y,lag,count:integer; const Button:TMouseButton=mbLeft);
var pt: TPoint;
    i:integer;
begin
try
  for i:=1 to count do begin
    pt.x:=x;
    pt.y:=y;
    Windows.ClientToScreen(CasinoHANDLE, pt);
    SetCursorPos(pt.x,pt.y);

    Mouse_Event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
    Mouse_Event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);

    Delay(lag);
  end;
  except
    MainForm.RepError('Error code: B-015');
  end;
end;


function TBotForm.ReadNumber:string;
begin
  Result:='';
  try
    Result:=RecognizeHash(GetCurrentHash('number'));
  except
    MainForm.RepError('Error code: B-103');
  end;
end;


function TBotForm.ReadMessage:string;
begin
  Result:='';
  try
    Result:=RecognizeHash(GetCurrentHash('message'));
  except
    MainForm.RepError('Error code: B-104');
  end;
end;


function TBotForm.ReadStatus:string;
begin
  Result:='';
  try
    Result:=RecognizeHash(GetCurrentHash('status'));
  except
    MainForm.RepError('Error code: B-105');
  end;
end;


function TBotForm.RecognizeHash(const hash:string):string;
var i:integer;
begin
  Result:='';
  try
    for i:=low(a_hash) to high(a_hash) do
      if a_hash[i,1]=hash then begin
        Result:=a_hash[i,0];
        Break;
      end;
  except
    MainForm.RepError('Error code: B-016');
  end;
end;


procedure TBotForm.Delay(const ms:integer);
//var i:integer;
begin
{  for i:=0 to ms do begin
    Application.ProcessMessages;
    sleep(1);
  end;
}
  Sleep(ms);
  Application.ProcessMessages;
end;


function TBotForm.GetCurrentHash(const mode:string):string;
begin
  try
    if mode='number' then
      GetScreenShot(a_ss_number[0],a_ss_number[1],a_ss_number[2],a_ss_number[3])
    else if mode='status' then
      GetScreenShot(a_ss_status[0],a_ss_status[1],a_ss_status[2],a_ss_status[3])
    else if mode='message' then
      GetScreenShot(a_ss_message[0],a_ss_message[1],a_ss_message[2],a_ss_message[3]);

    Result:=MD5(BmpToStr(SS.Picture.Bitmap));
  except
    MainForm.RepError('Error code: B-017');
  end;
end;


function TBotForm.MD5(const str:widestring):string;
var
   idmd5 : TIdHashMessageDigest5;
begin
  Result:='';
  try
 if str<>'' then begin
    idmd5 := TIdHashMessageDigest5.Create;
    try
      result := idmd5.AsHex(idmd5.HashValue(str)) ;
    finally
      idmd5.Free;
    end;
  end else Result:='';
  except
    MainForm.RepError('Error code: B-106');
  end;
end;


function TBotForm.BmpToStr(Bitmap: TBitmap):widestring;
var ScanlinePtr : PByte;
    ScanlineIncrement : integer;
    LastScanline : PByte;
    x : integer;
    Line: pRGBArray;
    n, xx : integer;
    r, g, b : string;
    s : string;
    Strs: TStringList;
    i:integer;
begin
  Strs:=TStringList.Create;
  try
    x := Bitmap.Width;
    s := StringOfChar(#32, (x *6)+(x -1));

    ScanlinePtr := Bitmap.Scanline[0];
    ScanlineIncrement := integer(Bitmap.Scanline[1]) - integer(ScanlinePtr);
    LastScanline := ScanlinePtr;
    Inc(LastScanLine, ScanlineIncrement  * Bitmap.Height);

    repeat
      Line := pRGBArray(ScanLinePtr);

      xx := 1;
      if x>0 then
      for n := 0 to x -1 do begin
        r := IntToHex(Line[n].rgbtRed, 2);
        g := IntToHex(Line[n].rgbtGreen, 2);
        b := IntToHex(Line[n].rgbtBlue, 2);

        MoveMemory(@s[xx], @r[1], 2);
        MoveMemory(@s[xx +2], @g[1], 2);
        MoveMemory(@s[xx +4], @b[1], 2);

        Inc(xx, 7);
      end;
      Strs.Add(s);

      Inc(ScanlinePtr, ScanlineIncrement);
    until (ScanlinePtr = LastScanline);

    if Strs.Count>0 then begin
      for i:=0 to Strs.Count-1 do
        if i=0 then Result:=Strs[i] else Result:=Result+' '+Strs[i];
    end else Result:='';

  except
    Result:='';
//    MainForm.RepError('Error code: B-018');
  end;
  Strs.Free;
end;


function InvertBitmap(MyBitmap: TBitmap): TBitmap;
var
   x, y: Integer;
   ByteArray: PByteArray;
begin
   MyBitmap.PixelFormat := pf24Bit;
   for y := 0 to MyBitmap.Height - 1 do
   begin
     ByteArray := MyBitmap.ScanLine[y];
     for x := 0 to MyBitmap.Width * 3 - 1 do
     begin
       ByteArray[x] := 255 - ByteArray[x];
     end;
   end;
   Result := MyBitmap;
end;


procedure TBotForm.GetScreenShot(const x1,y1,x2,y2:integer);
var
  DC: HDC;
  Bmp: TBitmap;
  Width,Height: Integer;
begin
  try
    if CasinoHANDLE<>0 then begin
      DC := GetDC(CasinoHANDLE);

      Width:=x2-x1;
      Height:=y2-y1;

      Bmp:=TBitmap.Create;
      Bmp.Height:=Height;
      Bmp.Width:=Width;

      BitBlt(Bmp.Canvas.Handle, 0, 0, Width, Height, DC, x1, y1, SRCCOPY);

      if SoftwareCODE='viglive' then Bmp:=InvertBitmap(Bmp);

      SS.Picture.Bitmap:=Bmp;

      Bmp.Free;
      ReleaseDC(CasinoHANDLE, DC);
    end;
  except
    MainForm.RepError('Error code: B-019');
  end;
end;


procedure TBotForm.b_current_hash_nClick(Sender: TObject);
begin
  e_current_hash.Text:=GetCurrentHash('number');
end;


procedure TBotForm.b_current_hash_sClick(Sender: TObject);
begin
  e_current_hash.Text:=GetCurrentHash('status');
end;


procedure TBotForm.b_recognize_hashClick(Sender: TObject);
begin
  l_recognized_hash.Caption:='Hash Recognized as: '+RecognizeHash(e_current_hash.Text);
end;


procedure TBotForm.b_bet_everythingClick(Sender: TObject);
var i:integer;
begin
  Bet('coin1',100,1);

  for i:=1 to 36 do Bet(IntToStr(i),100,1);
  for i:=1 to 12 do Bet('S'+IntToStr(i),100,1);
  {
  Bet('DS1/2',100,1);
  Bet('DS3/4',100,1);
  Bet('DS5/6',100,1);
  Bet('DS7/8',100,1);
  Bet('DS9/10',100,1);
  Bet('DS11/12',100,1);
  for i:=1 to 12 do Bet('Q'+IntToStr(i),100,1);
  }
  for i:=1 to 3 do Bet('D'+IntToStr(i),100,1);
  for i:=1 to 3 do Bet('C'+IntToStr(i),100,1);
  Bet('E',100,1);
  Bet('O',100,1);
  Bet('H',100,1);
  Bet('L',100,1);
  Bet('R',100,1);
  Bet('B',100,1);
end;


procedure TBotForm.b_dummy_betClick(Sender: TObject);
begin
  PlaceDummyBet;
end;


procedure TBotForm.Button1Click(Sender: TObject);
begin
  PlaceBets;
end;

procedure TBotForm.Button2Click(Sender: TObject);
begin
  e_current_hash.Text:=GetCurrentHash('message');
end;

end.
