unit chart_form;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Registry, TeEngine, Series, TeeProcs, Chart, ALListBox,
  StdCtrls, ExtCtrls, Buttons, ALPanel, Menus, JPEG, ClipBrd, ALButton, ComObj;

type
  TChartForm = class(TForm)
    box_chartform: TALPanel;
    bClose: TSpeedButton;
    b_more: TSpeedButton;
    b_play: TSpeedButton;
    b_stop: TSpeedButton;
    b_sbs: TSpeedButton;
    s_header: TShape;
    l_header: TLabel;
    list_spins: TALListBox;
    box_chart: TALPanel;
    ALPanel1: TALPanel;
    session_chart: TChart;
    Series1: TLineSeries;
    menu_form: TPopupMenu;
    m0_import_numbers: TMenuItem;
    m0_export_numbers: TMenuItem;
    session_menu: TPopupMenu;
    m_s_save_graph: TMenuItem;
    image_box: TImage;
    cb_global_chart: TALRadioButton;
    cb_session_chart: TALRadioButton;
    global_chart: TChart;
    LineSeries1: TLineSeries;
    global_menu: TPopupMenu;
    m_g_save_graph: TMenuItem;
    EXPORTtoexcel1: TMenuItem;
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure b_playClick(Sender: TObject);
    procedure b_stopClick(Sender: TObject);
    procedure bCloseClick(Sender: TObject);
    procedure b_moreClick(Sender: TObject);
    procedure b_sbsClick(Sender: TObject);
    procedure m0_import_numbersClick(Sender: TObject);
    procedure m0_export_numbersClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure m_s_save_graphClick(Sender: TObject);
    procedure m_g_save_graphClick(Sender: TObject);
    procedure cb_session_chartClick(Sender: TObject);
    procedure cb_global_chartClick(Sender: TObject);
    procedure EXPORTtoexcel1Click(Sender: TObject);
  protected
    procedure CreateParams(var Params: TCreateParams);  override;
  private
    procedure SaveGraph(const m:byte=0);
    procedure ImportNumbers;
    procedure ExportNumbers;
    procedure FResize;
    procedure LoadSettings;
    procedure SaveSettings;
    procedure WMNCHitTest(var Msg: TWMNCHitTest) ; message WM_NCHitTest;
    function CheckLimits:boolean;
    procedure ChangeChart;
    procedure ExportToExcel;
  public
    procedure G_Play(one_step:boolean=False);
    procedure G_Stop;
    procedure G_Pause;
    procedure G_SbS;
    procedure G_Reset;
  end;

var
  ChartForm: TChartForm;
  G_Paused:Boolean=False;
  STOP:boolean=False;
  SNumber:integer=0;
  Part:integer=0;
  ML:integer=0;
  MP:integer=0;
  ML_balance:integer=0;
  MP_balance:integer=0;

  Excel: Variant;

implementation

uses main_form, bot_form, config_form, debug_form, sys_s9;

{$R *.dfm}


procedure TChartForm.ExportToExcel;
var i:integer;
    range:string;
//    iL,iW:integer;
begin
  Excel:=CreateOleObject('Excel.Application');
  Excel.Visible:=True;
  Excel.Workbooks.Add(-4167);

  if numbers_list.Count>0 then begin

 //   iW:=0; iL:=0;

    for i:=1 to 8 do
      Excel.ActiveSheet.Cells[1,i].Font.Bold:=True;

    Excel.ActiveSheet.Cells[1,1]:='NUMBER:';
    Excel.ActiveSheet.Cells[1,2]:='STREET:';
    Excel.ActiveSheet.Cells[1,3]:='L/W:';
    Excel.ActiveSheet.Cells[1,4]:='PROFIT:';
    Excel.ActiveSheet.Cells[1,5]:='STREETS:';
    Excel.ActiveSheet.Cells[1,6]:='STREETS TO BET:';
    Excel.ActiveSheet.Cells[1,7]:='UNITS:';

    for i:=0 to s9_lw.Count-1 do begin
      range:='A'+IntToStr(i+2)+':D'+IntToStr(i+2);

      Excel.ActiveSheet.Cells[i+2,1]:=IntToStr(numbers_list[i]);
      Excel.ActiveSheet.Cells[i+2,2]:=s9_streets[i];
      Excel.ActiveSheet.Cells[i+2,3]:=s9_lw[i];
      Excel.ActiveSheet.Cells[i+2,4]:=IntToStr(s9_profit[i]);
      Excel.ActiveSheet.Cells[i+2,5]:=''''+s9_s_history[i]+' '+s9_s_count_history[i];
      Excel.ActiveSheet.Cells[i+2,6]:=''''+s9_s_to_bet_history[i];
      Excel.ActiveSheet.Cells[i+2,7]:=s9_units[i];
      if s9_lw[i]='W' then begin
        Excel.ActiveSheet.Range[range].Font.Color:=clGreen;
//        inc(iW);
      end else if s9_lw[i]='L' then begin
        Excel.ActiveSheet.Range[range].Font.Color:=clRed;
//        inc(iL);
      end;
    end;
    Excel.ActiveSheet.Columns[5].ColumnWidth:=45;
    Excel.ActiveSheet.Columns[6].ColumnWidth:=17;
    Excel.ActiveSheet.Cells[s9_lw.Count+2,3].Font.Bold:=True;
    Excel.ActiveSheet.Cells[s9_lw.Count+2,4].Font.Bold:=True;
    Excel.ActiveSheet.Cells[s9_lw.Count+2,3]:='BALANCE:';
    Excel.ActiveSheet.Cells[s9_lw.Count+2,4]:='=SUM(D2:D'+IntToStr(s9_lw.Count+1)+')';

{
    Excel.ActiveSheet.Cells[1,6]:='W: '+IntToStr(iW);
    Excel.ActiveSheet.Cells[2,6]:='L: '+IntToStr(iL);
    Excel.ActiveSheet.Cells[1,7]:='vW: '+IntToStr(ivW);
    Excel.ActiveSheet.Cells[2,7]:='vL: '+IntToStr(ivL);
}
  end;

end;


procedure TChartForm.ChangeChart;
begin
  if cb_session_chart.Checked then begin
    global_chart.Visible:=False;
    session_chart.Visible:=True;
    l_header.Caption:='SESSION CHART';
  end else begin
    global_chart.Visible:=True;
    session_chart.Visible:=False;
    l_header.Caption:='GLOBAL CHART';
  end;
end;


function TChartForm.CheckLimits:boolean;
var E_TMP:Integer;
begin
  Result:=False;
  try
    with ConfigForm do begin

      if cb_profit_limit.Checked then begin
        E_TMP:=Trunc(StrToInt(e_profit_limit.Text));
        if E_TMP<=SYSTEM_Balance then begin
          inc(MP);
          MP_balance:=MP_balance+SYSTEM_Balance;
          Result:=True;
          dummer_lw.Add('W');
        end;
      end;

      if cb_loss_limit.Checked then begin
        E_TMP:=Trunc(StrToInt(e_loss_limit.Text));
        if E_TMP>=SYSTEM_Balance-max_balance then begin
          inc(ML);
          ML_Balance:=ML_Balance+(SYSTEM_Balance);
          Result:=True;
          dummer_lw.Add('L');
        end;
      end;

    end;

    MainForm.Dummer;

    DebugForm.label1.Caption:=' MP: '+IntToStr(MP)+'('+IntToStr(MP_Balance)+')  #  ML: '+IntToStr(ML)+'('+IntToStr(ML_Balance)+') ';
  except
    MainForm.RepError('Error code: B-011');
  end;
end;


procedure TChartForm.FResize;
begin
  try
  box_ChartForm.Width:=ChartForm.Width;
  box_ChartForm.Height:=ChartForm.Height;

  bClose.Top:=box_ChartForm.Height-bClose.Height-15;
  bClose.Left:=box_ChartForm.Width-bClose.Width-15;

  b_more.Top:=bClose.Top-b_more.Height-5;
  b_more.Left:=bClose.Left;

  b_stop.Top:=Trunc((box_ChartForm.Height/2)-(b_stop.Height/2));
  b_stop.Left:=bClose.Left;

  b_play.Top:=b_stop.Top-b_play.Height;
  b_play.Left:=bClose.Left;

  b_sbs.Top:=b_stop.Top+b_stop.Height;;
  b_sbs.Left:=bClose.Left;

  list_spins.Top:=16;
  list_spins.Left:=bClose.Left-list_spins.Width-10;
  list_spins.Height:=box_ChartForm.Height-list_spins.Top-20;

  box_chart.Width:=list_spins.Left-10;
  box_chart.Height:=list_spins.Height;
  except
    MainForm.RepError('Error code: CHF-001');
  end;
end;


procedure TChartForm.CreateParams(var Params: TCreateParams) ;
 begin
   BorderStyle := bsNone;

   inherited;

   Params.ExStyle := Params.ExStyle or WS_EX_STATICEDGE;
   Params.Style := Params.Style or WS_SIZEBOX;
 end;


procedure TChartForm.G_SbS;
begin
  G_Play(True);
end;


procedure TChartForm.G_Stop;
begin
  try
  G_Paused:=False;
  SNumber:=0;
  
  b_play.Caption:='4';
  b_play.Font.Color:=clGreen;

  STOP:=True;
  except
    MainForm.RepError('Error code: CHF-002');
  end;
end;


procedure TChartForm.G_Pause;
begin
  try
  G_Paused:=True;

  b_play.Caption:='4';
  b_play.Font.Color:=clGreen;

  STOP:=True;
  except
    MainForm.RepError('Error code: CHF-003');
  end;
end;


procedure TChartForm.G_Reset;
var jpgImg: TJPEGImage;
    fn:string;
begin
  inc(part);
    if ConfigForm.cb_save_stats.Checked then begin
      try
        DateTimeToString(fn, 'yyyy-mm-dd  hh-nn', NOW);
        fn:=ConfigForm.e_stats_path.text+'\p'+IntToStr(part)+'  '+fn;
        MainForm.ExportNumbers(fn+'.txt');
        with ChartForm do begin
          session_chart.CopyToClipboardBitmap;
          image_box.Picture.Bitmap.LoadFromClipboardFormat(cf_BitMap,ClipBoard.GetAsHandle(cf_Bitmap), 0);
          jpgImg := TJPEGImage.Create;
          jpgImg.Assign(image_box.Picture.Bitmap);
          jpgImg.SaveToFile(fn+'.jpg');
          jpgImg.Free;
        end;
      except
      end;
    end;

    MainForm.SystemReset;
end;


procedure TChartForm.G_Play(one_step:boolean=False);
begin
  try
  if (list_spins.Items.Count<1) then
    MessageDlg('Please import numbers.', mtInformation, [mbOk], 0)
  else begin
    if not G_Paused then begin
      SNumber:=0;

      Part:=0;
      ML:=0;
      MP:=0;
      ML_balance:=0;
      MP_balance:=0;

      MainForm.SystemReset;
      MainForm.GlobalReset;
    end;

    b_play.Caption:=';';
    b_play.Font.Color:=clYellow;

    STOP:=False;
    G_Paused:=False;

    while (SNumber<list_spins.Items.Count) and (not STOP) do begin

      list_spins.ItemIndex:=SNumber;
      MainForm.Bridge(StrToInt(list_spins.Items[SNumber]));
      inc(SNumber);
      Application.ProcessMessages;
      if (CheckLimits) then begin
        G_Reset;
      end;
      if one_step then G_Pause;
    end;

    if SNumber=list_spins.Items.Count-1 then G_Stop;
  end;
  except
    MainForm.RepError('Error code: CHF-004');
  end;
end;



procedure TChartForm.LoadSettings;
var reg:TRegistry;
begin
try
  reg:=TRegistry.Create(KEY_READ OR $0100);
  with reg do begin
    try
      reg.RootKey := HKEY_LOCAL_MACHINE;
      if reg.OpenKey('SOFTWARE\Ophis\'+system_code+'\chart', TRUE) then begin
        if reg.ReadString('top')<>'' then ChartForm.Top:=StrToInt(reg.ReadString('top'))
        else ChartForm.Top:=Trunc(Screen.Height/2-ChartForm.Height/2);
        if reg.ReadString('left')<>'' then ChartForm.Left:=StrToInt(reg.ReadString('left'))
        else ChartForm.Left:=Trunc(Screen.Width/2-ChartForm.Width/2);

        if reg.ReadString('width')<>'' then ChartForm.width:=StrToInt(reg.ReadString('width'))
        else ChartForm.width:=520;
        if reg.ReadString('height')<>'' then ChartForm.height:=StrToInt(reg.ReadString('height'))
        else ChartForm.height:=380;

        if reg.ReadString('cb_session_chart')<>'' then begin
          if reg.ReadString('cb_session_chart')='1' then cb_session_chart.Checked:=True else cb_session_chart.Checked:=False;
        end else cb_session_chart.Checked:=True;
        if reg.ReadString('cb_global_chart')<>'' then begin
          if reg.ReadString('cb_global_chart')='1' then cb_global_chart.Checked:=True else cb_global_chart.Checked:=False;
        end else cb_global_chart.Checked:=False;

        if (not cb_session_chart.Checked) and (not cb_global_chart.Checked) then
          cb_session_chart.Checked:=True;

        ChangeChart;
      end;
      reg.CloseKey
    finally
      reg.Free;
    end;
  end;

  FResize;

  session_chart.Title.Text[0]:=Application.Title+' - '+AppVER;
  global_chart.Title.Text[0]:=Application.Title+' - '+AppVER;
  except
    MainForm.RepError('Error code: CHF-005');
  end;
end;


procedure TChartForm.SaveSettings;
var reg:TRegistry;
begin
  try
   reg:=TRegistry.Create(KEY_WRITE OR $0100);
   with reg do begin
    try
      reg.RootKey := HKEY_LOCAL_MACHINE;
      if reg.OpenKey('SOFTWARE\Ophis\'+system_code+'\chart', TRUE) then begin
        reg.WriteString('top',IntToStr(ChartForm.Top));
        reg.WriteString('left',IntToStr(ChartForm.Left));
        reg.WriteString('height',IntToStr(ChartForm.Height));
        reg.WriteString('width',IntToStr(ChartForm.Width));
        if cb_session_chart.Checked then reg.WriteString('cb_session_chart','1') else reg.WriteString('cb_session_chart','0');
        if cb_global_chart.Checked then reg.WriteString('cb_global_chart','1') else reg.WriteString('cb_global_chart','0');
      end;
      reg.CloseKey
    finally
      reg.Free;
    end;
  end;
  except
    MainForm.RepError('Error code: CHF-006');
  end;
end;


procedure TChartForm.WMNCHitTest(var Msg: TWMNCHitTest) ;
begin
  inherited;
  if Msg.Result = htClient then Msg.Result := htCaption;
end;


procedure TChartForm.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  SendMessage(Handle, WM_SYSCOMMAND, 61458, 0) ;
end;


procedure TChartForm.FormCreate(Sender: TObject);
begin
  LoadSettings;
end;


procedure TChartForm.FormDestroy(Sender: TObject);
begin
  SaveSettings;
end;


procedure TChartForm.b_playClick(Sender: TObject);
begin
  if (G_Paused) or (SNumber=0) then
    G_Play
  else
    G_Pause;
end;


procedure TChartForm.b_stopClick(Sender: TObject);
begin
  G_Stop;
end;


procedure TChartForm.bCloseClick(Sender: TObject);
begin
  ChartForm.Close;
end;


procedure TChartForm.ExportNumbers;
var saveDialog:TSaveDialog;
begin
  try
  if MainForm.list_nr_spun.Items.Count<1 then
    MessageDlg('History empty.', mtInformation, [mbOk], 0)
  else begin
    saveDialog:=TSaveDialog.Create(self);

    saveDialog.InitialDir:=GetCurrentDir;
    saveDialog.Filter:='Text file|*.txt';
    saveDialog.DefaultExt:='txt';
    saveDialog.FilterIndex:=1;
    if saveDialog.Execute then begin
        MainForm.ExportNumbers(saveDialog.FileName);
        MessageDlg('Numbers exported to file: '+saveDialog.FileName,mtInformation,[mbOK], 0)
      end;
    saveDialog.Free;
  end;
  except
    MainForm.RepError('Error code: CHF-007');
  end;
end;


procedure TChartForm.ImportNumbers;
  var openDialog:TOpenDialog;
      myFile : TextFile;
      j,k:integer;
      temp,temp1:string;
      nums:array[0..9] of byte;
      reg,reg1:TRegistry;
begin
try
  reg:=TRegistry.Create(KEY_READ OR $0100);
  reg.RootKey := HKEY_LOCAL_MACHINE;
  reg1:=TRegistry.Create(KEY_WRITE OR $0100);
  reg1.RootKey := HKEY_LOCAL_MACHINE;

  for k:=0 to 9 do nums[k]:=k;
  openDialog:=TOpenDialog.Create(self);
  if reg.OpenKey('SOFTWARE\Ophis\'+system_code+'\chart', TRUE) then
    if reg.ReadString('dir')<>'' then openDialog.InitialDir:=reg.ReadString('dir')
    else openDialog.InitialDir:=GetCurrentDir;
  reg.CloseKey;
  openDialog.Filter:='Text file|*.txt';
  openDialog.DefaultExt:='txt';
  openDialog.FilterIndex:=1;
  if openDialog.Execute then begin
      if reg1.OpenKey('SOFTWARE\Ophis\'+system_code+'\chart', TRUE) then reg1.WriteString('dir',ExtractFilePath(openDialog.FileName));
      reg1.CloseKey;
      AssignFile(myFile, openDialog.FileName);
      Reset(myFile);
      list_spins.Items.Clear;
      try
       STOP:=False;
       while (not Eof(myFile)) and (not STOP) do begin
         ReadLN(myFile,temp);
         temp1:='';
         if (temp<>'') and (temp[1]='S') then
            for j:=1 to 12 do ReadLN(myFile,temp);
         if (temp<>'') and (temp[1]='*') then Break;

         for j:=0 to Length(temp) do
           for k:=0 to 9 do
             if temp<>'' then if temp[j]=IntToStr(nums[k]) then temp1:=temp1+IntToStr(nums[k]);
         if temp1<>'' then begin
           try
             if (strtoint(temp1)>36) or (strtoint(temp1)<0) then Raise Exception.CreateFmt('Spins corrupted! ("'+temp1+'" is not a valid number)',[]);
           except
             Raise Exception.CreateFmt('Spins corrupted! - ("'+temp1+'" is not a valid number) Import Aborted!',[]);
           end;
           list_spins.Items.Add(temp1);
         end;
         list_spins.ItemIndex:=list_spins.Items.Count-1;
         Application.ProcessMessages;
       end;
       G_Stop;
      finally
       CloseFile(myFile);
       reg.Free;
       reg1.Free;
      end;
    end;
  openDialog.Free;
  except
    MainForm.RepError('Error code: CHF-008');
  end;
end;


procedure TChartForm.b_moreClick(Sender: TObject);
begin
  menu_form.Popup(Mouse.CursorPos.X,Mouse.CursorPos.Y);
end;


procedure TChartForm.b_sbsClick(Sender: TObject);
begin
  b_sbs.Enabled:=False;
  G_SbS;
  b_sbs.Enabled:=True;
end;


procedure TChartForm.m0_import_numbersClick(Sender: TObject);
begin
  ImportNumbers;
end;


procedure TChartForm.m0_export_numbersClick(Sender: TObject);
begin
  ExportNumbers;
end;


procedure TChartForm.FormResize(Sender: TObject);
begin
  FResize;
end;


procedure TChartForm.SaveGraph(const m:byte=0);
var saveDialog:TSaveDialog;
    jpgImg: TJPEGImage;
begin
try
  saveDialog:=TSaveDialog.Create(self);
  saveDialog.Title:=Application.Title;
  saveDialog.InitialDir:=GetCurrentDir;
  saveDialog.Filter:='JPG file|*.jpg';
  saveDialog.DefaultExt:='jpg';
  saveDialog.FilterIndex:=1;
  if saveDialog.Execute
    then begin
      if m=0 then
        session_chart.CopyToClipboardBitmap
      else global_chart.CopyToClipboardBitmap;
      image_box.Picture.Bitmap.LoadFromClipboardFormat(cf_BitMap,ClipBoard.GetAsHandle(cf_Bitmap), 0);
      jpgImg := TJPEGImage.Create;
      jpgImg.Assign(image_box.Picture.Bitmap);
      jpgImg.SaveToFile(saveDialog.FileName);
      jpgImg.Free;
      MessageDlg('Chart image saved to: '+saveDialog.FileName,mtInformation,[mbOK], 0)
    end;
  saveDialog.Free;
  except
    MainForm.RepError('Error code: CHF-009');
  end;
end;


procedure TChartForm.m_s_save_graphClick(Sender: TObject);
begin
  SaveGraph;
end;

procedure TChartForm.m_g_save_graphClick(Sender: TObject);
begin
  SaveGraph(1);
end;

procedure TChartForm.cb_session_chartClick(Sender: TObject);
begin
  ChangeChart;
end;

procedure TChartForm.cb_global_chartClick(Sender: TObject);
begin
  ChangeChart;
end;

procedure TChartForm.EXPORTtoexcel1Click(Sender: TObject);
begin
  ExportToExcel;
end;

end.
