unit config_form;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, mshtml,
  Dialogs, Registry, Buttons, StdCtrls, ExtCtrls, ALPanel, ALButton,
  ALComboBox, ALEdit, StrUtils, ALScrollBar, Filectrl, ComCtrls;

type
  TConfigForm = class(TForm)
    form_box: TALPanel;
    s_header: TShape;
    l_header: TLabel;
    bClose: TSpeedButton;
    c_software: TALComboBox;
    l_dsc_software: TLabel;
    box_limits: TALPanel;
    box_chips: TALPanel;
    e_coin1: TALEdit;
    e_coin2: TALEdit;
    e_coin3: TALEdit;
    e_coin4: TALEdit;
    e_coin5: TALEdit;
    e_coin6: TALEdit;
    e_coin7: TALEdit;
    e_coin8: TALEdit;
    e_coin9: TALEdit;
    cb_coin1: TALRadioButton;
    Label1: TLabel;
    cb_coin2: TALRadioButton;
    cb_coin3: TALRadioButton;
    cb_coin4: TALRadioButton;
    cb_coin5: TALRadioButton;
    cb_coin6: TALRadioButton;
    cb_coin7: TALRadioButton;
    cb_coin8: TALRadioButton;
    cb_coin9: TALRadioButton;
    e_manual: TALEdit;
    l_manual: TLabel;
    pb_delay: TALScrollBar;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ALPanel1: TALPanel;
    Label5: TLabel;
    Label7: TLabel;
    e_un: TALEdit;
    Label6: TLabel;
    e_bankroll: TALEdit;
    e_up: TALMaskEdit;
    b_start_casino: TALButton;
    l_status: TLabel;
    cb_demo: TALRadioButton;
    cb_real: TALRadioButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    l_profit_limit: TLabel;
    l_loss_limit: TLabel;
    e_profit_limit: TALEdit;
    cb_profit_limit: TALCheckBox;
    cb_loss_limit: TALCheckBox;
    e_loss_limit: TALEdit;
    cb_save_stats: TALCheckBox;
    e_stats_path: TALEdit;
    cb_session_relog: TALRadioButton;
    cb_session_reset: TALRadioButton;
    TabSheet2: TTabSheet;
    Label8: TLabel;
    Label9: TLabel;
    cb_global_profit_limit: TALCheckBox;
    e_global_profit_limit: TALEdit;
    e_global_loss_limit: TALEdit;
    cb_global_loss_limit: TALCheckBox;
    cb_global_relog: TALRadioButton;
    cb_global_stop: TALRadioButton;
    TabSheet3: TTabSheet;
    cb_dummer: TALCheckBox;
    e_dummer: TALEdit;
    cb_dummer_off: TALCheckBox;
    e_dummer_off: TALEdit;
    cb_dummer_on: TALCheckBox;
    e_dummer_on: TALEdit;
    TabSheet4: TTabSheet;
    cb_sp: TALCheckBox;
    e_sp_disp: TALEdit;
    e_sp_2: TALEdit;
    e_sp_1: TALEdit;
    cb_sp_1: TALCheckBox;
    cb_sp_2: TALCheckBox;
    Label10: TLabel;
    e_sp_1_ammount: TALEdit;
    Label11: TLabel;
    Label12: TLabel;
    e_sp_2_ammount: TALEdit;
    Label13: TLabel;
    cb_clear_cache: TALCheckBox;
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure bCloseClick(Sender: TObject);
    procedure c_softwareChange(Sender: TObject);
    procedure cb_coin1Click(Sender: TObject);
    procedure e_manualChange(Sender: TObject);
    procedure pb_delayChange(Sender: TObject);
    procedure cb_demoClick(Sender: TObject);
    procedure cb_realClick(Sender: TObject);
    procedure b_start_casinoClick(Sender: TObject);
    procedure cb_save_statsClick(Sender: TObject);
    procedure e_stats_pathClick(Sender: TObject);
    procedure cb_dummerClick(Sender: TObject);
  private
    procedure WMNCHitTest(var Msg: TWMNCHitTest) ; message WM_NCHitTest;
  public
    procedure LoadSettings;
    procedure SaveSettings;
    procedure ValidateManual;
    procedure SSStatus(const s:string);
    procedure CheckStatsPath;
    procedure ControlsState(const state:boolean);
    procedure RealMoneyState(const state:boolean);
    procedure KeyboardState(const state:Boolean);
    procedure GameModeState(const state:boolean);
    procedure SoftwareState(const state:Boolean);
  end;

var
  ConfigForm: TConfigForm;

implementation

uses main_form, keyboard_form, bot_form, sql_form, ss_form, casino_form, sys_config;

{$R *.dfm}

procedure TConfigForm.CheckStatsPath;
var path:string;
begin
  if (e_stats_path.Text='') and (cb_save_stats.Checked) then begin
    SelectDirectory('Select a directory for session reports', '', path);
    e_stats_path.text:=path;
  end;
end;


procedure TConfigForm.GameModeState(const state:boolean);
var b_state:boolean;
    c_state:TColor;
begin
  b_state:=state;
  if b_state then c_state:=clSilver else c_state:=clGray;

  cb_demo.Enabled:=b_state;
  cb_demo.BlankColor:=c_state;
  cb_demo.Repaint;
  cb_real.Enabled:=b_state;
  cb_real.BlankColor:=c_state;
  cb_real.Repaint;
end;


procedure TConfigForm.RealMoneyState(const state:boolean);
var b_state:boolean;
    c_state:TColor;
begin
  b_state:=state;
  if b_state then c_state:=clSilver else c_state:=clGray;

  RealMoney:=b_state;

  e_un.Enabled:=b_state;
  e_up.Enabled:=b_state;
  e_bankroll.Enabled:=b_state;

  e_un.Color:=c_state;
  e_up.Color:=c_state;
  e_bankroll.Color:=c_state;
end;


procedure TConfigForm.SSStatus(const s:string);
begin
  SSForm.l_ss_status.Caption:=s;
  SSForm.Refresh;
end;


procedure TConfigForm.SoftwareState(const state:Boolean);
var b_state:Boolean;
    c_state:TColor;
begin
  b_state:=state;
  if b_state then
    c_state:=clSilver else c_state:=clGray;

  c_software.Enabled:=b_state;
  c_software.Color:=c_state;
  c_software.Repaint;
end;


procedure TConfigForm.KeyboardState(const state:Boolean);
var b_state:Boolean;
    c_state:TColor;
    i:integer;
    tmp_c:TALButton;
begin
  b_state:=state;
  if b_state then
    c_state:=clSilver else c_state:=clGray;

  with KeyboardForm do begin
    for i:=0 to 36 do begin
      tmp_c:=(FindComponent('b_'+IntToStr(i)) as TALButton);
      tmp_c.Enabled:=b_state;
      tmp_c.Color:=c_state;
      tmp_c.Repaint;
    end;
    b_undo.Enabled:=b_state;
    b_undo.Color:=c_state;
    b_undo.Repaint;
  end;

end;


procedure TConfigForm.ControlsState(const state:Boolean);
var b_state:Boolean;
    c_state:TColor;
begin
  b_state:=state;
  if b_state then
    c_state:=clSilver else c_state:=clGray;

  b_start_casino.Enabled:=b_state;
  if b_state then begin
     //MainForm.b_play.Enabled:=b_state;
     //MainForm.b_play.Font.Color:=clLime;
  end else begin
     MainForm.b_play.Enabled:=b_state;
     MainForm.b_play.Font.Color:=c_state;
  end;

  cb_demo.Enabled:=b_state;
  cb_real.Enabled:=b_state;

  e_un.Enabled:=b_state;
  e_up.Enabled:=b_state;
  e_bankroll.Enabled:=b_state;

  cb_coin1.Enabled:=b_state;
  cb_coin2.Enabled:=b_state;
  cb_coin3.Enabled:=b_state;
  cb_coin4.Enabled:=b_state;
  cb_coin5.Enabled:=b_state;
  cb_coin6.Enabled:=b_state;
  cb_coin7.Enabled:=b_state;
  cb_coin8.Enabled:=b_state;
  cb_coin9.Enabled:=b_state;

  e_coin1.Enabled:=b_state;
  e_coin2.Enabled:=b_state;
  e_coin3.Enabled:=b_state;
  e_coin4.Enabled:=b_state;
  e_coin5.Enabled:=b_state;
  e_coin6.Enabled:=b_state;
  e_coin7.Enabled:=b_state;
  e_coin8.Enabled:=b_state;
  e_coin9.Enabled:=b_state;

  e_manual.Enabled:=b_state;
  pb_delay.Enabled:=b_state;

  cb_profit_limit.Enabled:=b_state;
  cb_loss_limit.Enabled:=b_state;
  cb_global_profit_limit.Enabled:=b_state;
  cb_global_loss_limit.Enabled:=b_state;
  cb_save_stats.Enabled:=b_state;
  cb_session_relog.Enabled:=b_state;
  cb_session_reset.Enabled:=b_state;
  cb_global_relog.Enabled:=b_state;
  cb_global_stop.Enabled:=b_state;

  e_profit_limit.Enabled:=b_state;
  e_loss_limit.Enabled:=b_state;
  e_global_profit_limit.Enabled:=b_state;
  e_global_loss_limit.Enabled:=b_state;
  e_stats_path.Enabled:=b_state;

  pagecontrol1.Enabled:=b_state;

  //COLOR
  b_start_casino.Color:=c_state;

  cb_demo.BlankColor:=c_state;
  cb_real.BlankColor:=c_state;
  cb_demo.Repaint;
  cb_real.Repaint;

  e_un.Color:=c_state;
  e_up.Color:=c_state;
  e_bankroll.Color:=c_state;

  cb_coin1.BlankColor:=c_state;
  cb_coin2.BlankColor:=c_state;
  cb_coin3.BlankColor:=c_state;
  cb_coin4.BlankColor:=c_state;
  cb_coin5.BlankColor:=c_state;
  cb_coin6.BlankColor:=c_state;
  cb_coin7.BlankColor:=c_state;
  cb_coin8.BlankColor:=c_state;
  cb_coin9.BlankColor:=c_state;

  e_coin1.Color:=c_state;
  e_coin2.Color:=c_state;
  e_coin3.Color:=c_state;
  e_coin4.Color:=c_state;
  e_coin5.Color:=c_state;
  e_coin6.Color:=c_state;
  e_coin7.Color:=c_state;
  e_coin8.Color:=c_state;
  e_coin9.Color:=c_state;
 
  cb_coin1.Repaint;
  cb_coin2.Repaint;
  cb_coin3.Repaint;
  cb_coin4.Repaint;
  cb_coin5.Repaint;
  cb_coin6.Repaint;
  cb_coin7.Repaint;
  cb_coin8.Repaint;
  cb_coin9.Repaint;

  e_manual.Color:=c_state;
  pb_delay.Color:=c_state;
  pb_delay.Repaint;

  cb_profit_limit.BlankColor:=c_state;
  cb_loss_limit.BlankColor:=c_state;
  cb_global_profit_limit.BlankColor:=c_state;
  cb_global_loss_limit.BlankColor:=c_state;
  cb_save_stats.BlankColor:=c_state;
  cb_session_relog.BlankColor:=c_state;
  cb_session_reset.BlankColor:=c_state;
  cb_global_relog.BlankColor:=c_state;
  cb_global_stop.BlankColor:=c_state;

  cb_profit_limit.Repaint;
  cb_loss_limit.Repaint;
  cb_global_profit_limit.Repaint;
  cb_global_loss_limit.Repaint;
  cb_save_stats.Repaint;
  cb_session_relog.Repaint;
  cb_session_reset.Repaint;
  cb_global_relog.Repaint;
  cb_global_stop.Repaint;

  e_profit_limit.Color:=c_state;
  e_loss_limit.Color:=c_state;
  e_stats_path.Color:=c_state;

  ConfigForm.Refresh;
  Application.ProcessMessages;
end;


procedure TConfigForm.LoadSettings;
var reg:TRegistry;
begin
   reg:=TRegistry.Create(KEY_READ OR $0100);
   with reg do begin
    try
      reg.RootKey := HKEY_LOCAL_MACHINE;
      if reg.OpenKey('SOFTWARE\Ophis\'+system_code+'\config', TRUE) then begin
        if reg.ReadString('top')<>'' then ConfigForm.Top:=StrToInt(reg.ReadString('top'))
        else ConfigForm.Top:=Trunc(Screen.Height/2-ConfigForm.Height/2);
        if reg.ReadString('left')<>'' then ConfigForm.Left:=StrToInt(reg.ReadString('left'))
        else ConfigForm.Left:=Trunc(Screen.Width/2-ConfigForm.Width/2);

        if reg.ReadString('cb_clear_cache')<>'' then begin
          if reg.ReadString('cb_clear_cache')='1' then cb_clear_cache.Checked:=True else cb_clear_cache.Checked:=False;
        end else cb_clear_cache.Checked:=True;
      end;
      reg.CloseKey
    finally
      reg.Free;
    end;
  end;

end;


procedure TConfigForm.SaveSettings;
var reg:TRegistry;
    i:integer;
begin
   reg:=TRegistry.Create(KEY_WRITE OR $0100);
   with reg do begin
    try
      reg.RootKey := HKEY_LOCAL_MACHINE;
      if reg.OpenKey('SOFTWARE\Ophis\'+system_code+'\config', TRUE) then begin
        reg.WriteString('top',IntToStr(ConfigForm.Top));
        reg.WriteString('left',IntToStr(ConfigForm.Left));
        if cb_clear_cache.Checked then reg.WriteString('cb_clear_cache','1')
          else reg.WriteString('cb_clear_cache','0');

      end;
      reg.CloseKey;

      if SoftwareCODE<>'' then begin
        reg.RootKey := HKEY_LOCAL_MACHINE;
        if reg.OpenKey('SOFTWARE\Ophis\'+system_code+'\config\'+SoftwareCODE, TRUE) then begin
          for i:=1 to 9 do begin
            if (FindComponent('cb_coin'+IntToStr(i)) as TALRadioButton).Checked then reg.WriteString('cb_coin'+IntToStr(i),'1')
              else reg.WriteString('cb_coin'+IntToStr(i),'0');
            if (FindComponent('e_coin'+IntToStr(i)) as TALEdit).Text<>'' then reg.WriteString('e_coin'+IntToStr(i),(FindComponent('e_coin'+IntToStr(i)) as TALEdit).Text);
          end;
          if e_manual.Text<>'' then reg.WriteString('e_manual',e_manual.Text);
          reg.WriteString('pb_delay',IntToStr(pb_delay.Position));

          reg.WriteString('e_un',e_un.Text);
          reg.WriteString('e_up',e_up.Text);
          reg.WriteString('e_bankroll',e_bankroll.Text);

          if cb_demo.Checked then reg.WriteString('cb_demo','1')
            else reg.WriteString('cb_demo','0');
          if cb_real.Checked then reg.WriteString('cb_real','1')
            else reg.WriteString('cb_real','0');
          if cb_session_relog.Checked then reg.WriteString('cb_session_relog','1')
            else reg.WriteString('cb_session_relog','0');
          if cb_session_reset.Checked then reg.WriteString('cb_session_reset','1')
            else reg.WriteString('cb_session_reset','0');
          if cb_global_relog.Checked then reg.WriteString('cb_global_relog','1')
            else reg.WriteString('cb_global_relog','0');
          if cb_global_stop.Checked then reg.WriteString('cb_global_stop','1')
            else reg.WriteString('cb_global_stop','0');

          if cb_dummer.Checked then reg.WriteString('cb_dummer','1')
            else reg.WriteString('cb_dummer','0');
          if cb_dummer_on.Checked then reg.WriteString('cb_dummer_on','1')
            else reg.WriteString('cb_dummer_on','0');
          if cb_dummer_off.Checked then reg.WriteString('cb_dummer_off','1')
            else reg.WriteString('cb_dummer_off','0');
          reg.WriteString('e_dummer_on',e_dummer_on.Text);
          reg.WriteString('e_dummer_off',e_dummer_off.Text);

          reg.WriteString('e_profit_limit',e_profit_limit.Text);
          reg.WriteString('e_loss_limit',e_loss_limit.Text);
          reg.WriteString('e_global_profit_limit',e_global_profit_limit.Text);
          reg.WriteString('e_global_loss_limit',e_global_loss_limit.Text);
          reg.WriteString('e_stats_path',e_stats_path.Text);

          if cb_profit_limit.Checked then reg.WriteString('cb_profit_limit','1')
          else reg.WriteString('cb_profit_limit','0');
          if cb_loss_limit.Checked then reg.WriteString('cb_loss_limit','1')
          else reg.WriteString('cb_loss_limit','0');

          if cb_global_profit_limit.Checked then reg.WriteString('cb_global_profit_limit','1')
          else reg.WriteString('cb_global_profit_limit','0');
          if cb_global_loss_limit.Checked then reg.WriteString('cb_global_loss_limit','1')
          else reg.WriteString('cb_global_loss_limit','0');

          if cb_save_stats.Checked then reg.WriteString('cb_save_stats','1')
          else reg.WriteString('cb_save_stats','0');

          if cb_sp.Checked then reg.WriteString('cb_sp','1')
          else reg.WriteString('cb_sp','0');
          if cb_sp_1.Checked then reg.WriteString('cb_sp_1','1')
          else reg.WriteString('cb_sp_1','0');
          if cb_sp_2.Checked then reg.WriteString('cb_sp_2','1')
          else reg.WriteString('cb_sp_2','0');
          reg.WriteString('e_sp_1',e_sp_1.Text);
          reg.WriteString('e_sp_1_ammount',e_sp_1_ammount.Text);
          reg.WriteString('e_sp_2',e_sp_2.Text);
          reg.WriteString('e_sp_2_ammount',e_sp_2_ammount.Text);
         end;
        reg.CloseKey;
      end
    finally
      reg.Free;
    end;
  end;
end;


procedure TConfigForm.WMNCHitTest(var Msg: TWMNCHitTest) ;
begin
  inherited;
  if Msg.Result = htClient then Msg.Result := htCaption;
end;


procedure TConfigForm.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  SendMessage(Handle, WM_SYSCOMMAND, 61458, 0) ;
end;


procedure TConfigForm.FormCreate(Sender: TObject);
begin
  Screen.Cursor:=crHourglass;
  MainForm.l_header.Caption:=System_CODE+' '+appVER;
  SSStatus('...loading local settings.');
  LoadSettings;
  SqlForm.LoadRemoteSettings;
  SSStatus('...initializing application.');
  MainForm.Visible:=True;
  KeyboardForm.Visible:=True;
  Screen.Cursor:=crDefault;

  ControlsState(False);
end;


procedure TConfigForm.FormDestroy(Sender: TObject);
begin
  SaveSettings;
end;


procedure TConfigForm.bCloseClick(Sender: TObject);
begin
  ConfigForm.Close;
end;


procedure TConfigForm.c_softwareChange(Sender: TObject);
var q:integer;
begin
  if (CASINO_status<>'off') or (TABLE_status<>'off') or (REAL_Balance<>0) or (numbers_list.Count>0) then begin
    q:=MessageDlg('Session in progress. Would you like to close it?',mtConfirmation,[mbYes,mbCancel], 0);
    if q=6 then begin
      if CASINO_status<>'off' then CASINO_status:='stop';
      if BOT_status<>'off' then BOT_status:='stop';
      if (TABLE_status<>'off') or (REAL_Balance<>0) then BotForm.ResetBotSession;
      if numbers_list.Count>0 then MainForm.SystemReset;
      MainForm.GlobalReset;
      SaveSettings;
      SqlForm.LoadSoftware;
    end;
  end else begin
    SaveSettings;
    SqlForm.LoadSoftware;
  end;
end;


procedure TConfigForm.cb_coin1Click(Sender: TObject);
begin
  SaveSettings;
  SqlForm.LoadCoins;
  ValidateManual;
end;


procedure TConfigForm.ValidateManual;
var i:integer;
  e_tmp:extended;
begin
  if e_manual.Text<>'' then begin
    for i:=1 to 9 do
      (FindComponent('e_coin'+IntToStr(i) ) as TALEdit).Color:=clSilver;

    try
      if e_manual.Text<>'' then
      if StrToFloat(e_manual.Text)<>0 then begin
        e_manual.Color:=clSilver;
        for i:=9 downto 1 do begin
          try
            if ((FindComponent('e_coin'+IntToStr(i) ) as TALEdit).Text<>'') then
            if (StrToFloat((FindComponent('e_coin'+IntToStr(i) ) as TALEdit).Text)<>0) then begin
              e_tmp:=StrToFloat(e_manual.Text)/StrToFloat((FindComponent('e_coin'+IntToStr(i)) as TALEdit).Text);
              if (e_tmp>=1) and (not AnsiContainsStr(FloatToStr(e_tmp),'.')) then begin
                e_manual.Color:=clGreen;
                (FindComponent('cb_coin'+IntToStr(i)) as TALRadioButton).Checked:=True;
                (FindComponent('e_coin'+IntToStr(i) ) as TALEdit).Color:=clGreen;
                SaveSettings;
                SqlForm.LoadCoins;
                Break;
              end;
            end else (FindComponent('e_coin'+IntToStr(i) ) as TALEdit).Color:=clSilver;
          except
            (FindComponent('e_coin'+IntToStr(i) ) as TALEdit).Color:=clRed;
          end;
        end;
      end else e_manual.Color:=clSilver;
    except
      e_manual.Color:=clRed;
    end;
  end else
    e_manual.Color:=clSilver;
end;


procedure TConfigForm.e_manualChange(Sender: TObject);
begin
  ValidateManual;
end;


procedure TConfigForm.pb_delayChange(Sender: TObject);
begin
  SoftwareDelay:=pb_delay.Position;
end;


procedure TConfigForm.cb_demoClick(Sender: TObject);
begin
  RealMoneyState(cb_real.Checked);
end;


procedure TConfigForm.cb_realClick(Sender: TObject);
begin
  RealMoneyState(cb_real.Checked);
end;


procedure TConfigForm.b_start_casinoClick(Sender: TObject);
var q:integer;
begin
  if (CASINO_status<>'off') or (TABLE_status<>'off') or (REAL_Balance<>0) or (numbers_list.Count>0) then begin
    q:=MessageDlg('Session in progress. Would you like to close it?',mtConfirmation,[mbYes,mbCancel], 0);
    if q=6 then begin
      if SoftwareCODE='' then begin
        raise Exception.Create('[CONFIG Error] Please select desired casino software.');
        ConfigForm.Visible:=True;
      end else begin
        if (cb_real.Checked) then begin
          if (e_un.Text<>'') and (e_un.Text<>'') then begin
            if CASINO_status<>'off' then CASINO_status:='stop';
            if BOT_status<>'off' then BOT_status:='stop';
            if (TABLE_status<>'off') or (REAL_Balance<>0) then BotForm.ResetBotSession;
            if numbers_list.Count>0 then MainForm.SystemReset;
            MainForm.GlobalReset;
            BotForm.StartCasino;
          end else begin
            raise Exception.Create('[CONFIG Error] Please enter unsername and password to play in RealMoney mode.');
            ConfigForm.Visible:=True;
          end;
        end else begin
          if CASINO_status<>'off' then CASINO_status:='stop';
          if BOT_status<>'off' then BOT_status:='stop';
          if (TABLE_status<>'off') or (REAL_Balance<>0) then BotForm.ResetBotSession;
          if numbers_list.Count>0 then MainForm.SystemReset;
          BotForm.StartCasino;
        end;
      end;
    end;  
  end else begin
    BotForm.StartCasino;
  end;
end;


procedure TConfigForm.cb_save_statsClick(Sender: TObject);
begin
  CheckStatsPath;
end;

procedure TConfigForm.e_stats_pathClick(Sender: TObject);
var path:string;
begin
      SelectDirectory('Select a directory for session reports', '', path);
    e_stats_path.text:=path;

end;

procedure TConfigForm.cb_dummerClick(Sender: TObject);
begin
  if cb_dummer.Checked then MainForm.cb_dummy.Checked:=True;
  SysConfig.UpdateCB;
end;

end.
