unit keyboard_form;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ALButton, Buttons, ALPanel, Registry, table_form, bot_form, casino_form, sql_form;

type
  TKeyboardForm = class(TForm)
    form_box: TALPanel;
    bConfig: TSpeedButton;
    bClose: TSpeedButton;
    numbers_box: TALPanel;
    b_undo: TALButton;
    b_9: TALButton;
    b_8: TALButton;
    b_7: TALButton;
    b_6: TALButton;
    b_5: TALButton;
    b_4: TALButton;
    b_36: TALButton;
    b_35: TALButton;
    b_34: TALButton;
    b_33: TALButton;
    b_32: TALButton;
    b_31: TALButton;
    b_30: TALButton;
    b_3: TALButton;
    b_29: TALButton;
    b_28: TALButton;
    b_27: TALButton;
    b_26: TALButton;
    b_25: TALButton;
    b_24: TALButton;
    b_23: TALButton;
    b_22: TALButton;
    b_21: TALButton;
    b_20: TALButton;
    b_2: TALButton;
    b_19: TALButton;
    b_18: TALButton;
    b_17: TALButton;
    b_16: TALButton;
    b_15: TALButton;
    b_14: TALButton;
    b_13: TALButton;
    b_12: TALButton;
    b_11: TALButton;
    b_10: TALButton;
    b_1: TALButton;
    b_0: TALButton;
    l_sql_status: TLabel;
    b_hide: TSpeedButton;
    top_box: TALPanel;
    b_show: TSpeedButton;
    b_close_small: TSpeedButton;
    l_status1: TLabel;
    l_status2: TLabel;
    procedure AddNumber(Sender:TObject);
    procedure bCloseClick(Sender: TObject);
    procedure bConfigClick(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure b_hideClick(Sender: TObject);
    procedure b_showClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure b_undoClick(Sender: TObject);
  private
    procedure LoadSettings;
    procedure SaveSettings;
    procedure WMNCHitTest(var Msg: TWMNCHitTest) ; message WM_NCHitTest;
    procedure WMMove(var Message: TMessage) ; message WM_MOVE;
    procedure WMEnterSizeMove(var Message: TMessage) ; message WM_ENTERSIZEMOVE;
    procedure WMExitSizeMove(var Message: TMessage) ; message WM_EXITSIZEMOVE;
  public
    procedure kfDock(const md:byte);
    procedure UndoButton(const md:byte);
  end;

var
  KeyboardForm: TKeyboardForm;
  kfDrag:Boolean=False;

implementation

uses main_form, config_form;

{$R *.dfm}


procedure TKeyboardForm.UndoButton(const md:byte);
begin
 if md=1 then begin
   b_undo.Font.Color:=clGreen;
 end else begin
   b_undo.Font.Color:=clRed;
 end;

end;


procedure TKeyboardForm.AddNumber(Sender:TObject);
begin
  MainForm.Bridge(StrToInt((Sender as TALButton).Caption));
end;


procedure TKeyboardForm.bCloseClick(Sender: TObject);
begin
  BOT_status:='stop';
  CASINO_status:='stop';
  if (TABLE_status='on') then begin
    TF.CloseCasino;
  end;
  MainForm.Close;
  Application.Terminate;
end;


procedure TKeyboardForm.bConfigClick(Sender: TObject);
begin
  if ConfigForm.Visible then ConfigForm.Visible:=False
  else ConfigForm.Visible:=True;
end;


procedure TKeyboardForm.WMNCHitTest(var Msg: TWMNCHitTest) ;
begin
  inherited;
  if Msg.Result = htClient then Msg.Result := htCaption;
end;


procedure TKeyboardForm.WMEnterSizeMove(var Message: TMessage) ;
begin
  kfDrag:=True;
end;


procedure TKeyboardForm.WMMove(var Message: TMessage) ;
begin
  if (Assigned(ConfigForm)) and (not mfDrag) then
    with MainForm do begin
      MainForm.top:=KeyboardForm.Top-Height;
      MainForm.left:=KeyboardForm.Left+(KeyboardForm.Width-Width);
    end;
end;


procedure TKeyboardForm.WMExitSizeMove(var Message: TMessage) ;
begin
  kfDrag:=False;
end;


procedure TKeyboardForm.FormMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  SendMessage(Handle, WM_SYSCOMMAND, 61458, 0) ;
end;


procedure TKeyboardForm.kfDock(const md:byte);
begin
  if md=1 then begin
    top_box.Visible:=False;
    form_box.Visible:=True;
    KeyboardForm.Width:=form_box.Width;
    KeyboardForm.Height:=form_box.Height;
  end else if md=0 then begin
    KeyboardForm.Height:=top_box.Height;
    KeyboardForm.Width:=MainForm.Width;
    form_box.Visible:=False;
    top_box.Visible:=True;
  end;

  with KeyboardForm do begin
    KeyboardForm.top:=MainForm.Top+MainForm.Height;
    KeyboardForm.left:=(MainForm.Left+MainForm.Width)-Width;
  end;
end;


procedure TKeyboardForm.b_hideClick(Sender: TObject);
begin
  kfDock(0);
end;


procedure TKeyboardForm.b_showClick(Sender: TObject);
begin
  kfDock(1);
end;


procedure TKeyboardForm.LoadSettings;
var reg:TRegistry;
begin
   reg:=TRegistry.Create(KEY_READ OR $0100);
   with reg do begin
    try
      reg.RootKey := HKEY_LOCAL_MACHINE;
      if reg.OpenKey('SOFTWARE\Ophis\'+system_code+'\keyboard', TRUE) then begin
        if reg.ReadString('kfDock')<>'' then begin
          kfDock(StrToInt(reg.ReadString('kfDock')));
        end else kfDock(0);
      end;
      reg.CloseKey
    finally
      reg.Free;
    end;
  end;
end;


procedure TKeyboardForm.SaveSettings;
var reg:TRegistry;
begin
   reg:=TRegistry.Create(KEY_WRITE OR $0100);
   with reg do begin
    try
      reg.RootKey := HKEY_LOCAL_MACHINE;
      if reg.OpenKey('SOFTWARE\Ophis\'+system_code+'\keyboard', TRUE) then begin
        if KeyboardForm.Height=top_box.Height then reg.WriteString('kfDock','0')
          else reg.WriteString('kfDock','1');
      end;
      reg.CloseKey
    finally
      reg.Free;
    end;
  end;
end;


procedure TKeyboardForm.FormCreate(Sender: TObject);
begin
  LoadSettings;
end;

procedure TKeyboardForm.FormDestroy(Sender: TObject);
begin
  SaveSettings;
end;

procedure TKeyboardForm.b_undoClick(Sender: TObject);
begin
  if (Sender as TALButton).Font.Color=clGreen then MainForm.Undo;
end;

end.
