unit main_form;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ALQuickSortList, Registry, ALButton, StdCtrls, ALEdit,
  ALListBox, Buttons, ExtCtrls, ALPanel, ComCtrls, StrUtils, math;

type
  TMainForm = class(TForm)
    s_header: TShape;
    l_header: TLabel;
    form_box: TALPanel;
    b_graph: TSpeedButton;
    l_dsc_spin: TLabel;
    l_r: TLabel;
    l_profit: TLabel;
    l_dsc_nr: TLabel;
    l_dsc_lw_profit: TLabel;
    b_clear: TSpeedButton;
    list_spins: TALListBox;
    list_lw: TALListBox;
    LIST_PROFIT: TALListBox;
    list_nr_spun: TALListBox;
    b_play: TSpeedButton;
    b_stop: TSpeedButton;
    b_bot_debug: TSpeedButton;
    b_sql_debug: TSpeedButton;
    bConfig: TSpeedButton;
    cb_dummy: TALCheckBox;
    b_systems_debug: TSpeedButton;
    l_3: TLabel;
    l_ds: TLabel;
    b_sysconfig: TSpeedButton;
    b_casino_debug: TSpeedButton;
    l_real: TLabel;
    l_global: TLabel;
    l_dummy: TLabel;
    list_s9_streets: TALListBox;
    Label1: TLabel;
    l_streets_count: TLabel;
    l_streets_chart: TLabel;
    Label2: TLabel;
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure b_graphClick(Sender: TObject);
    procedure b_clearClick(Sender: TObject);
    procedure b_bot_debugClick(Sender: TObject);
    procedure b_sql_debugClick(Sender: TObject);
    procedure b_stopClick(Sender: TObject);
    procedure b_playClick(Sender: TObject);
    procedure bConfigClick(Sender: TObject);
    procedure b_systems_debugClick(Sender: TObject);
    procedure cb_dummyClick(Sender: TObject);
    procedure b_sysconfigClick(Sender: TObject);
    procedure b_casino_debugClick(Sender: TObject);
  private
    procedure LoadSettings;
    procedure SaveSettings;
    procedure WMNCHitTest(var Msg: TWMNCHitTest) ; message WM_NCHitTest;
    procedure WMMove(var Message: TMessage) ; message WM_MOVE;
    procedure WMEnterSizeMove(var Message: TMessage) ; message WM_ENTERSIZEMOVE;
    procedure WMExitSizeMove(var Message: TMessage) ; message WM_EXITSIZEMOVE;
    procedure Method;
    procedure CheckLW;

  public
    procedure Dummer;
    procedure Split(const Delimiter: Char; Input: string; const Strings: TStrings) ;
    procedure ExportNumbers(const filename:string);
    procedure Undo;
    procedure SystemReset(const chart:boolean=True);
    procedure GlobalReset;
    procedure UpdateDisplay;
    procedure Bridge(const no:byte);
    procedure RepError(const s:string);
    function RoundD(x: Extended; d: Integer): Extended;
    procedure SessionsProgression;
  end;

const
  appVER:string='1.0.3';
  system_code:string='S9';
  spliter:char='|';

var
  MainForm: TMainForm;

  HardwareID:widestring='';
  mfDrag:Boolean=False;

  REAL_Enabled:boolean=False;
  REAL_Balance:extended=0;
  REAL_Units:extended=0;
  SYSTEM_Balance:integer=0;

  GLOBAL_Balance:integer=0;
  GLOBAL_max_balance:integer=0;
  GLOBAL_min_balance:integer=0;

  DUMMY_to_bet:CHAR='0';
  DUMMY_units:BYTE=1;
  DUMMY_mode:byte=0;
  DUMMY_balance:integer=0;
  DUMMY_l:byte=0;

  b_drop:integer=0;
  max_balance:integer=0;
  min_balance:integer=0;

  SPINS:integer=0;
  GLOBAL_SPINS:integer=0;

  i_enhanced:byte=1;
  base_units:extended=0;

  lw_list:TStringList;
  profit_list:TALintegerList;
  numbers_list:TALIntegerList;

  //COMMON
  common_street_spun:TALIntegerList;
  common_corners_spun:TALIntegerList;
  common_splits_spun:TStringList;
  common_ds_spun:TALIntegerList;

  dummer_lw:TStringList;


implementation

uses keyboard_form, chart_form, bot_form, sql_form, config_form, debug_form, casino_form, sys_config, table_form,
  sys_s9;

{$R *.dfm}

procedure TMainForm.SessionsProgression;
var tmp_sl:TStringList;
    tmp_s:string;
    i,j:integer;
    tmp_e:extended;
begin
  with ConfigForm do begin
    if numbers_list.Count=1 then begin
      if dummer_lw.Count>0 then begin
        if cb_sp.Checked then begin
          tmp_sl:=TStringList.Create;
          if cb_sp_1.Checked then begin
            Split(',',e_sp_1.Text,tmp_sl);
            if tmp_sl.Count>0 then
              for i:=0 to tmp_sl.Count-1 do begin
                if Length(tmp_sl[i])<=dummer_lw.Count then begin
                  tmp_s:='';
                  for j:=Length(tmp_sl[i]) downto 1 do
                    tmp_s:=tmp_s+dummer_lw[dummer_lw.Count-j];
                  if tmp_sl[i]=tmp_s then begin
                    tmp_e:=StrToFloat(e_manual.Text)+(base_units*StrToFloat(e_sp_1_ammount.Text));
                    if tmp_e<base_units then tmp_e:=base_units;
                    e_manual.Text:=FloatToStrF(tmp_e,ffFixed,24,2);
                    Break;
                  end;
                end;
              end;
          end;
          tmp_sl.Clear;
          if cb_sp_2.Checked then begin
            Split(',',e_sp_2.Text,tmp_sl);
            if tmp_sl.Count>0 then
              for i:=0 to tmp_sl.Count-1 do begin
                if Length(tmp_sl[i])<=dummer_lw.Count then begin
                  tmp_s:='';
                  for j:=Length(tmp_sl[i]) downto 1 do
                    tmp_s:=tmp_s+dummer_lw[dummer_lw.Count-j];
                  if tmp_sl[i]=tmp_s then begin
                    tmp_e:=StrToFloat(e_manual.Text)+(base_units*StrToFloat(e_sp_2_ammount.Text));
                    if tmp_e<base_units then tmp_e:=base_units;
                    e_manual.Text:=FloatToStrF(tmp_e,ffFixed,24,2);
                    Break;
                  end;
                end;
              end;
          end;
          tmp_sl.Free;

        end;
      end else begin
        if (ConfigForm.e_manual.Text<>'') and (ConfigForm.e_manual.Text<>'0') then
          base_units:=StrToFloat(ConfigForm.e_manual.Text)
        else base_units:=0;
      end;
    end;
  end;
end;


procedure TMainForm.Dummer;
var i,j:integer;
    tmp_sl:TStringList;
    tmp_s:string;
begin
  SessionsProgression;

  with ConfigForm do begin
    if (cb_dummer.Checked) then begin
      if (dummer_lw.Count>0) then begin
        tmp_sl:=TStringList.Create;

        if cb_dummer_off.Checked then begin
          Split(',',e_dummer_off.Text,tmp_sl);
          if tmp_sl.Count>0 then
            for i:=0 to tmp_sl.Count-1 do begin
              if Length(tmp_sl[i])<=dummer_lw.Count then begin
                tmp_s:='';
                for j:=Length(tmp_sl[i]) downto 1 do
                  tmp_s:=tmp_s+dummer_lw[dummer_lw.Count-j];
                if tmp_sl[i]=tmp_s then begin
                  MainForm.cb_dummy.Checked:=False;
                  SysConfig.UpdateCB;
                  Break;
                end;
              end;
            end;
        end;
        tmp_sl.Clear;

        if cb_dummer_on.Checked then begin
          Split(',',e_dummer_on.Text,tmp_sl);
          if tmp_sl.Count>0 then
            for i:=0 to tmp_sl.Count-1 do begin
              if Length(tmp_sl[i])<=dummer_lw.Count then begin
                tmp_s:='';
                for j:=Length(tmp_sl[i]) downto 1 do
                  tmp_s:=tmp_s+dummer_lw[dummer_lw.Count-j];
                if tmp_sl[i]=tmp_s then begin
                  MainForm.cb_dummy.Checked:=True;
                  SysConfig.UpdateCB;
                  Break;
                end;
              end;
            end;
        end;
        tmp_sl.Free;
      end else begin
        if cb_dummer.Checked then MainForm.cb_dummy.Checked:=True;
        SysConfig.UpdateCB;
      end;
    end;
  end;
end;


procedure TMainForm.GlobalReset;
begin
  GLOBAL_SPINS:=0;
  GLOBAL_Balance:=0;
  GLOBAL_max_balance:=0;
  GLOBAL_min_balance:=0;
  l_global.Caption:='GLOBAL: '+IntToStr(GLOBAL_Balance)+'u';
  ChartForm.global_chart.Series[0].Clear;
  dummer_lw.Clear;
  ConfigForm.e_dummer.Text:='...';
  if ConfigForm.cb_dummer.Checked then begin
    MainForm.cb_dummy.Checked:=True;
    SysConfig.UpdateCB;
  end;
end;


function TMainForm.RoundD(x: Extended; d: Integer): Extended;
var
  n: Extended;
begin
  n := IntPower(10, d);
  x := x * n;
  Result := (Int(x) + Int(Frac(x) * 2)) / n;
end;


procedure TMainForm.RepError(const s:string);
begin
  ShowMessage(s);
end;


procedure TMainForm.Split(const Delimiter: Char; Input: string; const Strings: TStrings) ;
begin
try
   Assert(Assigned(Strings)) ;
   Strings.Clear;
   Strings.Delimiter := Delimiter;
   Strings.DelimitedText := Input;
  except
    MainForm.RepError('Error code: M-005');
  end;
end;


procedure TMainForm.ExportNumbers(const filename:string);
var myFile : TextFile;
    i:integer;
begin
try
  if filename<>'' then begin
    AssignFile(myFile, filename);
    ReWrite(myFile);
    try
    if numbers_list.Count>0 then
      for i:=0 to numbers_list.Count-1 do
        WriteLn(myFile,numbers_list[i]);
    finally
      CloseFile(myFile);
    end;
  end;  
  except
    MainForm.RepError('Error code: M-006');
  end;
end;


procedure TMainForm.Undo;
var TMP_N:array of byte;
    i,j:integer;
    tmp_rb:extended;
begin
  //REAL STATS
  tmp_rb:=0;
  if TABLE_status='on' then begin
    with ConfigForm do begin
      if (ConfigForm.e_manual.Text='') or (ConfigForm.e_manual.Text='0') then begin
        j:=1;
        for i:=1 to 9 do
          if (FindComponent('cb_coin'+IntToStr(i) ) as TALRadioButton).Checked=True then j:=i;
        tmp_rb:=REAL_Balance-(profit_list[profit_list.Count-1]*StrToFloat((FindComponent('e_coin'+IntToStr(j) ) as TALEdit).Text));
      end else begin
        tmp_rb:=REAL_Balance-(profit_list[profit_list.Count-1]*StrToFloat(e_manual.Text));
      end;
    end;
  end;
  //^^

  GLOBAL_spins:=GLOBAL_spins-SPINS;
  GLOBAL_balance:=GLOBAL_balance-SYSTEM_balance;
  for i:=SPINS downto 0 do
    if ChartForm.global_chart.Series[0].Count>0 then
      ChartForm.global_chart.Series[0].Delete(ChartForm.global_chart.Series[0].Count-1);

  SetLength(TMP_N,numbers_list.Count-1);
  for i:=low(TMP_N) to high(TMP_N) do
    TMP_N[i]:=numbers_list[i];

  SystemReset;

  for i:=low(TMP_N) to high(TMP_N) do begin
    Bridge(TMP_N[i]);
  end;

  if SNumber<>0 then begin
    SNumber:=SNumber-1;
    chartform.list_spins.ItemIndex:=SNumber;
  end;

  //REAL STATS
  if TABLE_status='on' then begin
    REAL_Balance:=tmp_rb;
    l_real.Caption:='REAL: '+FloatToStrF(REAL_Balance,ffNumber,24,2);
  end;
  //^^

end;


procedure TMainForm.CheckLW;
var t_profit:integer;
begin
try
  if (SysConfig.cb_s9.Checked)
  or (dummy_to_bet<>'0')
  then begin
    t_profit:=0;

    if dummy_to_bet<>'0' then begin
      if numbers_list[numbers_list.Count-1]<>0 then begin
        if ((Odd(numbers_list[numbers_list.Count-1])) and (dummy_to_bet='O')) or
           ((not Odd(numbers_list[numbers_list.Count-1])) and (dummy_to_bet='E'))
            then begin
              DUMMY_balance:=DUMMY_Balance+DUMMY_units;
              t_profit:=t_profit+dummy_units;
              DUMMY_l:=0;
            end else begin
              DUMMY_balance:=DUMMY_Balance-DUMMY_units;
              t_profit:=t_profit-dummy_units;
              inc(DUMMY_l);
            end;
      end else begin
        DUMMY_balance:=DUMMY_Balance-DUMMY_units;
        t_profit:=t_profit-dummy_units;
        inc(DUMMY_l);
      end;

      //REAL STATS - dummy bet only (single_zero) - only when running on dummy mode ON
      if not REAL_Enabled then
        REAL_Balance:=REAL_Balance+(t_profit*REAL_units);
      //^^
    end;


    if SysConfig.cb_s9.Checked then t_profit:=t_profit+S9HIT;


    if t_profit>0 then begin
      lw_list.Add('W');
    end else if t_profit<0 then begin
      lw_list.Add('L');
    end else lw_list.Add(' ');

    profit_list.Add(t_profit);

    //REAL STATS
    if REAL_Enabled then
      REAL_Balance:=REAL_Balance+(t_profit*REAL_units);
    //^^
    l_real.Caption:='REAL: '+FloatToStrF(REAL_Balance,ffFixed,24,2);

    SYSTEM_Balance:=SYSTEM_Balance+t_profit;
    GLOBAL_Balance:=GLOBAL_Balance+t_profit;

  end else begin
    lw_list.Add(' ');
    profit_list.Add(0);
  end;
  except
    MainForm.RepError('Error code: M-007');
  end;

end;


procedure TMainForm.UpdateDisplay;
var i,k,debug_i:integer;
    to_bet:TStringList;
    to_bet_units:TALIntegerList;
    tmp_sl_bets:TStringList;
    tmp_sl_units:TStringList;
    add,debug:boolean;
    debug_sl:TStringList;
    s_tmp:string;
begin
try
  if spins<>0 then begin
    with list_nr_spun do begin
      if Items.Count=Trunc(height/ItemHeight) then Items.Delete(0);
      Items.Add(IntToStr(numbers_list[numbers_list.Count-1]));
    end;
    with list_spins do begin
      if Items.Count=Trunc(height/ItemHeight) then Items.Delete(0);
      Items.Add(IntToStr(SPINS));
    end;
    with list_lw do begin
      if Items.Count=Trunc(height/ItemHeight) then Items.Delete(0);
      Items.Add(lw_list[lw_list.Count-1]);
    end;
    with list_s9_streets do begin
      if Items.Count=Trunc(height/ItemHeight) then Items.Delete(0);
      if s9_streets.Count>0 then Items.Add(IntToStr(s9_streets[s9_streets.Count-1]));
    end;
    with list_profit do begin
      if Items.Count=Trunc(height/ItemHeight) then Items.Delete(0);
      if profit_list[profit_list.Count-1]<>0 then Items.Add(IntToStr(profit_list[profit_list.Count-1]))
        else Items.Add(' ');
    end;

  end else begin
    list_spins.Items.Clear;
    list_nr_spun.Items.Clear;
    list_lw.Items.Clear;
    list_profit.Items.Clear;
    list_s9_streets.Items.Clear;
  end;


  to_bet:=TStringList.Create;
  to_bet_units:=TALIntegerList.Create;
  tmp_sl_bets:=TStringList.Create;
  tmp_sl_units:=TStringList.Create;

  debug:=True;
  debug_i:=-1;
  debug_sl:=TStringList.Create;

  //S9
  if SysConfig.cb_S9.Checked then
    if s9_to_bet.Count>0 then begin

      if debug then begin
        debug_sl.Add('');
        inc(debug_i);
      end;

      for i:=0 to s9_to_bet.Count-1 do begin

        if debug then
          if debug_sl[debug_i]='' then
            debug_sl[debug_i]:='S9: '+s9_to_bet[i]+'['+IntToStr(s9_units[s9_units.Count-1])+']' else
              debug_sl[debug_i]:=debug_sl[debug_i]+' '+spliter+' '+s9_to_bet[i]+'['+IntToStr(s9_units[s9_units.Count-1])+']';

        Add:=True;
        if to_bet.Count>0 then
          for k:=0 to to_bet.Count-1 do
            if to_bet[k]=s9_to_bet[i] then begin
              to_bet_units[k]:=to_bet_units[k]+s9_units[s9_units.Count-1];
              Add:=False;
              Break;
            end;

        if Add then begin
          to_bet.Add(s9_to_bet[i]);
          to_bet_units.Add(s9_units[s9_units.Count-1]);
        end;
      end;
    end;


  tmp_sl_bets.Free;
  tmp_sl_units.Free;

  if debug then begin
    with DebugForm do begin
      l_debug.Caption:='';
      if debug_sl.Count>0 then
        for i:=0 to debug_sl.Count-1 do
          if i=0 then l_debug.Caption:=debug_sl[i] else l_debug.Caption:=l_debug.Caption+sLineBreak+debug_sl[i];
    end;
    debug_sl.Free;
  end;

  //caption update
  l_ds.Caption:='-';

  if to_bet.Count>0 then
    for i:=0 to to_bet.Count-1 do begin
      if l_ds.Caption='-' then l_ds.Caption:=AnsiReplaceStr(to_bet[i],'S','')+'['+IntToStr(to_bet_units[i])+']'
        else l_ds.Caption:=l_ds.Caption+'  '+AnsiReplaceStr(to_bet[i],'S','')+'['+IntToStr(to_bet_units[i])+']';
    end;

  ConfigForm.e_sp_disp.Text:='...';
  ConfigForm.e_dummer.Text:='...';
  if dummer_lw.Count>0 then
    for i:=0 to dummer_lw.Count-1 do begin
      if i=0 then ConfigForm.e_dummer.Text:=dummer_lw[i] else
        ConfigForm.e_dummer.Text:=ConfigForm.e_dummer.Text+' '+dummer_lw[i];
      if i=0 then ConfigForm.e_sp_disp.Text:=dummer_lw[i] else
        ConfigForm.e_sp_disp.Text:=ConfigForm.e_sp_disp.Text+' '+dummer_lw[i];
    end;

  to_bet.Free;
  to_bet_units.Free;

  l_profit.Caption:='SESSION Balance: '+IntToStr(SYSTEM_Balance)+'u';
  l_dummy.Caption:='DUMMY: '+IntToStr(DUMMY_Balance)+'u';
  l_global.Caption:='GLOBAL: '+IntToStr(GLOBAL_Balance)+'u';

  s_tmp:='';
  if s9_s.Count>0 then
    for i:=0 to s9_s.Count-1 do
      if s_tmp='' then s_tmp:=IntToStr(s9_s[i]) else s_tmp:=s_tmp+' '+IntToStr(s9_s[i]);
  l_streets_chart.Caption:=s_tmp;

  l_streets_count.Caption:='('+IntToStr(s9_s.Count)+')';

  except
    MainForm.RepError('Error code: M-008');
  end;
end;



procedure TMainForm.Method;
begin

  CheckLW;

  //s9
  if SysConfig.cb_s9.Checked then begin
    S9StreetUpdate;
    S9ToBet;
    S9Progression;
    S9ColectToBet;
  end;

  if min_balance>SYSTEM_Balance then min_balance:=SYSTEM_Balance;
  if max_balance<SYSTEM_Balance then max_balance:=SYSTEM_Balance;
  if b_drop>SYSTEM_Balance-max_balance then b_drop:=SYSTEM_Balance-max_balance;

  if GLOBAL_min_balance>GLOBAL_Balance then GLOBAL_min_balance:=GLOBAL_Balance;
  if GLOBAL_max_balance<GLOBAL_Balance then GLOBAL_max_balance:=GLOBAL_Balance;

    with ChartForm do begin
      session_chart.Series[0].AddXY(SPINS, SYSTEM_Balance);

      session_chart.Foot.Text.Clear;
      session_chart.Foot.Text.Add(
                       'Max. Drop: '+IntToStr(b_drop)+'   |   '+
                       'Min. Balance: '+IntToStr(min_balance)+'   |   '+
                       'Max. Balance: '+IntToStr(max_balance)+'   |   '+
                       'BALANCE: '+IntToStr(SYSTEM_Balance)
                       );

      global_chart.Series[0].AddXY(GLOBAL_SPINS, GLOBAL_Balance);

      global_chart.Foot.Text.Clear;
      global_chart.Foot.Text.Add(
                       'Min. Balance: '+IntToStr(GLOBAL_min_balance)+'   |   '+
                       'Max. Balance: '+IntToStr(GLOBAL_max_balance)+'   |   '+
                       'BALANCE: '+IntToStr(GLOBAL_Balance)
                       );

    end;
end;


procedure TMainForm.SystemReset(const chart:boolean=True);
begin
  try
    DUMMY_to_bet:='0';
    DUMMY_units:=1;
    DUMMY_mode:=0;
    DUMMY_balance:=0;
    DUMMY_l:=0;

    S9Reset;

    SPINS:=0;
    b_drop:=0;
    min_balance:=0;
    max_balance:=0;
    lw_list.Clear;
    profit_list.Clear;
    numbers_list.Clear;

    REAL_Balance:=0;
    REAL_units:=0;
    SYSTEM_Balance:=0;
    ChartForm.session_chart.Series[0].Clear;

    UpdateDisplay;
  except
    MainForm.RepError('Error code: M-009');
  end;
end;


procedure TMainForm.Bridge(const no:byte);
begin
  if SPINS>1 then KeyboardForm.UndoButton(1) else KeyboardForm.UndoButton(0);

  inc(SPINS);
  inc(GLOBAL_SPINS);
  numbers_list.Add(no);

  Method;
  UpdateDisplay;
end;


procedure TMainForm.LoadSettings;
var reg:TRegistry;
begin
  DecimalSeparator:='.';

   reg:=TRegistry.Create(KEY_READ OR $0100);
   with reg do begin
    try
      reg.RootKey := HKEY_LOCAL_MACHINE;
      if reg.OpenKey('SOFTWARE\Ophis\'+system_code, TRUE) then begin
        if reg.ReadString('top')<>'' then MainForm.Top:=StrToInt(reg.ReadString('top'))
          else MainForm.Top:=Trunc(Screen.Height/2-MainForm.Height/2);
        if reg.ReadString('left')<>'' then MainForm.Left:=StrToInt(reg.ReadString('left'))
          else MainForm.Left:=Trunc(Screen.Width-MainForm.Width-20);

        if reg.ReadString('cb_dummy')<>'' then begin
          if reg.ReadString('cb_dummy')='1' then cb_dummy.Checked:=True else cb_dummy.Checked:=False;
        end else cb_dummy.Checked:=False;

     end;
      reg.CloseKey
    finally
      reg.Free;
    end;
  end;


  lw_list:=TStringList.Create;
  profit_list:=TALIntegerList.Create;
  numbers_list:=TALIntegerList.Create;

  //COMMON
  dummer_lw:=TStringList.Create;

  S9Init;
end;


procedure TMainForm.SaveSettings;
var reg:TRegistry;
begin
   reg:=TRegistry.Create(KEY_WRITE OR $0100);
   with reg do begin
    try
      reg.RootKey := HKEY_LOCAL_MACHINE;
      if reg.OpenKey('SOFTWARE\Ophis\'+system_code, TRUE) then begin
        reg.WriteString('top',IntToStr(MainForm.Top));
        reg.WriteString('left',IntToStr(MainForm.Left));

        if cb_dummy.Checked then reg.WriteString('cb_dummy','1') else reg.WriteString('cb_dummy','0');
      end;
      reg.CloseKey
    finally
      reg.Free;
    end;
  end;

  lw_list.Free;
  profit_list.Free;
  numbers_list.Free;

  //COMMON
  common_ds_spun.Free;
  dummer_lw.Free;

  S9Free;
end;


procedure TMainForm.WMNCHitTest(var Msg: TWMNCHitTest) ;
begin
  inherited;
  if Msg.Result = htClient then Msg.Result := htCaption;
end;


procedure TMainForm.WMEnterSizeMove(var Message: TMessage) ;
begin
  mfDrag:=True;
end;


procedure TMainForm.WMMove(var Message: TMessage) ;
begin
  if (Assigned(KeyboardForm)) and (not kfDrag) then
     with KeyboardForm do begin
        KeyboardForm.top:=MainForm.Top+MainForm.Height;
        KeyboardForm.left:=(MainForm.Left+MainForm.Width)-Width;
     end;
end;


procedure TMainForm.WMExitSizeMove(var Message: TMessage) ;
begin
  mfDrag:=False;
end;


procedure TMainForm.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  SendMessage(Handle, WM_SYSCOMMAND, 61458, 0) ;
end;


procedure TMainForm.FormCreate(Sender: TObject);
begin
  LoadSettings;
end;


procedure TMainForm.FormDestroy(Sender: TObject);
begin
  SaveSettings;
end;


procedure TMainForm.b_graphClick(Sender: TObject);
begin
  if ChartForm.Visible then ChartForm.Visible:=False else ChartForm.Visible:=True;
end;


procedure TMainForm.b_clearClick(Sender: TObject);
var q:integer;
begin
  b_clear.Enabled:=False;
  if (CASINO_status<>'off') or ((TABLE_status<>'off') and (REAL_Balance<>0)) then begin
    q:=MessageDlg('Session in progress. Would you like reset it?',mtConfirmation,[mbYes,mbCancel], 0);
    if q=6 then begin
      BotForm.ResetBotSession;
      GlobalReset;
      BotForm.StartCasino;
    end;
  end else begin
    SystemReset;
    GlobalReset;
  end;
  b_clear.Enabled:=True;
end;


procedure TMainForm.b_bot_debugClick(Sender: TObject);
begin
  if BotForm.Visible then BotForm.Visible:=False else BotForm.Visible:=True;
end;


procedure TMainForm.b_sql_debugClick(Sender: TObject);
begin
  if SqlForm.Visible then SqlForm.Visible:=False else SqlForm.Visible:=True;
end;


procedure TMainForm.b_stopClick(Sender: TObject);
begin
  if BOT_status<>'off' then BOT_status:='stop';
  if CASINO_status<>'off' then CASINO_status:='stop';
end;


procedure TMainForm.b_playClick(Sender: TObject);
var q:integer;
begin
  if SoftwareCODE='' then begin
    raise Exception.Create('[CONFIG Error] Please select desired casino software.');
    ConfigForm.Visible:=True;
  end else begin
    if (TABLE_status='on') or (numbers_list.Count>0) or (REAL_Balance<>0) then begin
        q:=MessageDlg('Session in progress. Would you like to start new one?',mtConfirmation,[mbYes,mbNo,mbCancel], 0);
        if q=6 then begin
          if (TABLE_status='on') then begin
            BotForm.ResetBotSession;
          end else SystemReset;
          GlobalReset;
          if (TABLE_status='off') and (CASINO_status='off') then BotForm.StartCasino;
          if (TABLE_status='on') and (CASINO_status='off')  then BotForm.StartBot;
        end else if q=7 then
          if TABLE_status='on' then BotForm.StartBot;
    end else begin
      if TABLE_status='off' then BotForm.StartCasino;
      if TABLE_status='on' then BotForm.StartBot;
    end;
  end;
end;


procedure TMainForm.bConfigClick(Sender: TObject);
begin
  if ConfigForm.Visible then ConfigForm.Visible:=False
  else ConfigForm.Visible:=True;
end;


procedure TMainForm.b_systems_debugClick(Sender: TObject);
begin
  if DebugForm.Visible then DebugForm.Visible:=False else DebugForm.Visible:=True;
end;


procedure TMainForm.cb_dummyClick(Sender: TObject);
begin
  SysConfig.UpdateCB;
end;


procedure TMainForm.b_sysconfigClick(Sender: TObject);
begin
  if SysConfig.Visible then SysConfig.Visible:=False
  else SysConfig.Visible:=True;
end;


procedure TMainForm.b_casino_debugClick(Sender: TObject);
begin
  with CasinoForm do begin
    if Height=0 then begin
      Height:=607;
      width:=577;
    end else begin
      height:=0;
      width:=0;
    end;
  end;
end;





end.


