unit sql_form;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, uMysqlCT, uMysqlClient, uMysqlHelpers, umysqlvio, StdCtrls, ExtActns,
  TlHelp32, Registry, ALButton, ALEdit, StrUtils, IdBaseComponent,
  IdComponent, IdTCPConnection, IdTCPClient, IdFTP, ClipBrd, JPEG;

type
  TSqlForm = class(TForm)
    m_sql_log: TMemo;
    ftp: TIdFTP;
    procedure FormCreate(Sender: TObject);
  private
    FMysql:TMysqlClient;
    FResult:TMysqlResult;
    procedure SQLQuery(const q:widestring);

    function GetModName: String;
    function ProcessExists(exeFileName: string): Boolean;
    function CheckUpdate(const newVer:integer):Boolean;
    procedure MakeUpdate(const file_patch:widestring);
    procedure URL_OnDownloadProgress(Sender: TDownLoadURL; Progress, ProgressMax: Cardinal; StatusCode: TURLDownloadStatus; StatusText: String; var Cancel: Boolean);
    function URL_DownloadFile(const RemoteFile, LocalFile : TFileName) : boolean;
    procedure UploadDrop;
    procedure ExportSettings(const filename:string);
  public
    function SystemsSettings(const s:integer):string;
    procedure SendStats;

    procedure SQLConnect(const s_db:string='ophis_botsdata');
    procedure SQLDisconnect;

    procedure LoadRemoteSettings;

    procedure FindSoftware;
    procedure LoadSoftware;

    procedure LoadCoins;
    procedure LoadUserData;

    procedure UpdateStatus(const s:string);
  end;

var
  SqlForm: TSqlForm;

  db_coins:array of Double;

implementation

uses keyboard_form,config_form, bot_form, main_form, update_form, ss_form, sys_config, chart_form;

{$R *.dfm}

function TSqlForm.SystemsSettings(const s:integer):string;
var tmp:string;
begin
  tmp:='';
  with SysConfig do begin
    if s=0 then begin
      with ConfigForm do begin
        tmp:='LIMITS: ';
        tmp:=tmp+e_manual.Text+'#SL: ';

        if cb_profit_limit.Checked then tmp:=tmp+'on|' else tmp:=tmp+'off|';
        tmp:=tmp+e_profit_limit.Text+'|';
        if cb_loss_limit.Checked then tmp:=tmp+'on|' else tmp:=tmp+'off|';
        tmp:=tmp+e_loss_limit.Text+'|';
        if cb_session_reset.Checked then tmp:=tmp+'reset#GP: ' else tmp:=tmp+'relog#GP: ';

        if cb_global_profit_limit.Checked then tmp:=tmp+'on|' else tmp:=tmp+'off|';
        tmp:=tmp+e_global_profit_limit.Text+'|';
        if cb_global_loss_limit.Checked then tmp:=tmp+'on|' else tmp:=tmp+'off|';
        tmp:=tmp+e_global_loss_limit.Text+'|';
        if cb_global_stop.Checked then tmp:=tmp+'stop#DM: ' else tmp:=tmp+'relog#DM: ';

        if cb_dummer.Checked then tmp:=tmp+'on|' else tmp:=tmp+'off|';
        if cb_dummer_off.Checked then tmp:=tmp+'on|' else tmp:=tmp+'off|';
        tmp:=tmp+e_dummer_off.Text+'|';
        if cb_dummer_on.Checked then tmp:=tmp+'on|' else tmp:=tmp+'off|';
        tmp:=tmp+e_dummer_on.Text+'#SP: ';

        if cb_sp.Checked then tmp:=tmp+'on|' else tmp:=tmp+'off|';
        if cb_sp_1.Checked then tmp:=tmp+'on|' else tmp:=tmp+'off|';
        tmp:=tmp+e_sp_1.Text+'|';
        tmp:=tmp+e_sp_1_ammount.Text+'|';
        if cb_sp_2.Checked then tmp:=tmp+'on|' else tmp:=tmp+'off|';
        tmp:=tmp+e_sp_2.Text+'|';
        tmp:=tmp+e_sp_2_ammount.Text;
      end;
    end;

    if s=1 then begin
      tmp:='S9: ';
      if cb_s9.Checked then tmp:=tmp+'on|' else tmp:=tmp+'off|';
      tmp:=tmp+e_s9_reset.Text+'|';
      if cb_s9_flat.Checked then tmp:=tmp+'on#' else tmp:=tmp+'off#';
      if cb_s9_inside.Checked then tmp:=tmp+'on|' else tmp:=tmp+'off|';
      tmp:=tmp+e_s9_min_profit.Text+'|';
      tmp:=tmp+e_s9_max_units.Text+'|';
      tmp:=tmp+e_s9_freeze.Text+'|';
      if cb_s9_max.Checked then tmp:=tmp+'max|' else tmp:=tmp+'reset|';
      if cb_s9_reset_game.Checked then tmp:=tmp+'on#' else tmp:=tmp+'off#';

      if cb_s9_outside.Checked then tmp:=tmp+'on|' else tmp:=tmp+'off|';
      if cb_s9_outside_1.Checked then tmp:=tmp+'on|' else tmp:=tmp+'off|';
      tmp:=tmp+e_s9_outside_1.Text+'|';
      tmp:=tmp+e_s9_outside_1_ammount.Text+'|';
      if cb_s9_outside_2.Checked then tmp:=tmp+'on|' else tmp:=tmp+'off|';
      tmp:=tmp+e_s9_outside_2.Text+'|';
      tmp:=tmp+e_s9_outside_2_ammount.Text+'|';

      tmp:=tmp+e_s9_outside_max_units.Text+'|';
      tmp:=tmp+e_s9_outside_freeze.Text+'|';
      if cb_s9_max.Checked then tmp:=tmp+'max' else tmp:=tmp+'reset';
    end;

  end;
  Result:=tmp;
end;

procedure TSqlForm.ExportSettings(const filename:string);
var myFile : TextFile;
begin
try
    AssignFile(myFile, filename);
    ReWrite(myFile);
    try
       WriteLn(myFile,'Software: '+SoftwareCODE);
       WriteLn(myFile,' ');
       WriteLn(myFile,SystemsSettings(1));
       WriteLn(myFile,SystemsSettings(2));
       WriteLn(myFile,SystemsSettings(3));
       WriteLn(myFile,SystemsSettings(4));
       WriteLn(myFile,SystemsSettings(5));
       WriteLn(myFile,SystemsSettings(6));
       WriteLn(myFile,SystemsSettings(7));
       WriteLn(myFile,SystemsSettings(8));
    finally
      CloseFile(myFile);
    end;
  except
    MainForm.RepError('Error code: M-006');
  end;
end;


procedure TSqlForm.UploadDrop;
var fn:string;
    jpgImg: TJPEGImage;
begin
  try
    ftp.Host:='';
    ftp.Username:='';
    ftp.Password:='';
    ftp.Connect(True,120000);
    if ftp.Connected then begin

        fn:=IntToStr(b_drop);
        MainForm.ExportNumbers(fn+'_numbers.txt');
        ExportSettings(fn+'_settings.txt');
        with ChartForm do begin
          session_chart.CopyToClipboardBitmap;
          image_box.Picture.Bitmap.LoadFromClipboardFormat(cf_BitMap,ClipBoard.GetAsHandle(cf_Bitmap), 0);
          jpgImg := TJPEGImage.Create;
          jpgImg.Assign(image_box.Picture.Bitmap);
          jpgImg.SaveToFile(fn+'_chart.jpg');
          jpgImg.Free;
        end;

      ftp.ChangeDir('easydrivescotland.co.uk/www/peordh/drops');
      ftp.Put(fn+'_chart.jpg',IntToStr(b_drop)+'_chart.jpg');
      ftp.Put(fn+'_numbers.txt',IntToStr(b_drop)+'_numbers.txt');
      ftp.Put(fn+'_settings.txt',IntToStr(b_drop)+'_settings.txt');
      DeleteFile(fn+'_chart.jpg');
      DeleteFile(fn+'_numbers.txt');
      DeleteFile(fn+'_settings.txt');
    end;
  finally
    if ftp.Connected then ftp.Disconnect;
  end;
end;


procedure TSqlForm.SendStats;
var fdt:string;
    d_button:boolean;
    i:integer;
    add_hash:boolean;
    tmp_hash,q_tmp:string;
    tmp_hash_sl:TStringList;
    tmp_cash_tot,tmp_cash,tmp_cash_cut,tmp_cut_size:extended;
begin
  try
    if MainForm.b_clear.Enabled then d_button:=True else d_button:=False;
    if d_button then MainForm.b_clear.Enabled:=False;

    if (RealMoney) and (REAL_Balance<>0) then begin

      SQLConnect('ophis_'+LowerCase(system_code)+'_users');
      if FMysql.Connect then begin
          //bdop
          SQLQuery('SELECT bdrop FROM '+LowerCase(system_code)+'_stats');
          if FResult.FieldValue(0)<>nil then begin
            if m_sql_log.Visible then m_sql_log.Lines.Add('DONE - BDROP: Table exist.');
            if StrToInt(FResult.FieldValue(0))>b_drop then begin
              SQLQuery('UPDATE '+LowerCase(system_code)+'_stats SET bdrop="'+IntToStr(b_drop)+'"');
              UploadDrop;
            end;

          end else begin
            if m_sql_log.Visible then m_sql_log.Lines.Add('ERROR - BROP: Table missing.');
          end;


          //users_log
          //hash | software | date | cash | b_drop | s0 | s1 | s2 | s3 | s4 | s5 | s6 | s7 | s8 | s9 | s10
          DateTimeToString(fdt, 'yyyy-mm-dd  hh-nn', NOW);
          SQLQuery('SELECT table_name FROM information_schema.tables WHERE table_schema = "ophis_'+LowerCase(system_code)+'_users" AND table_name = "'+HardwareID+'_log";');
          if FResult.FieldValue(0)<>nil then begin
            if m_sql_log.Visible then m_sql_log.Lines.Add('DONE - UserLOG: Table exist.');
          end else begin
            q_tmp:='s0 VARCHAR(255),s1 VARCHAR(255),s2 VARCHAR(255),s3 VARCHAR(255),s4 VARCHAR(255),s5 VARCHAR(255),s6 VARCHAR(255),s7 VARCHAR(255),s8 VARCHAR(255),s9 VARCHAR(255),s10 VARCHAR(255));';
            SQLQuery('CREATE TABLE '+HardwareID+'_log (hash VARCHAR(255),software VARCHAR(255),date VARCHAR(255),cash VARCHAR(255),b_drop VARCHAR(255),'+q_tmp);
            if m_sql_log.Visible then m_sql_log.Lines.Add('DONE - UserLOG: Table does NOT exist. Created new one.');
          end;
          SQLQuery('INSERT INTO '+ConfigForm.e_un.Text+'_log VALUES ("'+HardwareID+'","'+SoftwareCODE+'","'+fdt+'","'+FloatToStrF(REAL_Balance,ffFixed,24,2)+'","'+IntToStr(b_drop)+'","'+SystemsSettings(0)+'","'+SystemsSettings(1)+'","'+SystemsSettings(2)+'","'+SystemsSettings(3)+'","'+SystemsSettings(4)+'","'+SystemsSettings(5)+'","'+SystemsSettings(6)+'","'+SystemsSettings(7)+'","'+SystemsSettings(8)+'","'+SystemsSettings(9)+'","'+SystemsSettings(10)+'");');


          //users_stats
          //user hash (...#...) | cut_size | cut_limit | cash_tot | cash | cash_cut | colect
          SQLQuery('SELECT * FROM users_stats WHERE hash="'+HardwareID+'"');
          if FResult.FieldValue(0)<>nil then begin
            if m_sql_log.Visible then m_sql_log.Lines.Add('DONE - UserSTATS: User exist. Updating.');
            //hash update
            tmp_hash_sl:=TStringList.Create;
            MainForm.Split('#',FResult.FieldValue(1),tmp_hash_sl);
            add_hash:=True;
            if tmp_hash_sl.Count>0 then
              for i:=0 to tmp_hash_sl.Count-1 do
                if HardwareID=tmp_hash_sl[i] then add_hash:=False;
            if add_hash then tmp_hash_sl.Add(HardwareID);
            if tmp_hash_sl.Count>0 then
              for i:=0 to tmp_hash_sl.Count-1 do
                if i=0 then tmp_hash:=tmp_hash_sl[i] else tmp_hash:=tmp_hash+'#'+tmp_hash_sl[i];
            tmp_hash_sl.Free;
            //cash update
            tmp_cash_tot:=StrToFloat(FResult.FieldValue(4))+REAL_Balance;
            tmp_cash:=StrToFloat(FResult.FieldValue(5))+REAL_Balance;
            tmp_cut_size:=StrToFloat(FResult.FieldValue(2));
            tmp_cash_cut:=tmp_cash*tmp_cut_size;
            //query
            SQLQuery('UPDATE users_stats SET hash="'+tmp_hash+'", cash_tot="'+FloatToStrF(tmp_cash_tot,ffFixed,24,2)+'", cash="'+FloatToStrF(tmp_cash,ffFixed,24,2)+'", cash_cut="'+FloatToStrF(tmp_cash_cut,ffFixed,24,2)+'" WHERE hash="'+HardwareID+'"');

          end else begin
            if m_sql_log.Visible then m_sql_log.Lines.Add('DONE - UserSTATS: User do not exist. Creating.');
            SQLQuery('INSERT INTO users_stats VALUES ("'+HardwareID+'","0.25","100","'+FloatToStrF(REAL_Balance,ffFixed,24,2)+'","'+FloatToStrF(REAL_Balance,ffFixed,24,2)+'","'+FloatToStrF(REAL_Balance*0.25,ffFixed,24,2)+'","0")');
          end;

      end;
      SqlDisconnect;

    end;
    if d_button then MainForm.b_clear.Enabled:=True;
  except
    MainForm.RepError('Error code: SQ-001');
  end;
end;


procedure TSqlForm.UpdateStatus(const s:string);
begin
  try
    ConfigForm.l_status.Caption:=s;
    KeyboardForm.l_status1.Caption:=s;
    KeyboardForm.l_status2.Caption:=s;
    Application.ProcessMessages;
  except
    MainForm.RepError('Error code: SQ-002');
  end;
end;


procedure TSqlForm.MakeUpdate(const file_patch:widestring);
begin
  try
    if MessageDlg('New version availible. Would you like to download and instal it now?',mtConfirmation,[mbYes,mbNo], 0)=mrYes then begin
    MainForm.Visible:=False;
    KeyboardForm.Visible:=False;
    UpdateForm.Visible:=True;
    with UpdateForm do begin
      UpdateForm.l_status.Caption:='...downloading new version.';
      Application.ProcessMessages;
      URL_DownloadFile(file_patch,'~'+system_code+'.tmp');

      UpdateForm.l_status.Caption:='...installing '+system_code+'.';
      Application.ProcessMessages;
      RenameFile(GetModName,'~'+system_code+'_old.tmp');
      RenameFile('~'+system_code+'.tmp',''+system_code+'.exe');

      UpdateForm.l_status.Caption:='...restarting '+system_code+'.';
      Application.ProcessMessages;
      WinExec(PCHAR(system_code+'.exe'),SW_SHOWNORMAL);
      Application.Terminate;
    end;
    KeyboardForm.Close;
  end;
  except
    MainForm.RepError('Error code: SQ-003');
  end;
end;


function TSqlForm.ProcessExists(exeFileName: string): Boolean;
var
  ContinueLoop: BOOL;
  FSnapshotHandle: THandle;
  FProcessEntry32: TProcessEntry32;
begin
  FSnapshotHandle := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
  FProcessEntry32.dwSize := SizeOf(FProcessEntry32);
  ContinueLoop := Process32First(FSnapshotHandle, FProcessEntry32);
  Result := False;
  while Integer(ContinueLoop) <> 0 do
  begin
    if ((UpperCase(ExtractFileName(FProcessEntry32.szExeFile)) =
      UpperCase(ExeFileName)) or (UpperCase(FProcessEntry32.szExeFile) =
      UpperCase(ExeFileName))) then
    begin
      Result := True;
    end;
    ContinueLoop := Process32Next(FSnapshotHandle, FProcessEntry32);
  end;
  CloseHandle(FSnapshotHandle);
end;


function TSqlForm.GetModName: String;
 var
    fName: String;
    nsize: cardinal;
 begin
    nsize := 128;
    SetLength(fName,nsize) ;
    SetLength(fName,
              GetModuleFileName(
                hinstance,
                pchar(fName),
                nsize)) ;
    Result := fName;
 end;


procedure TSqlForm.LoadRemoteSettings;
var desc:string;
    fdt:string;
begin
  try
  Screen.Cursor:=crHourglass;
  SQLConnect;
  if FMysql.Connected then begin

    ConfigForm.SSStatus('...verifying authentication.');
    //check_auth
    SQLQuery('SELECT appon FROM '+LowerCase(System_CODE)+'_auth WHERE hash="'+HardwareID+'"');
    if FResult.FieldValue(0)<>nil then begin
      if m_sql_log.Visible then m_sql_log.Lines.Add('DONE - LRS: Auth loaded succesfully.');
      //terminate banned ppl
      if FResult.FieldValue(0)='0' then begin
        Screen.Cursor:=crDefault;
        MessageDlg('You are not allowed to use this software!',mtWarning,[mbOK], 0);
        Halt;
      end;

    //if no auth data exist
    end else begin
      //check if auth request exist
      SQLQuery('SELECT * FROM auth_req WHERE app="'+LowerCase(System_CODE)+'" AND hash="'+HardwareID+'"');
      if FResult.FieldValue(0)=nil then begin
        //send auth_request
        repeat
          if not InputQuery(System_CODE, 'Please enter your name or email address.', desc)
            then begin
              Screen.Cursor:=crDefault;
              Halt;
            end;
        until desc <> '';
        DateTimeToString(fdt, 'yyyy-mm-dd', NOW);
        SQLQuery('INSERT INTO '+LowerCase(System_CODE)+'_auth VALUES ("'+HardwareID+'","1","['+appVER+'] '+desc+'","'+fdt+'")');
      end;
      Screen.Cursor:=crDefault;
      //MessageDlg('Your data have been send to the server. Please await approval.',mtInformation,[mbOK], 0);
      //Halt;
    end;

    ConfigForm.SSStatus('...checking updates.');
    //check updates
    SQLQuery('SELECT * FROM '+LowerCase(System_CODE)+'_cfg');
    if FResult.FieldValue(0)<>nil then begin
      if m_sql_log.Visible then m_sql_log.Lines.Add('DONE - LRS: Config loaded succesfully.');

      if CheckUpdate(StrToInt(FResult.FieldValue(1))) then
        MakeUpdate(FResult.FieldValue(2));

    end else begin
      if m_sql_log.Visible then m_sql_log.Lines.Add('ERROR - LRS: Loading config failed.');
    end;

    ConfigForm.SSStatus('...loading software list.');
    FindSoftware;


  end else begin
    Screen.Cursor:=crDefault;
    MessageDlg('[SERVER Error] Cannot connect to the server! Please check your firewall setting or contact software distributor.',mtWarning,[mbOK], 0);
    Halt;
    if m_sql_log.Visible then m_sql_log.Lines.Add('ERROR - LRS: SQL not connected.');
  end;

  if FileExists('~'+system_code+'_old.tmp') then begin
    ConfigForm.SSStatus('...clearing old updates.');
    while processExists('~'+system_code+'_old.tmp') do sleep(1);
    SysUtils.DeleteFile('~'+system_code+'_old.tmp');
  end;
  SQLDisconnect;
  Screen.Cursor:=crDefault;
  except
    MainForm.RepError('Error code: SQ-004');
  end;
end;


function TSqlForm.CheckUpdate(const newVer:integer):Boolean;
var i_tmp:integer;
    s_tmp:string;
begin
  s_tmp:=StringReplace(appVer,'.','',[rfReplaceAll]);
  s_tmp:=StringReplace(s_tmp,'b','',[rfReplaceAll]);
  i_tmp:=StrToInt(s_tmp);

  if newVer>i_tmp then Result:=True else Result:=False;
end;


procedure TSqlForm.URL_OnDownloadProgress;
begin
  UpdateForm.bar_download.Max:= ProgressMax;
  UpdateForm.bar_download.Position:= Progress;
  Application.ProcessMessages;
end;


function TSqlForm.URL_DownloadFile(const RemoteFile, LocalFile : TFileName) : boolean;
begin
  Result:=True;
  try
  with TDownLoadURL.Create(nil) do
  try
    URL:=RemoteFile;
    Filename:=LocalFile;
    OnDownloadProgress:=URL_OnDownloadProgress;
    try
      ExecuteTarget(nil);
    except
      Result:=False;
    end;
  finally
    Free;
  end;
  except
    MainForm.RepError('Error code: SQ-006');
  end;
end;


procedure TSqlForm.LoadUserData;
var reg:TRegistry;
begin
  try
  //LOAD REGISTRY DATA
  reg:=TRegistry.Create(KEY_READ OR $0100);
  with reg do begin
    try
      reg.RootKey := HKEY_LOCAL_MACHINE;
      if reg.OpenKey('SOFTWARE\Ophis\'+system_code+'\config\'+SoftwareCODE, TRUE) then begin
        with ConfigForm do begin
          if reg.ReadString('e_un')<>'' then e_un.Text:=reg.ReadString('e_un')
            else e_un.Text:='';
          if reg.ReadString('e_up')<>'' then e_up.Text:=reg.ReadString('e_up')
            else e_up.Text:='';
          if reg.ReadString('e_bankroll')<>'' then e_bankroll.Text:=reg.ReadString('e_bankroll')
            else e_bankroll.Text:='';

          if reg.ReadString('cb_demo')<>'' then begin
            if reg.ReadString('cb_demo')='1' then cb_demo.Checked:=True else cb_demo.Checked:=False;
          end else cb_demo.Checked:=True;
          if reg.ReadString('cb_real')<>'' then begin
            if reg.ReadString('cb_real')='1' then cb_real.Checked:=True else cb_real.Checked:=False;
          end else cb_real.Checked:=False;
          if (not cb_real.Checked) and (not cb_demo.Checked) then cb_demo.Checked:=True;

          if reg.ReadString('cb_session_relog')<>'' then begin
            if reg.ReadString('cb_session_relog')='1' then cb_session_relog.Checked:=True else cb_session_relog.Checked:=False;
          end else cb_session_relog.Checked:=False;
          if reg.ReadString('cb_session_reset')<>'' then begin
            if reg.ReadString('cb_session_reset')='1' then cb_session_reset.Checked:=True else cb_session_reset.Checked:=False;
          end else cb_session_reset.Checked:=True;
          if (not cb_session_reset.Checked) and (not cb_session_relog.Checked) then cb_session_reset.Checked:=True;

          if reg.ReadString('cb_global_relog')<>'' then begin
            if reg.ReadString('cb_global_relog')='1' then cb_global_relog.Checked:=True else cb_global_relog.Checked:=False;
          end else cb_global_relog.Checked:=False;
          if reg.ReadString('cb_global_stop')<>'' then begin
            if reg.ReadString('cb_global_stop')='1' then cb_global_stop.Checked:=True else cb_global_stop.Checked:=False;
          end else cb_global_stop.Checked:=True;
          if (not cb_global_stop.Checked) and (not cb_global_relog.Checked) then cb_global_stop.Checked:=True;

          if reg.ReadString('cb_dummer')<>'' then begin
            if reg.ReadString('cb_dummer')='1' then cb_dummer.Checked:=True else cb_dummer.Checked:=False;
          end else cb_dummer.Checked:=False;
          if reg.ReadString('cb_dummer_on')<>'' then begin
            if reg.ReadString('cb_dummer_on')='1' then cb_dummer_on.Checked:=True else cb_dummer_on.Checked:=False;
          end else cb_dummer_on.Checked:=False;
          if reg.ReadString('cb_dummer_off')<>'' then begin
            if reg.ReadString('cb_dummer_off')='1' then cb_dummer_off.Checked:=True else cb_dummer_off.Checked:=False;
          end else cb_dummer_off.Checked:=False;

          if reg.ReadString('e_dummer_on')<>'' then
            e_dummer_on.Text:=reg.ReadString('e_dummer_on')
          else e_dummer_on.Text:='LLLL';
          if reg.ReadString('e_dummer_off')<>'' then
            e_dummer_off.Text:=reg.ReadString('e_dummer_off')
          else e_dummer_off.Text:='LLLLWW';

          if reg.ReadString('e_profit_limit')<>'' then
            e_profit_limit.Text:=reg.ReadString('e_profit_limit')
          else e_profit_limit.Text:='200';
          if reg.ReadString('e_loss_limit')<>'' then
            e_loss_limit.Text:=reg.ReadString('e_loss_limit')
          else e_loss_limit.Text:='-1000';
          if reg.ReadString('e_global_profit_limit')<>'' then
            e_global_profit_limit.Text:=reg.ReadString('e_global_profit_limit')
          else e_global_profit_limit.Text:='5000';
          if reg.ReadString('e_global_loss_limit')<>'' then
            e_global_loss_limit.Text:=reg.ReadString('e_global_loss_limit')
          else e_global_loss_limit.Text:='-2000';

          if reg.ReadString('e_stats_path')<>'' then
            e_stats_path.Text:=reg.ReadString('e_stats_path')
          else e_stats_path.Text:='';

          if reg.ReadString('cb_profit_limit')<>'' then begin
            if reg.ReadString('cb_profit_limit')='1' then cb_profit_limit.Checked:=True else cb_profit_limit.Checked:=False;
          end else cb_profit_limit.Checked:=False;
          if reg.ReadString('cb_loss_limit')<>'' then begin
            if reg.ReadString('cb_loss_limit')='1' then cb_loss_limit.Checked:=True else cb_loss_limit.Checked:=False;
          end else cb_loss_limit.Checked:=False;

          if reg.ReadString('cb_global_profit_limit')<>'' then begin
            if reg.ReadString('cb_global_profit_limit')='1' then cb_global_profit_limit.Checked:=True else cb_global_profit_limit.Checked:=False;
          end else cb_global_profit_limit.Checked:=False;
          if reg.ReadString('cb_global_loss_limit')<>'' then begin
            if reg.ReadString('cb_global_loss_limit')='1' then cb_global_loss_limit.Checked:=True else cb_global_loss_limit.Checked:=False;
          end else cb_global_loss_limit.Checked:=False;

          if reg.ReadString('cb_save_stats')<>'' then begin
            if reg.ReadString('cb_save_stats')='1' then cb_save_stats.Checked:=True else cb_save_stats.Checked:=False;
          end else cb_save_stats.Checked:=False;

          if reg.ReadString('cb_sp')<>'' then begin
            if reg.ReadString('cb_sp')='1' then cb_sp.Checked:=True else cb_sp.Checked:=False;
          end else cb_sp.Checked:=False;
          if reg.ReadString('cb_sp_1')<>'' then begin
            if reg.ReadString('cb_sp_1')='1' then cb_sp_1.Checked:=True else cb_sp_1.Checked:=False;
          end else cb_sp_1.Checked:=False;
          if reg.ReadString('cb_sp_2')<>'' then begin
            if reg.ReadString('cb_sp_2')='1' then cb_sp_2.Checked:=True else cb_sp_2.Checked:=False;
          end else cb_sp_2.Checked:=False;
          if reg.ReadString('e_sp_1')<>'' then
            e_sp_1.Text:=reg.ReadString('e_sp_1')
          else e_sp_1.Text:='L';
          if reg.ReadString('e_sp_1_ammount')<>'' then
            e_sp_1_ammount.Text:=reg.ReadString('e_sp_1_ammount')
          else e_sp_1_ammount.Text:='1';
          if reg.ReadString('e_sp_2')<>'' then
            e_sp_2.Text:=reg.ReadString('e_sp_2')
          else e_sp_2.Text:='W';
          if reg.ReadString('e_sp_2_ammount')<>'' then
            e_sp_2_ammount.Text:=reg.ReadString('e_sp_2_ammount')
          else e_sp_2_ammount.Text:='-1';

        end;
      end;
      reg.CloseKey
    finally
      reg.Free;
    end;
  end;
  except
    MainForm.RepError('Error code: SQ-007');
  end;

end;


procedure TSqlForm.LoadCoins;
var reg:TRegistry;
    i,j:integer;
    s_tmp:string;
begin
  try
  //LOAD DB DATA
  if db_coins=nil then begin
    SQLQuery('SELECT v1 FROM '+SoftwareCODE+'_cfg WHERE name="coins"');
    if FResult.FieldValue(0)<>nil then begin
      SetLength(db_coins,StrToInt(FResult.FieldValue(0))+1);
      db_coins[0]:=StrToFloat(FResult.FieldValue(0));
      if m_sql_log.Visible then m_sql_log.Lines.Add('DONE - LoadCoins: Ammount of coins loaded.');
    end else begin
      if m_sql_log.Visible then m_sql_log.Lines.Add('ERROR - LoadCoins: Ammount of coins empty.');
    end;

    for i:=1 to Trunc(db_coins[0]) do begin
      SQLQuery('SELECT v1 FROM '+SoftwareCODE+'_cfg WHERE name="coin'+IntToStr(i)+'"');
      if FResult.FieldValue(0)<>nil then begin
        db_coins[i]:=StrToFloat(FResult.FieldValue(0));
        if m_sql_log.Visible then m_sql_log.Lines.Add('DONE - LoadCoins: Coin'+IntToStr(i)+' loaded.');
      end else begin
        if m_sql_log.Visible then m_sql_log.Lines.Add('ERROR - LoadCoins: Coin'+IntToStr(i)+' empty.');
      end;
    end;

  end; //if db_coins=nil

  //LOAD REGISTRY DATA
  reg:=TRegistry.Create(KEY_READ OR $0100);
  with reg do begin
    try
      reg.RootKey := HKEY_LOCAL_MACHINE;
      if reg.OpenKey('SOFTWARE\Ophis\'+system_code+'\config\'+SoftwareCODE, TRUE) then begin
        with ConfigForm do begin
          for i:=1 to Trunc(db_coins[0]) do begin
            if reg.ReadString('e_coin'+IntToStr(i))<>'' then
              if StrToFloat(reg.ReadString('e_coin'+IntToStr(i)))<>db_coins[i] then
                db_coins[i]:=StrToFloat(reg.ReadString('e_coin'+IntToStr(i)));
            if reg.ReadString('cb_coin'+IntToStr(i))<>'' then
              if reg.ReadString('cb_coin'+IntToStr(i))='1' then
                with ConfigForm do
                  (FindComponent('cb_coin'+IntToStr(i)) as TALRadioButton).Checked:=True;
          end;
          if reg.ReadString('e_manual')<>'' then e_manual.Text:=reg.ReadString('e_manual')
            else e_manual.Text:='0';
          if reg.ReadString('pb_delay')<>'' then begin
            pb_delay.Position:=StrToInt(reg.ReadString('pb_delay'));
            SoftwareDELAY:=pb_delay.Position;
          end else pb_delay.Position:=SoftwareDELAY;
        end;
      end;
      reg.CloseKey
    finally
      reg.Free;
    end;
  end;

  for i:=1 to 9 do
    with ConfigForm do begin
      (FindComponent('e_coin'+IntToStr(i)) as TALEdit).Text:='';
      (FindComponent('e_coin'+IntToStr(i)) as TALEdit).Visible:=False;
      (FindComponent('cb_coin'+IntToStr(i)) as TALRadioButton).Visible:=False;

    end;

  for i:=1 to Trunc(db_coins[0]) do
    with ConfigForm do begin
      (FindComponent('e_coin'+IntToStr(i)) as TALEdit).Visible:=True;
      (FindComponent('cb_coin'+IntToStr(i)) as TALRadioButton).Visible:=True;
      (FindComponent('e_coin'+IntToStr(i)) as TALEdit).Text:=FloatToStr(db_coins[i]);
    end;

  if ConfigForm.e_manual.Text='0' then
    ConfigForm.e_manual.Text:=ConfigForm.e_coin1.Text;

    
  //COINS COVERSION
  for i:=1 to Trunc(db_coins[0]) do
    with ConfigForm do
      if (FindComponent('cb_coin'+IntToStr(i)) as TALRadioButton).Checked then begin

        SetLength(a_coins,Trunc(db_coins[0])-(i-1));
        for j:=low(a_coins) to high(a_coins) do SetLength(a_coins[j],2);

        for j:=low(a_coins) to High(a_coins) do begin
          if (db_coins[j+i]<>0) and (db_coins[i]<>0) then begin
            s_tmp:=FloatToStr(db_coins[j+i]/db_coins[i]);
            if not AnsiContainsStr(s_tmp,'.') then begin
              a_coins[j,0]:=StrToInt(s_tmp);
              a_coins[j,1]:=j+i;
            end else begin
              a_coins[j,0]:=0;
              a_coins[j,1]:=0;
            end;
          end;  
        end;

        Break;
      end;

{    if a_coins<>nil then begin
      for i:=low(a_coins) to high(a_coins) do begin
        if i=low(a_coins) then begin
          ConfigForm.Label2.Caption:=IntToStr(a_coins[i,0]);
          ConfigForm.Label3.Caption:=IntToStr(a_coins[i,1]);

        end else begin
          ConfigForm.Label2.Caption:=ConfigForm.Label2.Caption+' '+IntToStr(a_coins[i,0]);
          ConfigForm.Label3.Caption:=ConfigForm.Label3.Caption+' '+IntToStr(a_coins[i,1]);

        end;
      end;
    end;
}
  except
    MainForm.RepError('Error code: SQ-008');
  end;
end;


procedure TSqlForm.LoadSoftware;
var i,j:integer;
begin
  try
  Screen.Cursor:=crHourGlass;
  ConfigForm.KeyboardState(False);
  ConfigForm.ControlsState(False);
  ConfigForm.SoftwareState(False);
  SQLConnect;
  if FMysql.Connected then begin
    if ConfigForm.c_software.Text<>'' then begin

      UpdateStatus('loading software settings...');
      SQLQuery('SELECT code FROM software_list WHERE name="'+ConfigForm.c_software.Text+'"');

      if FResult.FieldValue(0)<>nil then begin
        SoftwareCODE:=FResult.FieldValue(0);

        if m_sql_log.Visible then m_sql_log.Lines.Add('DONE - FindSoftware: SoftwareCODE loaded.');
      end else begin
      if m_sql_log.Visible then m_sql_log.Lines.Add('ERROR - FindSoftware: SoftwareCODE results empty.');
      end;


      UpdateStatus('loading OCR hashes...');
      SQLQuery('SELECT * FROM '+SoftwareCODE+'_h');

      if FResult.FieldValue(0)<>nil then begin
        SetLength(a_hash,FResult.RowsCount);
        for i:=low(a_hash) to high(a_hash) do SetLength(a_hash[i],FResult.FieldsCount);

        for i:=0 to FResult.RowsCount-1 do begin
          for j:=0 to FResult.FieldsCount-1 do
            a_hash[i,j]:=FResult.FieldValue(j);
          FResult.Next;
        end;

        for i:=low(a_hash) to high(a_hash) do begin
          for j:=low(a_hash) to high(a_hash) do begin
            if i<>j then
              if a_hash[i,1]=a_hash[j,1] then
                raise Exception.Create('[DB Error] Hashes duplicated. ('+a_hash[i,0]+'='+a_hash[j,0]+')');
          end;
        end;

        if m_sql_log.Visible then m_sql_log.Lines.Add('DONE - LoadSoftware: Hashes loaded into array.');
      end else begin
        if m_sql_log.Visible then m_sql_log.Lines.Add('ERROR - LoadSoftware: Hashes results empty.');
      end;


      UpdateStatus('loading table coordinates...');
      SQLQuery('SELECT * FROM '+SoftwareCODE+'_c');

      if FResult.FieldValue(0)<>nil then begin
        SetLength(a_coords,FResult.RowsCount);
        for i:=low(a_coords) to high(a_coords) do SetLength(a_coords[i],FResult.FieldsCount);

        for i:=0 to FResult.RowsCount-1 do begin
          for j:=0 to FResult.FieldsCount-1 do begin
            a_coords[i,j]:=FResult.FieldValue(j);
          end;
          FResult.Next;
        end;

        if m_sql_log.Visible then m_sql_log.Lines.Add('DONE - LoadSoftware: Coords loaded into array.');
      end else begin
        if m_sql_log.Visible then m_sql_log.Lines.Add('ERROR - LoadSoftware: Coords results empty.');
      end;


      UpdateStatus('loading OCR coordinates...');
      SQLQuery('SELECT * FROM '+SoftwareCODE+'_cfg WHERE name="number_coords"');

      if FResult.FieldValue(0)<>nil then begin
        SetLength(a_ss_number,FResult.FieldsCount-1);

        for i:=1 to FResult.FieldsCount-1 do begin
          a_ss_number[i-1]:=StrToInt(FResult.FieldValue(i));
        end;

        if m_sql_log.Visible then m_sql_log.Lines.Add('DONE - LoadSoftware: SS Coords for Numbers loaded into array.');
      end else begin
        if m_sql_log.Visible then m_sql_log.Lines.Add('ERROR - LoadSoftware: SS Coords results empty.');
      end;

      SQLQuery('SELECT * FROM '+SoftwareCODE+'_cfg WHERE name="status_coords"');

      if FResult.FieldValue(0)<>nil then begin
        SetLength(a_ss_status,FResult.FieldsCount-1);

        for i:=1 to FResult.FieldsCount-1 do begin
          a_ss_status[i-1]:=StrToInt(FResult.FieldValue(i));
        end;

        if m_sql_log.Visible then m_sql_log.Lines.Add('DONE - LoadSoftware: SS Coords for Status loaded into array.');
      end else begin
        if m_sql_log.Visible then m_sql_log.Lines.Add('ERROR - LoadSoftware: SS Coords results empty.');
      end;

      SQLQuery('SELECT * FROM '+SoftwareCODE+'_cfg WHERE name="message_coords"');

      if FResult.FieldValue(0)<>nil then begin
        SetLength(a_ss_message,FResult.FieldsCount-1);

        for i:=1 to FResult.FieldsCount-1 do begin
          a_ss_message[i-1]:=StrToInt(FResult.FieldValue(i));
        end;

        if m_sql_log.Visible then m_sql_log.Lines.Add('DONE - LoadSoftware: SS Coords for Status loaded into array.');
      end else begin
        if m_sql_log.Visible then m_sql_log.Lines.Add('ERROR - LoadSoftware: SS Coords results empty.');
      end;


      UpdateStatus('loading coins values...');
      SQLQuery('SELECT v1 FROM '+SoftwareCODE+'_cfg WHERE name="type"');

      if FResult.FieldValue(0)<>nil then begin
        SoftwareTYPE:=FResult.FieldValue(0);

        if m_sql_log.Visible then m_sql_log.Lines.Add('DONE - LoadSoftware: Software TYPE loaded.');
      end else begin
        if m_sql_log.Visible then m_sql_log.Lines.Add('ERROR - LoadSoftware: Software TYPE empty.');
      end;

      SQLQuery('SELECT v1 FROM '+SoftwareCODE+'_cfg WHERE name="delay"');

      if FResult.FieldValue(0)<>nil then begin
        SoftwareDELAY:=StrToInt(FResult.FieldValue(0));

        if m_sql_log.Visible then m_sql_log.Lines.Add('DONE - LoadSoftware: Software DELAY loaded.');
      end else begin
        if m_sql_log.Visible then m_sql_log.Lines.Add('ERROR - LoadSoftware: Software DELAY empty.');
      end;
      
      UpdateStatus('loading user data...');
      LoadUserData;

      UpdateStatus('updating coins value...');
      LoadCoins;
      ConfigForm.ControlsState(True);
      UpdateStatus('validating coins...');
      ConfigForm.ValidateManual;

      UpdateStatus('Software loading completed.');
      ConfigForm.RealMoneyState(ConfigForm.cb_real.Checked);
    end;
  end else begin
    if m_sql_log.Visible then m_sql_log.Lines.Add('ERROR - LoadSoftware: SQL not connected.');
  end;
  finally
    MainForm.b_play.Enabled:=True;
    MainForm.b_play.Font.Color:=clLime;
    Screen.Cursor:=crDefault;
    ConfigForm.KeyboardState(True);
    ConfigForm.SoftwareState(True);
    SQLDisconnect;
  end;
end;




procedure TSqlForm.FindSoftware;
var i:integer;
begin
  try
  Screen.Cursor:=crHourGlass;
  SQLConnect;
  if FMysql.Connected then begin
    SQLQuery('SELECT name FROM software_list');

    if FResult.FieldValue(0)<>nil then begin
      ConfigForm.c_software.Items.Clear;
      for i:=0 to FResult.RowsCount-1 do begin
        if not AnsiContainsStr(FResult.FieldValue(0),'[dev]') then
          ConfigForm.c_software.Items.Add(FResult.FieldValue(0));
        FResult.Next;
      end;

      if m_sql_log.Visible then m_sql_log.Lines.Add('DONE - FindSoftware: Results loaded into list.');
    end else begin
      if m_sql_log.Visible then m_sql_log.Lines.Add('ERROR - FindSoftware: Results Empty.');
    end;
  end else begin
    if m_sql_log.Visible then m_sql_log.Lines.Add('ERROR - FindSoftware: SQL not connected.');
  end;
  SQLDisconnect;
  Screen.Cursor:=crDefault;
  except
    MainForm.RepError('Error code: SQ-009');
  end;
end;


procedure TSqlForm.SQLConnect(const s_db:string='ophis_botsdata');
begin
try
  Screen.Cursor:=crHourGlass;

	//sql_info_here

  FMysql.Db:=s_db;
  FMysql.Compress:=True;
  FMysql.ShouldReconnect:=True;
  FMysql.NoTimeOut:=True;
  if FMysql.Connect then begin
    if KeyboardForm.l_sql_status.Visible then KeyboardForm.l_sql_status.Font.Color:=clGreen;
    if m_sql_log.Visible then m_sql_log.Lines.Add('DONE - SQLConnect: Connection successful.');
  end else begin
    if KeyboardForm.l_sql_status.Visible then KeyboardForm.l_sql_status.Font.Color:=clRed;
    if m_sql_log.Visible then m_sql_log.Lines.Add('ERROR - SQLConnect: Cant connect to SQL.');
  end;
  Screen.Cursor:=crDefault;  
  except
    MainForm.RepError('Error code: SQ-010');
  end;
end;


procedure TSqlForm.SQLDisconnect;
begin
  try
  if FMysql.Connected then begin
    FMysql.close;
    if KeyboardForm.l_sql_status.Visible then KeyboardForm.l_sql_status.Font.Color:=clSilver;
    if m_sql_log.Visible then m_sql_log.Lines.Add('DONE - SQLDisconnect: DC Completed.');
  end else begin
    if m_sql_log.Visible then m_sql_log.Lines.Add('ERROR - SQLDisconnect: SQL is not connected.');
  end;
  except
    MainForm.RepError('Error code: SQ-011');
  end;
end;


procedure TSqlForm.SQLQuery(const q:widestring);
var ex:boolean;
begin
  try
  if FMysql.Connected then begin
    if assigned(FResult) then FreeAndNil(FResult);

    if q<>'' then begin
      FResult:=FMysql.query(q,true,ex);
    end else begin
      FreeAndNil(FResult);
    end;

    if ex then begin
      if m_sql_log.Visible then m_sql_log.Lines.Add('DONE - QUERY: '+q);
    end else begin
      if m_sql_log.Visible then m_sql_log.Lines.Add('ERROR - QUERY: '+FMysql.LastError);
    end;
  end else begin
    if m_sql_log.Visible then m_sql_log.Lines.Add('ERROR - QUERY: SQL not connected!');
  end;
  except
    MainForm.RepError('Error code: SQ-012');
  end;
end;


procedure TSqlForm.FormCreate(Sender: TObject);
begin
  FMysql:=TMysqlClient.Create;
end;


end.
