unit sys_config;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons, ALPanel, Registry,
  ALButton, ALEdit, ComCtrls;

type
  TSysConfig = class(TForm)
    form_box: TALPanel;
    bClose: TSpeedButton;
    l_header: TLabel;
    s_header: TShape;
    ALPanel3: TALPanel;
    ALPanel4: TALPanel;
    ALPanel5: TALPanel;
    e_s9_reset: TALEdit;
    cb_s9: TALCheckBox;
    Label18: TLabel;
    cb_s9_flat: TALRadioButton;
    cb_s9_inside: TALRadioButton;
    cb_s9_outside: TALRadioButton;
    ALPanel1: TALPanel;
    e_s9_min_profit: TALEdit;
    Label1: TLabel;
    Label2: TLabel;
    e_s9_max_units: TALEdit;
    Label3: TLabel;
    cb_s9_max: TALRadioButton;
    cb_s9_reset: TALRadioButton;
    cb_s9_reset_game: TALCheckBox;
    Label4: TLabel;
    e_s9_freeze: TALEdit;
    ALPanel2: TALPanel;
    cb_s9_outside_1: TALCheckBox;
    cb_s9_outside_2: TALCheckBox;
    e_s9_outside_2: TALEdit;
    e_s9_outside_1: TALEdit;
    Label10: TLabel;
    Label12: TLabel;
    e_s9_outside_2_ammount: TALEdit;
    e_s9_outside_1_ammount: TALEdit;
    Label13: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    e_s9_outside_max_units: TALEdit;
    label44: TLabel;
    e_s9_outside_freeze: TALEdit;
    Label8: TLabel;
    cb_s9_outside_max: TALRadioButton;
    cb_s9_outside_reset: TALRadioButton;
    procedure form_boxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure bCloseClick(Sender: TObject);
    procedure cb_cornersClick(Sender: TObject);
    procedure cb_dsClick(Sender: TObject);
    procedure cb_s3Click(Sender: TObject);
    procedure cb_dssClick(Sender: TObject);
    procedure cb_adssClick(Sender: TObject);
  private
    procedure LoadSettings;
    procedure SaveSettings;
    procedure WMNCHitTest(var Msg: TWMNCHitTest) ; message WM_NCHitTest;
  public
    procedure UpdateCB;
  end;

var
  SysConfig: TSysConfig;

implementation

uses  main_form, config_form;

{$R *.dfm}


procedure TSysConfig.LoadSettings;
var reg:TRegistry;
begin
  try
   reg:=TRegistry.Create(KEY_READ OR $0100);
   with reg do begin
    try
      reg.RootKey := HKEY_LOCAL_MACHINE;
      if reg.OpenKey('SOFTWARE\Ophis\'+system_code+'\sysconfig', TRUE) then begin
        if reg.ReadString('top')<>'' then SysConfig.Top:=StrToInt(reg.ReadString('top'))
        else SysConfig.Top:=Trunc(Screen.Height/2-SysConfig.Height/2);
        if reg.ReadString('left')<>'' then SysConfig.Left:=StrToInt(reg.ReadString('left'))
        else SysConfig.Left:=Trunc(Screen.Width/2-SysConfig.Width/2);

        if reg.ReadString('cb_s9')<>'' then begin
          if reg.ReadString('cb_s9')='1' then cb_s9.Checked:=True else cb_s9.Checked:=False;
        end else cb_s9.Checked:=True;
        if reg.ReadString('e_s9_reset')<>'' then
          e_s9_reset.Text:=reg.ReadString('e_s9_reset')
        else e_s9_reset.Text:='2';

        if reg.ReadString('cb_s9_flat')<>'' then begin
          if reg.ReadString('cb_s9_flat')='1' then cb_s9_flat.Checked:=True else cb_s9_flat.Checked:=False;
        end else cb_s9_flat.Checked:=True;

        if reg.ReadString('cb_s9_inside')<>'' then begin
          if reg.ReadString('cb_s9_inside')='1' then cb_s9_inside.Checked:=True else cb_s9_inside.Checked:=False;
        end else cb_s9_inside.Checked:=False;
        if reg.ReadString('e_s9_min_profit')<>'' then
          e_s9_min_profit.Text:=reg.ReadString('e_s9_min_profit')
        else e_s9_min_profit.Text:='1';
        if reg.ReadString('e_s9_max_units')<>'' then
          e_s9_max_units.Text:=reg.ReadString('e_s9_max_units')
        else e_s9_max_units.Text:='500';
        if reg.ReadString('e_s9_freeze')<>'' then
          e_s9_freeze.Text:=reg.ReadString('e_s9_freeze')
        else e_s9_freeze.Text:='10';
        if reg.ReadString('cb_s9_max')<>'' then begin
          if reg.ReadString('cb_s9_max')='1' then cb_s9_max.Checked:=True else cb_s9_max.Checked:=False;
        end else cb_s9_max.Checked:=True;
        if reg.ReadString('cb_s9_reset')<>'' then begin
          if reg.ReadString('cb_s9_reset')='1' then cb_s9_reset.Checked:=True else cb_s9_reset.Checked:=False;
        end else cb_s9_reset.Checked:=False;
        if reg.ReadString('cb_s9_reset_game')<>'' then begin
          if reg.ReadString('cb_s9_reset_game')='1' then cb_s9_reset_game.Checked:=True else cb_s9_reset_game.Checked:=False;
        end else cb_s9_reset_game.Checked:=False;

        if reg.ReadString('cb_s9_outside')<>'' then begin
          if reg.ReadString('cb_s9_outside')='1' then cb_s9_outside.Checked:=True else cb_s9_outside.Checked:=False;
        end else cb_s9_outside.Checked:=False;
        if reg.ReadString('cb_s9_outside_1')<>'' then begin
          if reg.ReadString('cb_s9_outside_1')='1' then cb_s9_outside_1.Checked:=True else cb_s9_outside_1.Checked:=False;
        end else cb_s9_outside_1.Checked:=True;
        if reg.ReadString('e_s9_outside_1')<>'' then
          e_s9_outside_1.Text:=reg.ReadString('e_s9_outside_1')
        else e_s9_outside_1.Text:='L';
        if reg.ReadString('e_s9_outside_1_ammount')<>'' then
          e_s9_outside_1_ammount.Text:=reg.ReadString('e_s9_outside_1_ammount')
        else e_s9_outside_1_ammount.Text:='1';
        if reg.ReadString('cb_s9_outside_2')<>'' then begin
          if reg.ReadString('cb_s9_outside_2')='1' then cb_s9_outside_2.Checked:=True else cb_s9_outside_2.Checked:=False;
        end else cb_s9_outside_2.Checked:=True;
        if reg.ReadString('e_s9_outside_2')<>'' then
          e_s9_outside_2.Text:=reg.ReadString('e_s9_outside_2')
        else e_s9_outside_2.Text:='W';
        if reg.ReadString('e_s9_outside_2_ammount')<>'' then
          e_s9_outside_2_ammount.Text:=reg.ReadString('e_s9_outside_2_ammount')
        else e_s9_outside_2_ammount.Text:='-1';

        if reg.ReadString('e_s9_outside_max_units')<>'' then
          e_s9_outside_max_units.Text:=reg.ReadString('e_s9_outside_max_units')
        else e_s9_outside_max_units.Text:='500';
        if reg.ReadString('e_s9_outside_freeze')<>'' then
          e_s9_outside_freeze.Text:=reg.ReadString('e_s9_outside_freeze')
        else e_s9_outside_freeze.Text:='10';
        if reg.ReadString('cb_s9_outside_max')<>'' then begin
          if reg.ReadString('cb_s9_outside_max')='1' then cb_s9_outside_max.Checked:=True else cb_s9_outside_max.Checked:=False;
        end else cb_s9_outside_max.Checked:=True;
        if reg.ReadString('cb_s9_outside_reset')<>'' then begin
          if reg.ReadString('cb_s9_outside_reset')='1' then cb_s9_outside_reset.Checked:=True else cb_s9_outside_reset.Checked:=False;
        end else cb_s9_outside_reset.Checked:=False;


      end;
      reg.CloseKey
    finally
      reg.Free;
    end;
  end;

  UpdateCB;
  except
    MainForm.RepError('Error code: SC-001');
  end;
end;


procedure TSysConfig.SaveSettings;
var reg:TRegistry;
begin
  try
   reg:=TRegistry.Create(KEY_WRITE OR $0100);
   with reg do begin
    try
      reg.RootKey := HKEY_LOCAL_MACHINE;
      if reg.OpenKey('SOFTWARE\Ophis\'+system_code+'\sysconfig', TRUE) then begin
        reg.WriteString('top',IntToStr(SysConfig.Top));
        reg.WriteString('left',IntToStr(SysConfig.Left));

        if cb_s9.Checked then reg.WriteString('cb_s9','1') else reg.WriteString('cb_s9','0');
        reg.WriteString('e_s9_reset',e_s9_reset.Text);

        if cb_s9_flat.Checked then reg.WriteString('cb_s9_flat','1') else reg.WriteString('cb_s9_flat','0');

        if cb_s9_inside.Checked then reg.WriteString('cb_s9_inside','1') else reg.WriteString('cb_s9_inside','0');
        reg.WriteString('e_s9_min_profit',e_s9_min_profit.Text);
        reg.WriteString('e_s9_max_units',e_s9_max_units.Text);
        reg.WriteString('e_s9_freeze',e_s9_freeze.Text);
        if cb_s9_max.Checked then reg.WriteString('cb_s9_max','1') else reg.WriteString('cb_s9_max','0');
        if cb_s9_reset.Checked then reg.WriteString('cb_s9_reset','1') else reg.WriteString('cb_s9_reset','0');
        if cb_s9_reset_game.Checked then reg.WriteString('cb_s9_reset_game','1') else reg.WriteString('cb_s9_reset_game','0');

        if cb_s9_outside.Checked then reg.WriteString('cb_s9_outside','1') else reg.WriteString('cb_s9_outside','0');
        if cb_s9_outside_1.Checked then reg.WriteString('cb_s9_outside_1','1') else reg.WriteString('cb_s9_outside_1','0');
        reg.WriteString('e_s9_outside_1',e_s9_outside_1.Text);
        reg.WriteString('e_s9_outside_1_ammount',e_s9_outside_1_ammount.Text);
        if cb_s9_outside_2.Checked then reg.WriteString('cb_s9_outside_2','1') else reg.WriteString('cb_s9_outside_2','0');
        reg.WriteString('e_s9_outside_2',e_s9_outside_2.Text);
        reg.WriteString('e_s9_outside_2_ammount',e_s9_outside_2_ammount.Text);

        reg.WriteString('e_s9_outside_max_units',e_s9_outside_max_units.Text);
        reg.WriteString('e_s9_outside_freeze',e_s9_outside_freeze.Text);
        if cb_s9_outside_max.Checked then reg.WriteString('cb_s9_outside_max','1') else reg.WriteString('cb_s9_outside_max','0');
        if cb_s9_outside_reset.Checked then reg.WriteString('cb_s9_outside_reset','1') else reg.WriteString('cb_s9_outside_reset','0');

      end;
      reg.CloseKey;
    finally
      reg.Free;
    end;
  end;
  except
    MainForm.RepError('Error code: SC-002');
  end;
end;


procedure TSysConfig.WMNCHitTest(var Msg: TWMNCHitTest) ;
begin
  inherited;
  if Msg.Result = htClient then Msg.Result := htCaption;
end;


procedure TSysConfig.form_boxMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  SendMessage(Handle, WM_SYSCOMMAND, 61458, 0) ;
end;


procedure TSysConfig.FormCreate(Sender: TObject);
begin
  LoadSettings;
end;


procedure TSysConfig.FormDestroy(Sender: TObject);
begin
  SaveSettings;
end;


procedure TSysConfig.bCloseClick(Sender: TObject);
begin
  Close;
end;


procedure TSysConfig.UpdateCB;
begin
  try
  with SysConfig.cb_s9 do
    if Checked then
      Font.Color:=clLime else Font.Color:=clRed;

  if Assigned(ConfigForm) then
    with ConfigForm do begin
      with cb_dummer do
        if Checked then
          Font.Color:=clLime else Font.Color:=clRed;
      with cb_sp do
        if Checked then
          Font.Color:=clLime else Font.Color:=clRed;
    end;
  if Assigned(MainForm) then
    with MainForm do begin
      with cb_dummy do
        if Checked then
          Font.Color:=clLime else Font.Color:=clRed;
    end;
  except
    MainForm.RepError('Error code: SC-003');
  end;
end;


procedure TSysConfig.cb_cornersClick(Sender: TObject);
begin
  UpdateCB;
end;


procedure TSysConfig.cb_dsClick(Sender: TObject);
begin
  UpdateCB;
end;


procedure TSysConfig.cb_s3Click(Sender: TObject);
begin
  UpdateCB;
end;


procedure TSysConfig.cb_dssClick(Sender: TObject);
begin
  UpdateCB;
end;


procedure TSysConfig.cb_adssClick(Sender: TObject);
begin
  UpdateCB;
end;

end.
