unit sys_s9;

interface

uses Classes, SysUtils, ALQuickSortList, debug_form, main_form, bot_form, sys_config, strutils;

    function S9HIT:integer;
    procedure S9ToBet;
    procedure S9Progression;
    procedure S9Init;
    procedure S9Free;
    procedure S9Reset;
    procedure S9ColectToBet;
    procedure S9StreetUpdate;
    function S9NtoS(const no:byte):byte;
    procedure S9ResetSession;
    procedure S9RemoveFromStreets;
    procedure S9AssignBets;
    procedure S9MakeHistory;

var
    s9_to_bet:TStringList;

    s9_lw:TStringList;
    s9_s:TALIntegerList;
    s9_s_to_bet:TALIntegerList;
    s9_streets:TALIntegerList;
    s9_profit:TALIntegerList;
    s9_units:TALIntegerList;
    s9_balance:integer=0;
    s9_missing_streets:TStringList;
    s9_reset_session:boolean=False;

    s9_games_lw:TStringList;
    s9_games_loss:integer=0;
    s9_games_balance:integer=0;
    s9_games_progression:boolean=False;

    s9_s_history:TStringList;
    s9_s_count_history:TStringList;
    s9_s_to_bet_history:TStringList;

    s9_lmsc:integer=12;
    s9_loss:integer=0;

    s9_chart:array[0..143,0..1] of string = (
      ('1-1','1,12'),('1-2','1,2'),('1-3','2,3,4'),('1-4','3,4,6'),('1-5','4,5,8'),('1-6','5,6,10'),('1-7','6,7,11'),('1-8','7,8,9'),('1-9','7,8,9'),('1-10','5,9,10'),('1-11','3,10,11'),('1-12','1,11,12'),
      ('2-1','1,10,11'),('2-2','2,12'),('2-3','1,2,3'),('2-4','2,4'),('2-5','3,5,6'),('2-6','4,6,8'),('2-7','5,7,9'),('2-8','6,7,8'),('2-9','5,7,9'),('2-10','3,8,10'),('2-11','1,9,11'),('2-12','10,11,12'),
      ('3-1','1,8,10'),('3-2','2,10,11'),('3-3','3,12'),('3-4','1,2,4'),('3-5','2,4,5'),('3-6','3,6'),('3-7','4,7'),('3-8','5,8'),('3-9','3,6,9'),('3-10','1,7,10'),('3-11','8,11'),('3-12','9,12'),
      ('4-1','1,6,9'),('4-2','2,8,10'),('4-3','3,10,11'),('4-4','4,12'),('4-5','1,2,5'),('4-6','2,4,6'),('4-7','3,5,7'),('4-8','3,4,8'),('4-9','1,5,9'),('4-10','6,10,11'),('4-11','7,9,11'),('4-12','7,8,12'),
      ('5-1','1,4,8'),('5-2','2,6,9'),('5-3','3,8,10'),('5-4','4,10,11'),('5-5','5,12'),('5-6','1,2,6'),('5-7','2,3,7'),('5-8','1,3,8'),('5-9','4,9,11'),('5-10','5,9,10'),('5-11','6,7,11'),('5-12','5,7,12'),
      ('6-1','1,2,7'),('6-2','2,4,8'),('6-3','3,6,9'),('6-4','4,8,10'),('6-5','5,10,11'),('6-6','6,12'),('6-7','1,7'),('6-8','2,8,11'),('6-9','3,9'),('6-10','4,7,10'),('6-11','5,11'),('6-12','3,6,12'),
      ('7-1','1,6'),('7-2','2,3,7'),('7-3','3,5,8'),('7-4','4,7,9'),('7-5','5,9,10'),('7-6','6,11'),('7-7','7,12'),('7-8','1,8,10'),('7-9','2,8,9'),('7-10','3,6,10'),('7-11','4,11'),('7-12','2,5,12'),
      ('8-1','1,3,5'),('8-2','2,5,6'),('8-3','3,7'),('8-4','4,8,9'),('8-5','5,9,11'),('8-6','1,6,10'),('8-7','2,7,11'),('8-8','8,12'),('8-9','1,9,10'),('8-10','2,8,10'),('8-11','3,6,11'),('8-12','4,12'),
      ('9-1','1,4,5'),('9-2','2,5,7'),('9-3','3,6,9'),('9-4','4,7,11'),('9-5','1,5,8'),('9-6','3,6,9'),('9-7','4,7,10'),('9-8','2,8,11'),('9-9','9,12'),('9-10','1,10'),('9-11','2,8,11'),('9-12','3,6,12'),
      ('10-1','1,3,7'),('10-2','2,4,9'),('10-3','3,5,11'),('10-4','1,4,6'),('10-5','3,5,7'),('10-6','5,6,8'),('10-7','6,7,9'),('10-8','4,8,10'),('10-9','2,9,11'),('10-10','10,12'),('10-11','1,10,11'),('10-12','2,8,12'),
      ('11-1','1,2,9'),('11-2','2,3,11'),('11-3','1,3,4'),('11-4','3,4,5'),('11-5','5,6'),('11-6','6,7'),('11-7','7,8'),('11-8','6,8,9'),('11-9','4,9,10'),('11-10','2,10,11'),('11-11','11,12'),('11-12','1,10,12'),
      ('12-1','1,11'),('12-2','1,2'),('12-3','3'),('12-4','4,5'),('12-5','5,7'),('12-6','6,9'),('12-7','7,10'),('12-8','8'),('12-9','6,9'),('12-10','4,10'),('12-11','2,11'),('12-12','12')
    );

implementation


procedure S9ResetSession;
var i:integer;
begin
  s9_s.Clear;
  for i:=1 to 12 do
    s9_s.add(i);

  if SysConfig.cb_s9_reset_game.Checked then s9_balance:=0;
  s9_s_to_bet.Clear;
  s9_missing_streets.Clear;

  if s9_games_balance<0 then begin
    s9_games_lw.Add('L');
    inc(s9_games_loss);
  end else if s9_games_balance>0 then begin
    s9_games_lw.Add('W');
    s9_games_loss:=0;
  end else
    s9_games_lw.Add(' ');

  s9_games_balance:=0;
  s9_games_progression:=True;
  s9_reset_session:=False;
end;


procedure S9StreetUpdate;
begin
  s9_streets.Add(S9NtoS(numbers_list[numbers_list.Count-1]));
end;


procedure S9ColectToBet;
var i:integer;
begin
  s9_to_bet.Clear;

  if (s9_s_to_bet.Count>0) then
    for i:=0 to s9_s_to_bet.Count-1 do
      s9_to_bet.Add('S'+IntToStr(s9_s_to_bet[i]));
end;


function S9NtoS(const no:byte):byte;
begin
  Result:=0;
  if (no>=1) and (no<=3) then
    Result:=1
  else if (no>=4) and (no<=6) then
    Result:=2
  else if (no>=7) and (no<=9) then
    Result:=3
  else if (no>=10) and (no<=12) then
    Result:=4
  else if (no>=13) and (no<=15) then
    Result:=5
  else if (no>=16) and (no<=18) then
    Result:=6
  else if (no>=19) and (no<=21) then
    Result:=7
  else if (no>=22) and (no<=24) then
    Result:=8
  else if (no>=25) and (no<=27) then
    Result:=9
  else if (no>=28) and (no<=30) then
    Result:=10
  else if (no>=31) and (no<=33) then
    Result:=11
  else if (no>=34) and (no<=36) then
    Result:=12;
end;


function S9HIT:integer;
var t_profit,i:integer;
    hit:boolean;
begin
  t_profit:=0;

  if s9_s_to_bet.Count>0 then begin
    hit:=False;
    for i:=0 to s9_s_to_bet.Count-1 do
      if s9_s_to_bet[i]=S9NtoS(numbers_list[numbers_list.Count-1]) then hit:=True;

    if Hit then
      t_profit:=t_profit+(12*s9_units[s9_units.Count-1])-(s9_s_to_bet.Count*s9_units[s9_units.Count-1])
    else
      t_profit:=t_profit-(s9_s_to_bet.Count*s9_units[s9_units.Count-1]);
  end;

  if t_profit>0 then begin
    s9_lw.Add('W');
    s9_loss:=0;
  end else if t_profit<0 then begin
    s9_lw.Add('L');
    inc(s9_loss);
  end else s9_lw.Add(' ');

  s9_balance:=s9_balance+t_profit;
  s9_games_balance:=s9_games_balance+t_profit;
  s9_profit.Add(t_profit);
  Result:=t_profit;
end;


procedure S9AssignMissingStreets;
var tmp_array:array[1..12] of byte;
    i:integer;
    s_tmp:string;
begin
  for i:=low(tmp_array) to high(tmp_array) do
    tmp_array[i]:=0;

  if s9_s.Count>0 then
    for i:=0 to s9_s.Count-1 do
      tmp_array[s9_s[i]]:=1;

  s_tmp:='';
  for i:=low(tmp_array) to high(tmp_array) do
    if tmp_array[i]=0 then
      if s_tmp='' then s_tmp:=IntToStr(i) else s_tmp:=s_tmp+','+IntToStr(i);

  s9_missing_streets.Add(s_tmp);
end;


procedure S9RemoveFromStreets;
var i,j,k:integer;
    tmp_sl:TStringList;
    s_mov:string;
    s_to_delete:TALIntegerList;
begin
  s_mov:=IntToStr(s9_streets[s9_streets.Count-2])+'-'+IntToStr(s9_streets[s9_streets.Count-1]);
  tmp_sl:=TStringList.Create;
  s_to_delete:=TALIntegerList.Create;

  for i:=Low(s9_chart) to High(s9_chart) do
    if s9_chart[i,0]=s_mov then begin
      tmp_sl.Clear;
      MainForm.Split(',',s9_chart[i,1],tmp_sl);
      if tmp_sl.Count>0 then
        for j:=0 to tmp_sl.Count-1 do
          if tmp_sl[j]<>'12' then
            if s9_s.Count>0 then
              for k:=s9_s.Count-1 downto 0 do
                if s9_s[k]=StrToInt(tmp_sl[j]) then
                  s_to_delete.Add(s9_s[k]);

      Break;
    end;

    if s9_s.Count-s_to_delete.Count<Trunc(StrToInt(SysConfig.e_s9_reset.Text)) then begin
      s9_reset_session:=True;
    end else
      if s_to_delete.Count>0 then
        for j:=0 to s_to_delete.Count-1 do
          if s9_s.Count>0 then
            for k:=s9_s.Count-1 downto 0 do
              if s9_s[k]=s_to_delete[j] then
                s9_s.Delete(k);

  tmp_sl.Free;
  s_to_delete.Free;

end;


procedure S9AssignBets;
var i,j,k:integer;
    s_mov:string;
    tmp_sl,tmp_sl2:TStringList;
    ex,add:boolean;
    street:integer;
begin
  tmp_sl:=TStringList.Create;
  tmp_sl2:=TStringList.Create;
  s_mov:=IntToStr(s9_streets[s9_streets.Count-1])+'-';

  s9_s_to_bet.Clear;

  for i:=low(s9_chart) to high(s9_chart) do
    if AnsiStartsStr(s_mov,s9_chart[i,0]) then begin
      tmp_sl.Clear;
      tmp_sl2.Clear;
      MainForm.Split(',',s9_chart[i,1],tmp_sl);
      MainForm.Split(',',s9_missing_streets[s9_missing_streets.Count-1],tmp_sl2);
      if (tmp_sl.Count>0) and (tmp_sl2.Count>0) then begin
        add:=True;
        for j:=0 to tmp_sl.Count-1 do begin
          ex:=False;
          for k:=0 to tmp_sl2.Count-1 do
            if tmp_sl[j]=tmp_sl2[k] then
              //if (tmp_sl.Count>1) and (tmp_sl.Count>1) then
                ex:=True;
          if not ex then add:=False;
        end;

        if add then begin
          street:=StrToInt(StringReplace(s9_chart[i,0],s_mov,'',[rfReplaceAll]));
          if street<>12 then s9_s_to_bet.Add(street);
        end;

      end;
    end;

  tmp_sl.Free;
  tmp_sl2.Free;
end;


procedure S9MakeHistory;
var s_tmp:string;
    i:integer;
begin
  s_tmp:='';
  if s9_s.Count>0 then
    for i:=0 to s9_s.Count-1 do
      if s_tmp='' then s_tmp:=IntToStr(s9_s[i]) else s_tmp:=s_tmp+' '+IntToStr(s9_s[i]);
  s9_s_history.Add(s_tmp);


  s_tmp:='';
  if s9_s_to_bet.Count>0 then
    for i:=0 to s9_s_to_bet.Count-1 do
      if s_tmp='' then s_tmp:=IntToStr(s9_s_to_bet[i]) else s_tmp:=s_tmp+' '+IntToStr(s9_s_to_bet[i]);
  s9_s_to_bet_history.Add(s_tmp);

  
  s_tmp:='';
  if s9_s.Count>0 then begin
    if s9_s.Count<>12 then begin
      s_tmp:='('+IntToStr(s9_s.Count);
      if s9_lw[s9_lw.Count-1]='W' then s_tmp:=s_tmp+'*)' else s_tmp:=s_tmp+')';
    end;

    if s9_s.Count<=s9_lmsc then begin
      if s9_s_count_history.Count>0 then begin
        if s9_s_count_history[s9_s_count_history.Count-1]='' then s9_s_count_history.Add(s_tmp)
          else s9_s_count_history.Add(s9_s_count_history[s9_s_count_history.Count-1]+' '+s_tmp);
      end else s9_s_count_history.Add(s_tmp);
    end else s9_s_count_history.Add(s_tmp);

  end else s9_s_count_history.Add(s_tmp);

  s9_lmsc:=s9_s.Count;


  //debug
{  with debugform do begin
    if s9_s_history.Count>0 then
      label2.Caption:=s9_s_history[s9_s_history.Count-1] else label2.Caption:='';
    if s9_s_to_bet_history.Count>0 then
      label3.Caption:=s9_s_to_bet_history[s9_s_to_bet_history.Count-1] else label3.Caption:='';

  end;
  }
end;


procedure S9ToBet;
begin
  if (s9_s.Count<=Trunc(StrToInt(SysConfig.e_s9_reset.Text))) or (s9_reset_session) then
    if s9_lw.Count<=1 then
      S9ResetSession
    else if s9_lw.Count>1 then begin
      if s9_lw[s9_lw.Count-1]='L' then S9ResetSession;
    end;

  if numbers_list.Count>0 then
    if s9_streets.Count>1 then begin

      S9RemoveFromStreets;
      if numbers_list[numbers_list.Count-1]<>0 then begin
        S9AssignMissingStreets;
        S9AssignBets;
      end;

    end;

  S9MakeHistory;
end;


procedure S9Progression;
var j,max_units,min_profit,freeze:integer;
    tmp_sl:TStringList;
    tmp_s:string;
    i:integer;
    tmp_e:integer;
    units_count:integer;
begin
  units_count:=s9_units.Count;
  with SysConfig do begin
    //flat
    if cb_s9_flat.Checked then begin
      s9_units.Add(1);
    end else
    //insie
    if cb_s9_inside.Checked then begin
      max_units:=trunc(strtoint(e_s9_max_units.Text))+1;
      min_profit:=trunc(strtoint(e_s9_min_profit.Text));
      freeze:=trunc(strtoint(e_s9_freeze.Text));

      if s9_balance>=min_profit then s9_balance:=0;

      if (s9_s_to_bet.Count>0) then begin
        if (s9_loss<freeze) then begin
            for j:=1 to max_units do
              if (s9_balance+((12*j)-(j*s9_s_to_bet.Count))>=min_profit) or (j=max_units) then begin
                if j<max_units then begin
                  s9_units.Add(j);
                  Break;
                end else begin
                  if cb_s9_max.Checked then s9_units.Add(j-1);
                  if cb_s9_reset.Checked then begin
                    s9_balance:=0;
                    s9_units.Add(1);
                    s9_loss:=0;
                  end;
                end;
              end;
        end else
          if s9_units.Count>0 then s9_units.Add(s9_units[s9_units.Count-1]) else s9_units.Add(1);
      end else
        if s9_units.Count>0 then s9_units.Add(s9_units[s9_units.Count-1]) else s9_units.Add(1);
    end else
    //outside
    if cb_s9_outside.Checked then begin
      if s9_games_progression then begin
        s9_games_progression:=False;
        if s9_games_lw.Count>0 then begin

          tmp_sl:=TStringList.Create;
          if cb_s9_outside_1.Checked then begin
            MainForm.Split(',',e_s9_outside_1.Text,tmp_sl);
            if tmp_sl.Count>0 then
              for i:=0 to tmp_sl.Count-1 do begin
                if Length(tmp_sl[i])<=s9_games_lw.Count then begin
                  tmp_s:='';
                  for j:=Length(tmp_sl[i]) downto 1 do
                    tmp_s:=tmp_s+s9_games_lw[s9_games_lw.Count-j];
                  if tmp_sl[i]=tmp_s then begin
                    tmp_e:=s9_units[s9_units.Count-1]+Trunc(StrToInt(e_s9_outside_1_ammount.Text));
                    //max_units
                    if tmp_e>Trunc(StrToInt(SysConfig.e_s9_outside_max_units.Text)) then begin
                      if SysConfig.cb_s9_outside_reset.Checked then tmp_e:=1;
                      if SysConfig.cb_s9_outside_max.Checked then tmp_e:=s9_units[s9_units.Count-1];
                    end;
                    //freeze
                    if s9_games_loss=Trunc(StrToInt(SysConfig.e_s9_outside_freeze.Text)) then
                      tmp_e:=s9_units[s9_units.Count-1];
                    //<1 safety
                    if tmp_e<1 then tmp_e:=1;

                    s9_units.Add(tmp_e);
                    Break;
                  end;
                end;
              end;
          end;
          tmp_sl.Clear;
          if cb_s9_outside_2.Checked then begin
            MainForm.Split(',',e_s9_outside_2.Text,tmp_sl);
            if tmp_sl.Count>0 then
              for i:=0 to tmp_sl.Count-1 do begin
                if Length(tmp_sl[i])<=s9_games_lw.Count then begin
                  tmp_s:='';
                  for j:=Length(tmp_sl[i]) downto 1 do
                    tmp_s:=tmp_s+s9_games_lw[s9_games_lw.Count-j];
                  if tmp_sl[i]=tmp_s then begin
                    tmp_e:=s9_units[s9_units.Count-1]+Trunc(StrToInt(e_s9_outside_2_ammount.Text));
                    //max_units
                    if tmp_e>Trunc(StrToInt(SysConfig.e_s9_outside_max_units.Text)) then begin
                      if SysConfig.cb_s9_outside_reset.Checked then tmp_e:=1;
                      if SysConfig.cb_s9_outside_max.Checked then tmp_e:=s9_units[s9_units.Count-1];
                    end;
                    //freeze
                    if s9_games_loss=Trunc(StrToInt(SysConfig.e_s9_outside_freeze.Text)) then
                      tmp_e:=s9_units[s9_units.Count-1];
                    //<1 safety
                    if tmp_e<1 then tmp_e:=1;

                    s9_units.Add(tmp_e);
                    Break;
                  end;
                end;
              end;
          end;
          tmp_sl.Free;

        end;
      end;
    end;

  end;

  if s9_units.Count<=units_count then
    if s9_units.Count>0 then s9_units.Add(s9_units[s9_units.Count-1]) else s9_units.Add(1);

end;


procedure S9Init;
begin
  s9_to_bet:=TStringList.Create;
  s9_lw:=TStringList.Create;
  s9_s:=TALIntegerList.Create;
  s9_s_to_bet:=TALIntegerList.Create;
  s9_streets:=TALIntegerList.Create;
  s9_profit:=TALIntegerList.Create;
  s9_units:=TALIntegerList.Create;
  s9_missing_streets:=TStringList.Create;

  s9_games_lw:=TStringList.Create;

  s9_s_history:=TStringList.Create;
  s9_s_count_history:=TStringList.Create;
  s9_s_to_bet_history:=TStringList.Create;
end;


procedure S9Free;
begin
  s9_to_bet.Free;
  s9_lw.Free;
  s9_s.Free;
  s9_s_to_bet.Free;
  s9_streets.Free;
  s9_profit.Free;
  s9_units.Free;
  s9_missing_streets.Free;

  s9_games_lw.Free;

  s9_s_history.Free;
  s9_s_count_history.Free;
  s9_s_to_bet_history.Free;
end;


procedure S9Reset;
begin
  s9_to_bet.Clear;
  s9_lw.Clear;
  s9_s.Clear;
  s9_s_to_bet.Clear;
  s9_streets.Clear;
  s9_profit.Clear;
  s9_units.Clear;
  s9_missing_streets.clear;
  s9_reset_session:=False;

  s9_games_lw.clear;
  s9_games_loss:=0;
  s9_games_balance:=0;
  s9_games_progression:=False;

  s9_loss:=0;
  s9_balance:=0;
  s9_lmsc:=12;

  s9_s_history.clear;
  s9_s_count_history.clear;
  s9_s_to_bet_history.clear;
end;


end.
