unit table_form;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleCtrls, ExtCtrls, Buttons, ALPanel, Registry,
  main_form, bot_form, MSHTML, SHDocVw_EWB, EwbCore, EmbeddedWB, sql_form;

type
  TTableForm = class(TForm)
    box_main: TALPanel;
    box_wb: TALPanel;
    bClose: TSpeedButton;
    messageTIMER: TTimer;
    wb: TEmbeddedWB;
    procedure wbNavigateComplete2(Sender: TObject; const pDisp: IDispatch;
      var URL: OleVariant);
    procedure box_mainMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure bCloseClick(Sender: TObject);
    procedure wbDocumentComplete(Sender: TObject; const pDisp: IDispatch;
      var URL: OleVariant);
    procedure wbCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure messageTIMERTimer(Sender: TObject);
  private
    procedure WMNCHitTest(var Msg: TWMNCHitTest) ; message WM_NCHitTest;
    procedure SaveSettings;
    procedure LoadSettings;
    procedure ClearBorder(Sender:TObject);
    procedure WB_SetBorderStyle(Sender: TObject; BorderStyle: String);
    procedure WB_Set3DBorderStyle(Sender: TObject; bValue: Boolean);
  public
    procedure AdjSize;
    procedure CloseCasino;
  end;

var
  TableForm: TTableForm;


implementation

uses config_form;
{$R *.dfm}


procedure TTableForm.bCloseClick(Sender: TObject);
var q:integer;
begin
  if REAL_Balance<>0 then begin
    q:=MessageDlg('Do you want to close this session?',mtConfirmation,[mbYes,mbCancel], 0);
    if q=6 then CloseCasino;
  end else CloseCasino;
end;


procedure TTableForm.CloseCasino;
begin
  messageTIMER.Enabled:=False;
  bClose.Enabled:=False;

  try
    if BotForm.ReadNumber<>'' then begin
      BotForm.Bet('close',SoftwareDELAY,1);
      repeat
        sleep(50);
        Application.ProcessMessages;
      until (not wb.Busy);
    end else begin
      wb.Navigate('about:blank');
      repeat
        sleep(50);
        Application.ProcessMessages;
      until (not wb.Busy);

      CasinoHANDLE:=0;
      SqlForm.SendStats;
      MainForm.SystemReset;

      ConfigForm.GameModeState(True);
      TABLE_status:='off';
      Self.Free;
    end;
  except
    MainForm.RepError('BOOM! Smth went wrong when closing table! [TF-001]');
  end;

end;


procedure TTableForm.wbCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose:=False;
  CloseCasino;
end;


procedure TTableForm.ClearBorder(Sender: TObject);
begin
  try
    WB_Set3DBorderStyle(Sender, False);
    WB_SetBorderStyle(Sender, 'none');
  except
    MainForm.RepError('Error code: TF-003');
  end;
end;


procedure TTableForm.WB_SetBorderStyle(Sender: TObject; BorderStyle: String);
var
  Document : IHTMLDocument2;
  Element : IHTMLElement;
begin
  try
    Document := TEmbeddedWB(Sender).Document as IHTMLDocument2;
    if Assigned(Document) then begin
      Element := Document.Body;
      if Element <> nil then begin
        Element.Style.BorderStyle := BorderStyle;
      end;
    end;
  except
    MainForm.RepError('Error code: TF-004');
  end;
end;


procedure TTableForm.WB_Set3DBorderStyle(Sender: TObject; bValue: Boolean);
var
  Document : IHTMLDocument2;
  Element : IHTMLElement;
  StrBorderStyle: string;
begin
  try
    Document := TEmbeddedWB(Sender).Document as IHTMLDocument2;
    if Assigned(Document) then begin
      Element := Document.Body;
      if Element <> nil then begin
        case BValue of
          False: StrBorderStyle := 'none';
          True : StrBorderStyle := '';
        end;
        Element.Style.BorderStyle := StrBorderStyle;
      end;
    end;
  except
    MainForm.RepError('Error code: TF-005');
  end;
end;


procedure TTableForm.AdjSize;
var frame_y,frame_x:integer;
begin
  try
    frame_x:=2;
    frame_y:=2;

    box_wb.Left:=frame_y;
    box_wb.Top:=frame_x;
    box_wb.AutoSize:=True;

    box_main.AutoSize:=True;
    box_main.AutoSize:=False;
    box_main.Width:=frame_x+box_wb.Width+frame_x+bClose.Width+frame_x;
    box_main.Height:=frame_y+box_wb.height+frame_y;

    bClose.Left:=box_main.Width-bClose.Width-frame_x;
    bClose.Top:=box_main.Height-bClose.Height-frame_y;

    AutoSize:=True;
  except
    MainForm.RepError('Error code: TF-006');
  end;
end;


procedure TTableForm.wbNavigateComplete2(Sender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
begin
  try
    ClearBorder(Sender);
    AdjSize;
  except
    MainForm.RepError('Error code: TF-007');
  end;
end;


procedure TTableForm.WMNCHitTest(var Msg: TWMNCHitTest) ;
begin
  inherited;
  if Msg.Result = htClient then Msg.Result := htCaption;
end;


procedure TTableForm.box_mainMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  SendMessage(Handle, WM_SYSCOMMAND, 61458, 0) ;
end;


procedure TTableForm.LoadSettings;
var reg:TRegistry;
begin
  try
   reg:=TRegistry.Create(KEY_READ OR $0100);
   with reg do begin
    try
      reg.RootKey := HKEY_LOCAL_MACHINE;
      if reg.OpenKey('SOFTWARE\Ophis\'+system_code+'\casino', TRUE) then begin
        if reg.ReadString('top')<>'' then Self.Top:=StrToInt(reg.ReadString('top'))
        else Top:=10;
        if reg.ReadString('left')<>'' then Self.Left:=StrToInt(reg.ReadString('left'))
        else Left:=10;
      end;
      reg.CloseKey
    finally
      reg.Free;
    end;
  end;
  except
    MainForm.RepError('Error code: TF-008');
  end;
end;


procedure TTableForm.SaveSettings;
var reg:TRegistry;
begin
  try
   reg:=TRegistry.Create(KEY_WRITE OR $0100);
   with reg do begin
    try
      reg.RootKey := HKEY_LOCAL_MACHINE;
      if reg.OpenKey('SOFTWARE\Ophis\'+system_code+'\casino', TRUE) then begin
        reg.WriteString('top',IntToStr(Top));
        reg.WriteString('left',IntToStr(Left));
      end;
      reg.CloseKey;
    finally
      reg.Free;
    end;
  end;
  except
    MainForm.RepError('Error code: TF-009');
  end;
end;


procedure TTableForm.wbDocumentComplete(Sender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
begin
  try
    ClearBorder(Sender);
  except
    MainForm.RepError('Error code: TF-010');
  end;
end;



procedure TTableForm.FormDestroy(Sender: TObject);
begin
  try
    if Caption='RNGX Casino' then SaveSettings;
  except
    MainForm.RepError('Error code: TF-011');
  end;
end;


procedure TTableForm.FormCreate(Sender: TObject);
begin
  try
    LoadSettings;
  except
    MainForm.RepError('Error code: TF-012');
  end;
end;


procedure TTableForm.messageTIMERTimer(Sender: TObject);
var m_tmp:string;
begin
  try
    if (TABLE_status='on') and (Caption='RNGX Casino') then begin
      m_tmp:=BotForm.ReadMessage;

      if (m_tmp='table_limit') or (m_tmp='cant_connect') then
        BotForm.Bet('ok',SoftwareDELAY,1);
    end;
  except
    MainForm.RepError('OMFG! Message timer is broken! [TF-013]');
  end;
end;


end.
